// 系统加载配置
'use strict';
//本地化设置
angular.module("ngLocale", [], ["$provide", function ($provide) {
    var PLURAL_CATEGORY = {ZERO: "zero", ONE: "one", TWO: "two", FEW: "few", MANY: "many", OTHER: "other"};
    $provide.value("$locale", {
        "DATETIME_FORMATS": {
            "AMPMS": [
                "\u4e0a\u5348",
                "\u4e0b\u5348"
            ],
            "DAY": [
                "\u661f\u671f\u65e5",
                "\u661f\u671f\u4e00",
                "\u661f\u671f\u4e8c",
                "\u661f\u671f\u4e09",
                "\u661f\u671f\u56db",
                "\u661f\u671f\u4e94",
                "\u661f\u671f\u516d"
            ],
            "ERANAMES": [
                "\u516c\u5143\u524d",
                "\u516c\u5143"
            ],
            "ERAS": [
                "\u516c\u5143\u524d",
                "\u516c\u5143"
            ],
            "FIRSTDAYOFWEEK": 6,
            "MONTH": [
                "\u4e00\u6708",
                "\u4e8c\u6708",
                "\u4e09\u6708",
                "\u56db\u6708",
                "\u4e94\u6708",
                "\u516d\u6708",
                "\u4e03\u6708",
                "\u516b\u6708",
                "\u4e5d\u6708",
                "\u5341\u6708",
                "\u5341\u4e00\u6708",
                "\u5341\u4e8c\u6708"
            ],
            "SHORTDAY": [
                "\u5468\u65e5",
                "\u5468\u4e00",
                "\u5468\u4e8c",
                "\u5468\u4e09",
                "\u5468\u56db",
                "\u5468\u4e94",
                "\u5468\u516d"
            ],
            "SHORTMONTH": [
                "1\u6708",
                "2\u6708",
                "3\u6708",
                "4\u6708",
                "5\u6708",
                "6\u6708",
                "7\u6708",
                "8\u6708",
                "9\u6708",
                "10\u6708",
                "11\u6708",
                "12\u6708"
            ],
            "WEEKENDRANGE": [
                5,
                6
            ],
            "fullDate": "y\u5e74M\u6708d\u65e5EEEE",
            "longDate": "y\u5e74M\u6708d\u65e5",
            "medium": "y\u5e74M\u6708d\u65e5 ah:mm:ss",
            "mediumDate": "y\u5e74M\u6708d\u65e5",
            "mediumTime": "ah:mm:ss",
            "short": "yy/M/d ah:mm",
            "shortDate": "yy/M/d",
            "shortTime": "ah:mm"
        },
        "NUMBER_FORMATS": {
            "CURRENCY_SYM": "\u00a5",
            "DECIMAL_SEP": ".",
            "GROUP_SEP": ",",
            "PATTERNS": [
                {
                    "gSize": 3,
                    "lgSize": 3,
                    "maxFrac": 3,
                    "minFrac": 0,
                    "minInt": 1,
                    "negPre": "-",
                    "negSuf": "",
                    "posPre": "",
                    "posSuf": ""
                },
                {
                    "gSize": 3,
                    "lgSize": 3,
                    "maxFrac": 2,
                    "minFrac": 2,
                    "minInt": 1,
                    "negPre": "-\u00a4\u00a0",
                    "negSuf": "",
                    "posPre": "\u00a4\u00a0",
                    "posSuf": ""
                }
            ]
        },
        "id": "zh-cn",
        "pluralCat": function (n, opt_precision) {
            return PLURAL_CATEGORY.OTHER;
        }
    });
}]);
//app设置
var app =
    angular.module('app')
        .config(
            ['$controllerProvider', '$compileProvider', '$filterProvider', '$provide',
                function ($controllerProvider, $compileProvider, $filterProvider, $provide) {

                    // lazy controller, directive and service
                    app.controller = $controllerProvider.register;
                    app.directive = $compileProvider.directive;
                    app.filter = $filterProvider.register;
                    app.factory = $provide.factory;
                    app.service = $provide.service;
                    app.constant = $provide.constant;
                    app.value = $provide.value;
                }
            ])
        .config(function ($httpProvider) {
            // Use x-www-form-urlencoded Content-Type
            $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
            // $httpProvider.defaults.timeout = 3000;
            /**
             * The workhorse; converts an object to x-www-form-urlencoded serialization.
             * @param {Object} obj
             * @return {String}
             */
            var param = function (obj) {
                var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
                for (name in obj) {
                    value = obj[name];
                    if (value instanceof Array) {
                        for (i = 0; i < value.length; ++i) {
                            subValue = value[i];
                            fullSubName = name + '[' + i + ']';
                            innerObj = {};
                            innerObj[fullSubName] = subValue;
                            query += param(innerObj) + '&';
                        }
                    } else if (value instanceof Object) {
                        for (subName in value) {
                            subValue = value[subName];
                            fullSubName = name + '.' + subName + '';
                            innerObj = {};
                            innerObj[fullSubName] = subValue;
                            query += param(innerObj) + '&';
                        }
                    } else if (value !== undefined && value !== null)
                        query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
                }

                return query.length ? query.substr(0, query.length - 1) : query;
            };

            // Override $http service's default transformRequest
            $httpProvider.defaults.transformRequest = [function (data) {
                return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
            }];
            $httpProvider.interceptors.push('loadingInterceptor');
        })
        .factory('loadingInterceptor', function ($q, $rootScope, $timeout) {


            return {
                request: function (config) {
                    //$(".back-layer").show();
                    var romoteUrl = $rootScope.remoteUrl || $rootScope.canteenYunUrl;//"http://192.168.1.25/";
                    var isApp = $rootScope.isApp;
                    //config.timeout = 3000;
                    if (config && config.url && config.url.indexOf(".action") > -1 && isApp && romoteUrl && config.url.indexOf("http") <= -1) {
                        config.url = romoteUrl + config.url;
                    }
                    if (config && config.url && config.url.indexOf(".action") > -1) {
                        if ($rootScope.getLoginUser) {
                            var user = $rootScope.getLoginUser();
                            if (user && user.userId) {
                                config.headers.mkbUserId = user.userId;
                            }
                        }
                    }
                    $rootScope.canShowLoading = true;
                    // $rootScope.showLoading = true;
                    $timeout(function () {
                        if ($rootScope.canShowLoading) {
                            $rootScope.showLoading = true;
                        }
                    }, 2000);

                    return config || $q.when(config);
                },
                response: function (response) {
                    // $(".back-layer").hide();
                    //监听未登陆状态
                    if (response.config && response.config.url && response.config.url.indexOf(".action") > -1) {
                        if (response.data && response.data.errType == 'unlogin') {
                            $rootScope.$emit("unloginIntercepted", "notLogin", response);
                        }
                    }
                    $rootScope.showLoading = false;
                    $rootScope.canShowLoading = false;


                    return response || $q.when(response);
                },
                responseError: function (rejection) {
                    $rootScope.showLoading = false;
                    $rootScope.canShowLoading = false;
                    // $(".back-layer").hide();
                    if (rejection.config && rejection.config.url && rejection.config.url.indexOf(".action") > -1) {
                        //	alert("服务器连接错误");
                    }
                    return $q.reject(rejection);
                }
            };
        });
/**
 * 系统缓存
 * 使用app.caches._cachesData对象，localStorage和sessionStorage三种方式存储
 * */
app.caches = {
    /**
     * @params k key
     * @params v value
     * @params persistence default:undefined
     *  可接受：-1: 使用ones.caches.cacheData 刷新/关闭清除
     *         1  使用localStorage
     *         0 使用sessionStorage 当前页面生命周期，关闭页面清除
     * @param toJson 是否存储为JSON字符串，用于对象存储
     * */
    setItem: function (k, v, persistence, toJson) {

        if (angular.isObject(v) || angular.isArray(v)) {
            toJson = true;
        }

        if (undefined == persistence) {
            persistence = 0;
        }

        switch (persistence) {
            case -1:
                app.caches._cachesData[k] = v;
                break;
            case 1:
                if (toJson) {
                    v = angular.toJson(v);
                }
                localStorage.setItem(k, v);
                break;
            case 0:
                if (toJson) {
                    v = angular.toJson(v);
                }
                sessionStorage.setItem(k, v);
                break;
        }
        return v;
    },
    getItem: function (k) {
        var v = app.caches._cachesData[k];

        if (undefined == v) {
            v = sessionStorage.getItem(k);
        }

        if (null == v) {
            v = localStorage.getItem(k);
        }

        try {
            v = angular.fromJson(v);
        } catch (e) {
        }

        return v;

    },
    removeItem: function (k) {
        delete (app.caches._cachesData[k]);
        sessionStorage.removeItem(k);
        localStorage.removeItem(k);
    },
    clear: function (level) {
        switch (level) {
            case -1:
                app.caches._cachesData = {};
                break;
            case 0:
                sessionStorage.clear();
                break;
            case 1:
                localStorage.clear();
                break;
            default:
                localStorage.clear();
                sessionStorage.clear();
                app.caches._cachesData = {};
        }
    },
    _cachesData: {}
};
/**
 * 通用弹窗控件
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} items
 * @returns {}
 */
app.controller('CommonModalInstanceCtrl', ['$scope', '$rootScope', '$modalInstance', 'modal', function ($scope, $rootScope, $modalInstance, modal) {
    $scope.modal = {};
    $scope.modal = modal;
    $scope.ok = function () {
        $rootScope.commonDialogOpen = false;
        $modalInstance.close($scope.modal);
    };
    $scope.cancel = function () {
        $rootScope.commonDialogOpen = false;
        $modalInstance.dismiss('cancel');
    };
}]);
/**
 * 格式化日期时间
 **/
Date.prototype.format = function (formatStr) {
    var str = formatStr;
    var Week = ['周日', '周一', '周二', '周三', '周四', '周五', '周六'];

    str = str.replace(/yyyy|YYYY/, this.getFullYear());
    str = str.replace(/yy|YY/, (this.getYear() % 100) > 9 ? (this.getYear() % 100).toString() : '0' + (this.getYear() % 100));

    str = str.replace(/MM/, (this.getMonth() + 1) > 9 ? (this.getMonth() + 1).toString() : '0' + (this.getMonth() + 1));
    str = str.replace(/M/g, this.getMonth() + 1);

    str = str.replace(/w|W/g, Week[this.getDay()]);

    str = str.replace(/dd|DD/, this.getDate() > 9 ? this.getDate().toString() : '0' + this.getDate());
    str = str.replace(/d|D/g, this.getDate());

    str = str.replace(/hh|HH/, this.getHours() > 9 ? this.getHours().toString() : '0' + this.getHours());
    str = str.replace(/h|H/g, this.getHours());
    str = str.replace(/mm/, this.getMinutes() > 9 ? this.getMinutes().toString() : '0' + this.getMinutes());
    str = str.replace(/m/g, this.getMinutes());

    str = str.replace(/ss|SS/, this.getSeconds() > 9 ? this.getSeconds().toString() : '0' + this.getSeconds());
    str = str.replace(/s|S/g, this.getSeconds());

    return str;
}
