// lazyload config

angular.module('app')
    /**
     * jQuery plugin config use ui-jq directive , config the js and css files that required
     * key: function name of the jQuery plugin
     * value: array of the css js file located
     */
    .constant('JQ_CONFIG', {
            easyPieChart: ['vendor/jquery/charts/easypiechart/jquery.easy-pie-chart.js'],
            sparkline: ['vendor/jquery/charts/sparkline/jquery.sparkline.min.js'],
            plot: ['vendor/jquery/charts/flot/jquery.flot.min.js',
                'vendor/jquery/charts/flot/jquery.flot.resize.js',
                'vendor/jquery/charts/flot/jquery.flot.tooltip.min.js',
                'vendor/jquery/charts/flot/jquery.flot.spline.js',
                'vendor/jquery/charts/flot/jquery.flot.orderBars.js',
                'vendor/jquery/charts/flot/jquery.flot.pie.min.js'],
            slimScroll: ['vendor/jquery/slimscroll/jquery.slimscroll.min.js'],
            sortable: ['vendor/jquery/sortable/jquery.sortable.js'],
            nestable: ['vendor/jquery/nestable/jquery.nestable.js',
                'vendor/jquery/nestable/nestable.css'],
            filestyle: ['vendor/jquery/file/bootstrap-filestyle.min.js'],
            slider: ['vendor/jquery/slider/bootstrap-slider.js',
                'vendor/jquery/slider/slider.css'],
            chosen: ['vendor/jquery/chosen/chosen.jquery.min.js',
                'vendor/jquery/chosen/chosen.css'],
            TouchSpin: ['vendor/jquery/spinner/jquery.bootstrap-touchspin.min.js',
                'vendor/jquery/spinner/jquery.bootstrap-touchspin.css'],
            wysiwyg: ['vendor/jquery/wysiwyg/bootstrap-wysiwyg.js',
                'vendor/jquery/wysiwyg/jquery.hotkeys.js'],
            dataTable: ['vendor/jquery/datatables/jquery.dataTables.min.js',
                'vendor/jquery/datatables/dataTables.bootstrap.js',
                'vendor/jquery/datatables/dataTables.bootstrap.css'],
            vectorMap: ['vendor/jquery/jvectormap/jquery-jvectormap.min.js',
                'vendor/jquery/jvectormap/jquery-jvectormap-world-mill-en.js',
                'vendor/jquery/jvectormap/jquery-jvectormap-us-aea-en.js',
                'vendor/jquery/jvectormap/jquery-jvectormap.css'],
            footable: ['vendor/jquery/footable/footable.all.min.js',
                'vendor/jquery/footable/footable.core.css']
        }
    )
    // oclazyload config
    .config(['$ocLazyLoadProvider', function ($ocLazyLoadProvider) {
        // We configure ocLazyLoad to use the lib script.js as the async loader
        $ocLazyLoadProvider.config({
            debug: true,
            events: true,
            modules: [
                {
                    //日期控件
                    name: 'dateTimePicker',
                    files: [
                        'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js',
                        'vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                        'vendor/jquery/dateTimePicker/mobiscroll.css'
                    ]
                }, {
                    name: 'ngGrid',
                    files: [
                        'vendor/modules/ng-grid/ng-grid.min.js',
                        'vendor/modules/ng-grid/ng-grid.min.css',
                        'vendor/modules/ng-grid/theme.css'
                    ]
                }
                ,
                {
                    name: 'ui.select',
                    files: [
                        'vendor/modules/angular-ui-select/select.min.js',
                        'vendor/modules/angular-ui-select/select.min.css'
                    ]
                },
                {
                    name: 'angularFileUpload',
                    files: [
                        'vendor/modules/angular-file-upload/angular-file-upload.min.js'
                    ]
                },
                {
                    name: 'ui.calendar',
                    files: ['vendor/modules/angular-ui-calendar/calendar.js']
                },
                {
                    name: 'ngImgCrop',
                    files: [
                        'vendor/modules/ngImgCrop/ng-img-crop.js',
                        'vendor/modules/ngImgCrop/ng-img-crop.css'
                    ]
                },
                {
                    name: 'angularBootstrapNavTree',
                    files: [
                        'vendor/modules/angular-bootstrap-nav-tree/abn_tree_directive.js',
                        'vendor/modules/angular-bootstrap-nav-tree/abn_tree.css'
                    ]
                },
                {
                    name: 'toaster',
                    files: [
                        'vendor/modules/angularjs-toaster/toaster.js',
                        'vendor/modules/angularjs-toaster/toaster.css'
                    ]
                },
                {
                    name: 'textAngular',
                    files: [
                        'vendor/modules/textAngular/textAngular-sanitize.min.js',
                        'vendor/modules/textAngular/textAngular.min.js'
                    ]
                },
                {
                    name: 'vr.directives.slider',
                    files: [
                        'vendor/modules/angular-slider/angular-slider.min.js',
                        'vendor/modules/angular-slider/angular-slider.css'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular',
                    files: [
                        'vendor/modules/videogular/videogular.min.js'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular.plugins.controls',
                    files: [
                        'vendor/modules/videogular/plugins/controls.min.js'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular.plugins.buffering',
                    files: [
                        'vendor/modules/videogular/plugins/buffering.min.js'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular.plugins.overlayplay',
                    files: [
                        'vendor/modules/videogular/plugins/overlay-play.min.js'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular.plugins.poster',
                    files: [
                        'vendor/modules/videogular/plugins/poster.min.js'
                    ]
                },
                {
                    name: 'com.2fdevs.videogular.plugins.imaads',
                    files: [
                        'vendor/modules/videogular/plugins/ima-ads.min.js'
                    ]
                }
            ]
        });
    }])
;