'use strict';

/**
 * 系统路由配置  ui-rooter
 */
angular.module('app')
    .run(
        ['$rootScope', '$state', '$stateParams', '$templateCache',
            function ($rootScope, $state, $stateParams, $templateCache) {
                $rootScope.$state = $state;
                $rootScope.$stateParams = $stateParams;
                $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
                    if (toState.templateUrl !== undefined) {
                        var url = toState.templateUrl;
                        if (url.indexOf('?') < 0) {
                            url = url + '?_rt=' + appVersion;
                        }
                        toState.templateUrl = url;
                    }
                    if (toState.name.indexOf('login') > -1) {
                        //	// 如果是进入登录界面则允许
//					if(!$rootScope.loginUser){
//						$rootScope.loginUser = app.caches.getItem("loginUserFront");
//					}
//					 console.log($rootScope.loginUser);
//					if(toState.name == 'login.userLogin' &&  $rootScope.loginUser){
//							event.preventDefault();// 取消默认跳转行为
//							 console.log("gomain");
//							$state.go("app.main");//跳转到页面
//					}
                        return;
                    }
                    // 如果用户不存在
                    if (!$rootScope.loginUser && !app.caches.getItem("loginUserFront")) {
                        $rootScope.reloadCurrenUserInfo(true).then(function (data) {
                            if (!data) {
                                event.preventDefault();// 取消默认跳转行为
                                $state.go("login.userLogin", {authError: '未登陆或登陆超时'});//跳转到登录界面
                            }
                        });
                    }
                    /**是否展示侧滑导航**/
                    $rootScope.showLeftNav = false;
                });
            }
        ]
    )
    .config(
        ['$stateProvider', '$urlRouterProvider',
            function ($stateProvider, $urlRouterProvider) {

                $urlRouterProvider
                    //          	  .otherwise('/app/main');
                    .otherwise('/login/userLogin');
                $stateProvider
                    //登陆
                    .state('login', {
                        url: '/login',
                        template: '<div ui-view class="fade-in-right-big smooth"></div>'
                    })
                    //前台登陆
                    .state('login.userLogin', {
                        url: '/userLogin?authError&from&erCode',
                        controller: 'UserLoginCtrl',
                        templateUrl: 'tpl/userLogin.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/UserLoginCtrl.js',
                                        'css/login.css']);
                                }]
                        }
                    })//组织机构登陆
                    .state('login.orgLogin', {
                        url: '/orgLogin?authError&from&rid',
                        controller: 'OrgLoginCtrl',
                        templateUrl: 'tpl/orgLogin.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/OrgLoginCtrl.js']);
                                }]
                        }
                    })//电子菜谱
                    .state('login.dianzicaipu', {
                        url: '/dianzicaipu',
                        controller: 'DianzicaipuCtrl',
                        templateUrl: 'tpl/dianzicaipu.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/DianzicaipuCtrl.js']);
                                }]
                        }
                    })
                    //前台微信绑定
                    .state('login.bindUser', {
                        url: '/bindUser?authError&from&erCode&openId&type',
                        controller: 'UserBindCtrl',
                        templateUrl: 'tpl/bindUser.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/UserBindCtrl.js',
                                        'css/login.css']);
                                }]
                        }
                    })
                    //前台注册
                    .state('login.userRegister', {
                        url: '/userRegister?authError&from&erCode&openId&type',
                        controller: 'UserRegisterCtrl',
                        templateUrl: 'tpl/userRegister.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/UserRegisterCtrl.js']);
                                }]
                        }
                    })

                    //前台忘记密码功能
                    .state('login.userForgetPwd', {
                        url: '/userForgetPwd?authError&from&erCode&openId&type',
                        controller: 'UserForgetPwdCtrl',
                        templateUrl: 'tpl/userForgetPwd.html',
                        resolve: {
                            deps: ['uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(['js/controllers/UserForgetPwdCtrl.js']);
                                }]
                        }
                    })


                    //系统通用配置
                    .state('app', {
                        abstract: true,
                        url: '/app',
                        templateUrl: 'tpl/app.html'
                    })
                    //用户首页
                    .state('app.user', {
                        url: '/user',
                        controller: 'UserCtrl',
                        templateUrl: 'tpl/user.html',
                        resolve: {
                            deps: ['$ocLazyLoad',
                                function ($ocLazyLoad) {
                                    return $ocLazyLoad.load('js/controllers/UserCtrl.js');
                                }
                            ]
                        }
                    })
                    //用户信息
                    .state('app.userInfo', {
                        url: '/userInfo',
                        controller: 'UserInfoCtrl',
                        templateUrl: 'tpl/userInfo.html',
                        resolve: {
                            deps: ['$ocLazyLoad',
                                function ($ocLazyLoad) {
                                    return $ocLazyLoad.load(['vendor/libs/exif.js', 'js/controllers/UserInfoCtrl.js']);
                                }
                            ]
                        }
                    })

                    //登录后
                    .state('app.canteenList', {
                        url: '/canteenList',
                        controller: 'CanteenListCtrl',
                        templateUrl: 'tpl/canteenList.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/owl.carousel.js',
                                            'vendor/jquery/jquery.SuperSlide.2.1.1.js',
                                            'css/index.css']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/CanteenListCtrl.js');
                                        }
                                    )
                                }]
                        }
                    })
                    //登录后主页
                    .state('app.main', {
                        url: '/main?id&type&from',
                        controller: 'MainCtrl',
                        templateUrl: 'tpl/main.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['css/index.css',
                                            'vendor/jquery/jquery.SuperSlide.2.1.1.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js'

                                            , 'vendor/jquery/seatCharts/css/jq22.css'
                                            , 'vendor/jquery/seatCharts/jquery.seat-charts.min.js'
                                        ]
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/MainCtrl.js');
                                        }
                                    )
                                }]
                        }
                    })
                    //批量预订
                    .state('app.yudingBatch', {
                        url: '/yudingBatch',
                        controller: 'YudingBatchCtrl',
                        templateUrl: 'tpl/yudingBatch.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/YudingBatchCtrl.js');
                                        }
                                    )
                                }]
                        }
                    })
                    //点菜页面
                    .state('app.foodList', {
                        url: '/foodList?cookBookId&canbieDate',
                        controller: 'FoodListCtrl',
                        templateUrl: 'tpl/foodList.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/libs/swiper.min.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/foodListCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //订单页面
                    .state('app.myBillList', {
                        url: '/myBillList?billId&currentState',
                        controller: 'MyBillListCtrl',
                        templateUrl: 'tpl/myBillList.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js',
                                            'css/index.css',
                                            'vendor/libs/jweixin-1.0.0.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/MyBillListCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //消息页面
                    .state('app.myMessage', {
                        url: '/myMessage?flag',
                        controller: 'MyMessageCtrl',
                        templateUrl: 'tpl/myMessage.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/myMessageCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //消息页面
                    .state('app.cameraView', {
                        url: '/cameraView',
                        controller: 'CameraViewCtrl',
                        templateUrl: 'tpl/cameraView.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/CameraViewCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //移动
                    .state('app.cameraMobileView', {
                        url: '/cameraMobileView',
                        controller: 'CameraMobileViewCtrl',
                        templateUrl: 'tpl/cameraMobileView.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js', 'vendor/jquery/qrcode/ezuikit.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/CameraMobileViewCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //投票页面
                    .state('app.toupiao', {
                        url: '/toupiao',
                        controller: 'ToupiaoCtrl',
                        templateUrl: 'tpl/toupiao.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/ToupiaoCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })

                    //我的饭卡
                    .state('app.myCard', {
                        url: '/myCard',
                        controller: 'myCardCtrl',
                        templateUrl: 'tpl/myCard.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/dateTimePicker/mobiscroll.core-2.5.2.js',
                                            'vendor/jquery/dateTimePicker/mobiscroll.datetime-2.5.1.js', 'js/qrcode.js',
                                            'vendor/jquery/qrcode/jquery.qrcode.min.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/MyCardCtrl.js');
                                        }
                                    )
                                }]
                        }
                    })
                    //我的抢单
                    .state('app.takeoutBill', {
                        url: '/takeoutBill',
                        controller: 'takeoutBillCtrl',
                        templateUrl: 'tpl/takeoutBill.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(
                                        ['js/controllers/takeoutBillCtrl.js']
                                    )
                                }]
                        }
                    })//我的订单
                    .state('app.takeout', {
                        url: '/takeout',
                        controller: 'takeoutCtrl',
                        templateUrl: 'tpl/takeout.html',
                        resolve: {
                            deps: ['$ocLazyLoad',
                                function ($ocLazyLoad) {
                                    return $ocLazyLoad.load('js/controllers/takeoutCtrl.js');
                                }
                            ]
                        }

                    })//我的结算
                    .state('app.balance', {
                        url: '/balance',
                        controller: 'balanceCtrl',
                        templateUrl: 'tpl/balance.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function (uiLoad) {
                                    return uiLoad.load(
                                        ['js/controllers/balanceCtrl.js']
                                    )
                                }]
                        }
                    })
                    //营养生活页面
                    .state('app.yingyang', {
                        url: '/yingyang',
                        controller: 'yingyangCtrl',
                        templateUrl: 'tpl/myNutrition.html',
                        resolve: {
                            deps: ['$ocLazyLoad', 'uiLoad',
                                function ($ocLazyLoad, uiLoad) {
                                    return uiLoad.load(
                                        ['vendor/jquery/qrcode/jquery.qrcode.min.js']
                                    ).then(
                                        function () {
                                            return uiLoad.load('js/controllers/yingyangCtrl.js');
                                        }
                                    )
                                }]
                        }

                    })
                    //用户地址
                    .state('app.address', {
                        url: '/address',
                        controller: 'AddressCtrl',
                        templateUrl: 'tpl/address.html',
                        resolve: {
                            deps: ['$ocLazyLoad',
                                function ($ocLazyLoad) {
                                    return $ocLazyLoad.load('js/controllers/AddressCtrl.js');
                                }
                            ]
                        }
                    })
                    //修改自定义地址
                    .state('app.addressEdit', {
                        url: '/addressEdit',
                        controller: 'AddressEditCtrl',
                        templateUrl: 'tpl/addressEdit.html',
                        resolve: {
                            deps: ['$ocLazyLoad',
                                function ($ocLazyLoad) {
                                    return $ocLazyLoad.load('js/controllers/AddressEditCtrl.js');
                                }
                            ]
                        }
                    })
            }
        ]
    );