/**
 * 用户地址编辑页面
 */
app.controller('AddressEditCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    //菜单状态
    $rootScope.showMenu = false;
    //地址信息
    $scope.user = app.caches.getItem("mkb_user_address") || {};
    app.caches.removeItem("mkb_user_address");
    $scope.xiaoquList = [];
    $scope.selectedXiaoqu = {};
    $scope.addressDetail = $scope.user.customAddress;
    $scope.address = $scope.user.addressLevel;
    $scope.louList = [];
    $scope.selectedLou = {};
    $scope.showSelectWinFlag = false;
    //选择框
    $scope.showSelectWin = function () {
        $scope.showSelectWinFlag = true;
    }
    //选择框确认
    $scope.selectOk = function () {
        $scope.selectedXiaoqu.checked = ($scope.selectedXiaoqu.address != null && $scope.selectedXiaoqu.address != "")
        $scope.address = $scope.selectedXiaoqu.address + '-' + $scope.selectedLou.address;
        $scope.user.addressLevelId = $scope.selectedXiaoqu.id + "," + $scope.selectedLou.id;
        $scope.user.addressLevel = $scope.selectedXiaoqu.address + "-" + $scope.selectedLou.address;
        $scope.showSelectWinFlag = false;
    }
    //选择校区
    $scope.selectXiaoqu = function (xiaoqu) {
        angular.forEach($scope.addressList, function (data) {
            data.selected = false;
            angular.forEach(data.addressList, function (d) {
                d.selected = false;
            });
        });
        xiaoqu.selected = true;
        $scope.selectedXiaoqu = xiaoqu;
        $scope.louList = xiaoqu.addressList;
        $scope.selectedLou = {}
    }
    //选择楼栋
    $scope.selectLoudong = function (loudong) {
        angular.forEach($scope.louList, function (data) {
            data.selected = false;
        });
        loudong.selected = true;
        $scope.selectedLou = loudong;
    }

    //全仓
    //刷新页面
    $scope.getAddressAll = function () {
        var url = "doErAddressUserAction_getErAddressUsersForSearch.action";
        var param = "erAddressUserSearch.restaurantId=" + $scope.getLoginUser().restaurantId;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.addressList = data.list[0];
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    $scope.getAddressAll();

    /**
     * 保存操作
     */
    $scope.saveAddress = function () {
        if ($scope.user.addressLevelId == null || $scope.user.addressLevelId == "") {
            $scope.toaster('error', '请选择分区和楼栋');
            return;
        }
        //编辑
        var url = "doUserAction_updatePtUser.action";
        var param = {};
        param.user = {};
        param.user.userId = $scope.user.userId;
        param.user.addressLevel = $scope.user.addressLevel;
        param.user.addressLevelId = $scope.user.addressLevelId;
        param.user.customAddress = $scope.user.customAddress;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //编辑
                $scope.toaster('success', '地址保存成功');
                $scope.state.go("app.address");
                return;
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }

}]);
