'use strict';

/* Controllers */

angular.module('app')
    .controller('AppCtrl', ['$scope', '$rootScope', '$http', '$window', '$stateParams', '$state', '$location', 'toaster', '$modal', '$q',
        function ($scope, $rootScope, $http, $window, $stateParams, $state, $location, toaster, $modal, $q) {
            //系统配置  start----------

            $rootScope.canteenYunUrl = "https://st.mankebao.cn/";
            //$rootScope.canteenYunUrl = "http://127.0.0.1:8080/";
            //$rootScope.canteenYunUrl = "http://223.86.39.201:23456/";
            //$rootScope.canteenYunUrl = "http://192.168.9.96:8080/canteen_600226/";


            $rootScope.isApp = true;//是否手机app打包
            //本地缓存remoteurl
            $rootScope.remoteUrl = app.caches.getItem('cacheRemoteUrl') || $rootScope.canteenYunUrl;
            //系统配置  end----------

            $scope.stateParams = $stateParams;
            $scope.state = $state;
            $scope.location = $location;
            $scope.toaster = toaster;
            $scope.modal = {};
            $rootScope.showLoading = false;//遮罩
            $rootScope.canShowLoading = false;//遮罩是否显示
            //通用对话框是否打开
            $rootScope.commonDialogOpen = false;
            //body背景
            $rootScope.bodyBg = false;
            //加载中
            $scope.loading = false;
            //本地缓存企业码
            $rootScope.cacheErCode = app.caches.getItem('erCode');
            $rootScope.laodongqiangduArr = [{text: '极轻体力劳动', value: '极轻体力劳动'}, {
                text: '轻体力劳动',
                value: '轻体力劳动'
            }, {text: '中体力劳动', value: '中体力劳动'}, {text: '重体力劳动', value: '重体力劳动'}];
            //是否显示底部菜单
            $rootScope.showMenu = false;
            $rootScope.currentMenu = "";
            //饭卡操作类型
            $rootScope.mealcardRecordTypes = [{value: '', text: '全部类型'}, {value: '1', text: '充值'}, {
                value: 'czsxf',
                text: '充值手续费'
            }, {value: '2', text: '餐补'}, {value: 'jc', text: '加班餐补'}, {value: 'xc', text: '现金餐补'}, {
                value: 'd',
                text: '餐补清零'
            }, {value: 'a', text: '食堂消费'}, {value: 'b', text: '核减'}, {value: 'hejia', text: '核加'}, {
                value: 'qita',
                text: '其它消费'
            }, {value: 'tx', text: '提现'}, {value: 'c', text: '退卡'}, {value: 'gb', text: '工本费'}, {
                value: 'yjkk',
                text: '开卡押金'
            }, {value: 'yjbk', text: '补卡押金'}, {value: 'yjtk', text: '退卡押金'}, {value: 'tcsf', text: '停车扣费'}];
            //全局登陆状态监听
            $rootScope.$on('unloginIntercepted', function (errorType) {
                if ($scope.getLoginUser()) {
                    $rootScope.loginUser = null;
                    app.caches.removeItem("loginUserFront");
                }
                if (typeof (AlipayJSBridge) !== undefined) {
                    try {
                        AlipayJSBridge.call('closeWebview');
                    } catch (e) {
                    }
                    ;
                }

                // 跳转到登录界面，这里我记录了一个from，这样可以在登录后自动跳转到未登录之前的那个界面
                $state.go("login.userLogin", {from: $state.current.name, authError: '未登陆或登陆超时'});
            });
            /**
             * 跳转页面
             * @param url
             * @param param
             */
            $scope.goPage = function (url, param) {
                $state.go(url, param);
            }
            $rootScope.goPage = $scope.goPage;
            /**
             * 消息提示
             * type：success,error,info,wait,warning 类型
             * title：标题
             * body：消息体
             * timeout：时间
             * bodyOutputType：消息体类型
             * clickHandler ：回调
             * @returns {}
             */
            $scope.toaster = function (type, title, body, timeout, bodyOutputType, clickHandler, to) {
                var timeoutM = timeout || 2000;
                toaster.pop(type, title, body, timeoutM, bodyOutputType, clickHandler, to);
            }
            /**
             * 清除消息
             * @returns {}
             */
            $scope.clearToaster = function () {
                toaster.clear();
            }
            /**
             * 替换alert弹框
             * @param {} text 消息
             * @param {} title 标题
             *  @param {} size sm 小 lg 大 可空
             *    用法  $scope.AlertMessage.result.then(function () {
        		   // 确定
    		  }, function () {
        		  //取消
      			});
             */
            $scope.AlertMessage = function (text, title, size) {
                $scope.modal.modalTitle = title;
                $scope.modal.modalText = text;
                $scope.modal.modalType = "ALTER";
                if ($rootScope.commonDialogOpen) {
                    return;
                }
                $rootScope.commonDialogOpen = true;
                var myModal = $modal.open({
                    templateUrl: 'commonModal.html',
                    controller: 'CommonModalInstanceCtrl',
                    size: size || "sm",
                    resolve: {
                        modal: function () {
                            return $scope.modal;
                        }
                    }
                });
                myModal.result.then(null, function () {
                    $rootScope.commonDialogOpen = false;
                });
                return myModal;
            }
            $rootScope.AlertMessage = $scope.AlertMessage;
            /**
             * 替换confirm弹框
             * @param {} text 消息
             * @param {} title 标题
             *  @param {} size sm 小 lg 大 可空
             * @returns {} modalInstance
             *    用法  $scope.AlertMessage('','').result.then(function () {
        		   // 确定
    		  }, function () {
        		  //取消
      			});
             */
            $scope.ConfirmMessage = function (text, title, size) {
                $scope.modal.modalTitle = title;
                $scope.modal.modalText = text;
                $scope.modal.modalType = "CONFIRM";
                if ($rootScope.commonDialogOpen) {
                    return;
                }
                $rootScope.commonDialogOpen = true;
                var myModal = $modal.open({
                    templateUrl: 'commonModal.html',
                    controller: 'CommonModalInstanceCtrl',
                    size: size || "sm",
                    resolve: {
                        modal: function () {
                            return $scope.modal;
                        }
                    }
                });
                myModal.result.then(null, function () {
                    $rootScope.commonDialogOpen = false;
                });
                return myModal;
            }
            $rootScope.ConfirmMessage = $scope.ConfirmMessage;
            /**
             * 打开模态窗体
             * @param {} config
             * config属性
             * {
             * templateUrl:模板地址  可以为  <script type="text/ng-template" id="myModalContent.html">的模板
             * 也可以为具体的html。
             * controller:窗体内用的controller。如果不指定，可以直接使用rootscope作用域
             * size:lg/sm
             * resolve注入的参数，目标窗体用注入参数的形式来接收
             * }
             * @returns {}
             *  $scope.openModalWindow(config).result.then(function () {
        		   // 确定
    		  }, function () {
        		  //取消
      			});
             */
            $scope.openModalWindow = function (config) {
                return $modal.open(config);
            }
            /**
             * 切换css
             * @param {} ele
             * @param {} myclass
             * @returns {}
             */
            $scope.toggleClass = function (ele, myclass) {
                $(ele).toggleClass(myclass);
            }
            $rootScope.showCameraPlayer = false;
            $scope.playerBaseUrl = "vendor/player/sewise.player.min.js";
            /**
             * 打开播放器
             * @param camera
             * @param eid
             */
            $scope.addPlayer = function (camera, eid) {
                if (!$rootScope.showCameraPlayer) {
                    var script = document.createElement('script');
                    script.type = "text/javascript";
                    var params = "?logo=vendor/player/playerlogo.png&server=vod&type=m3u8&autostart=true&videourl=" + camera.liveUrl + "&sourceid=&starttime=0&lang=zh_CN&title=" + encodeURIComponent(camera.title) + "&claritybutton=disable&skin=vodWhite";
                    script.src = $scope.playerBaseUrl + params;

                    //$("#container").append(script);
                    //用JQ的append方法动态添加脚本会造成脚本被执行两次，所以这里改为原生动态添加脚本的方式。
                    $("#" + eid).get(0).appendChild(script);
                    $rootScope.showCameraPlayer = true;
                }
            }
            $rootScope.addPlayer = $scope.addPlayer;
            $scope.removePlayer = function (eid) {
                if (window.SewisePlayer) {
                    try {
                        SewisePlayer.doStop();
                    } catch (e) {
                    }
                    ;
                }
                if ($rootScope.showCameraPlayer) {
                    $("#" + eid).empty();
                    $rootScope.showCameraPlayer = false;
                }
            }
            $rootScope.removePlayer = $scope.removePlayer;
            $scope.toPlay = function (camera) {
                if (window.SewisePlayer) {
                    try {
                        SewisePlayer.toPlay(camera.liveUrl, camera.title, 0, true);
                    } catch (e) {
                    }
                    ;
                }
                $rootScope.showCameraPlayer = true;
            }
            $scope.toStop = function (camera) {
                if (window.SewisePlayer) {
                    try {
                        SewisePlayer.toStop();
                    } catch (e) {
                    }
                    ;
                }
                $rootScope.showCameraPlayer = false;
            }

            /**
             * 取得登陆用户
             * @returns {}
             */
            $scope.getLoginUser = function () {
                if ($rootScope.loginUser) {
                    return $rootScope.loginUser;
                } else if (app.caches.getItem("loginUserFront")) {
                    $rootScope.loginUser = app.caches.getItem("loginUserFront");
                    return $rootScope.loginUser;
                } else {
                    return null;
                }
            }
            $rootScope.getLoginUser = $scope.getLoginUser;
            /**
             * 取得当前餐厅
             **/
            $scope.getCurrentCanteen = function () {
                if ($rootScope.currentCanteen) {
                    return $rootScope.currentCanteen;
                } else if (app.caches.getItem("currentCanteen")) {
                    $rootScope.currentCanteen = app.caches.getItem("currentCanteen");
                    return $rootScope.currentCanteen;
                } else {
                    return null;
                }
            }
            $rootScope.getCurrentCanteen = $scope.getCurrentCanteen;
            /**
             * 退出
             * @returns {}
             */
            $scope.logout = function () {
                var url = "logout.action";
                $http.post(url).success(function (data, status, headers, config) {
                    if (data.success) {
                        if ($scope.getLoginUser()) {
                            $rootScope.loginUser = null;
                            app.caches.removeItem("loginUserFront");
//                        if(typeof(uexWidgetOne) !== undefined && $rootScope.isApp){
//                            try{
//                            uexWidgetOne.exit(-1);
//                            }catch(e){}
//                        }
                            $rootScope.$state.go("login.userLogin");
                        }
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }
                });

            }
            /**
             * 切换食堂
             ***/
            $scope.changeCanteen = function (canteenId, goUrl) {
                //记录用户选择食堂位置
                $rootScope.canteenY = window.pageYOffset;
                if (canteenId) {
                    var url = "doUserAction_changeCanteen.action";
                    var param = "canteenId=" + canteenId;
                    $http.post(url, param).success(function (data, status, headers, config) {
                        if (data.success) {
                            $rootScope.currentCanteen = data.erCanteen;
                            app.caches.setItem("currentCanteen", data.erCanteen);
                            app.caches.setItem("selectCanteenId", canteenId, 1);
                            $rootScope.currentCanteenId = data.erCanteen.id;
                            //刷新页面
                            if (goUrl) {
                                $state.go(goUrl);
                            } else {
                                location.reload();
                            }
                        } else {
                            $scope.AlertMessage(data.errMsg, '错误');
                        }
                    });
                }
            }
            /**
             * 展示或者隐藏左侧侧滑的导航
             **/
            $scope.showOrHideLeftNav = function () {
                $rootScope.showBatch = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.batchCanuse == 'Y') ? true : false;
                $rootScope.showCamera = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.cameraFlag == 'Y') ? true : false;
                var height = $(window).height();
                var menuHeight = (height - 50 - 80 - 50) / 9;
                $('.person_menu li a').css('line-height', menuHeight + 'px');
                $rootScope.showLeftNav = !$rootScope.showLeftNav;
            }
            /**
             * 判断是否隐藏
             */
            $scope.checkIsHidePrice = function () {
                var result = false;
                if ($scope.getLoginUser()) {
                    result = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.isHidePrice == 'Y') ? true : false;
                    return result;
                } else {
                    $scope.reloadCurrenUserInfo(true).then(function (data) {
                        if (!data) {
                            return false;
                        } else {
                            result = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.isHidePrice == 'Y') ? true : false;
                            return result;
                        }
                    });
                }
            }
            /**
             * 刷新用户
             * @returns {}
             */
            $scope.reloadCurrenUserInfo = function (isfirst) {
                var def = $q.defer();
                var url = "doUserAction_getCurrentUserInfo.action";
                $http.post(url).success(function (data, status, headers, config) {
                    if (data.success) {
                        //设置缓存
                        $rootScope.loginUser = data.loginUser;
                        $rootScope.currentCanteen = data.erCanteen;
                        if ($rootScope.loginUser) {
                            app.caches.setItem("loginUserFront", data.loginUser);
                            if (isfirst) {
                                var currentId = data.erCanteen.id;
                                app.caches.setItem("currentCanteen", data.erCanteen);
                                var selectCanteenId = app.caches.getItem("selectCanteenId");
                                if (selectCanteenId) {
                                    for (var i = 0; i < erList.length; i++) {
                                        var er = erList[i];
                                        if (er.id == selectCanteenId) {
                                            $rootScope.currentCanteen = er;
                                            app.caches.setItem("currentCanteen", er);
                                            break;
                                        }
                                    }
                                }
                            }
                        }

                        def.resolve($rootScope.loginUser);
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                        def.reject();
                    }
                });
                return def.promise;
            }
            $rootScope.reloadCurrenUserInfo = $scope.reloadCurrenUserInfo;
            /** 格式化时间（日期统一 ） */
            $scope.setTimeByDate = function (date) {
                date.setYear(2016);
                date.setMonth(0);
                date.setDate(1);
                return date;
            }
            /**
             * 计算天数
             * @param sDate1
             * @param sDate2
             * @returns {Number}
             * @constructor
             */
            $scope.DateDiff = function (sDate1, sDate2) {    //sDate1和sDate2是2006-12-18格式
                var aDate, oDate1, oDate2, iDays
                aDate = sDate1.split("-")
                oDate1 = new Date(aDate[1] + '-' + aDate[2] + '-' + aDate[0])    //转换为12-18-2006格式
                aDate = sDate2.split("-")
                oDate2 = new Date(aDate[1] + '-' + aDate[2] + '-' + aDate[0])
                iDays = parseInt(Math.abs(oDate1 - oDate2) / 1000 / 60 / 60 / 24)    //把相差的毫秒数转换为天数
                return iDays
            }
            //日期转换
            $scope.changeToMyDate = function (mydate, format) {
                var newV = "";
                if (typeof (mydate) == "string") {
                    newV = mydate;
                } else if (typeof (mydate) == "object") {
                    if (mydate.time) {
                        newV = new Date(mydate.time).format(format);
                    } else {
                        newV = mydate.format(format);
                    }
                }
                return newV;
            }

            $rootScope.changeToMyDate = $scope.changeToMyDate;

            /**
             * 字符串转日期
             * @param str
             * @returns {*}
             */
            $scope.getDateFromStr = function (str) {
                str = str.replace(/-/g, "/");
                var date = new Date(str);
                return date;
            }
            /**根据日期(Date类型)获取其时间戳(long型)*/
            $scope.getLongByDate = function (date) {
                if (date.time) {
                    return date.time;
                } else {
                    return date.getTime();
                }
            }
            /**
             * 替换全部
             * @param str
             * @param sptr
             * @param sptr1
             * @returns {*}
             */
            $scope.replaceAll = function (str, from, to) {
                while (str.indexOf(from) >= 0) {
                    str = str.replace(from, to);
                }
                return str;
            }

            /**
             * 取得图片地址
             * @param imgUrl
             */
            $scope.getPicUrl = function (imgUrl, isList) {
                if (imgUrl) {
                    return $scope.getImgPrifxUrl(isList) + imgUrl;
                } else {
                    return "images/diancai_03.png";
                }
            }

            /**
             * 取得图片地址
             * @param imgUrl
             */
            $scope.getToupiaoPicUrl = function (imgUrl, isList) {
                if (imgUrl) {
                    return $scope.getImgPrifxUrl(isList) + imgUrl;
                } else {
                    return "images/getheadimg.png";
                }
            }

            /**
             * 图片前缀
             */
            $scope.getImgPrifxUrl = function (isList) {
                var romoteUrl = $rootScope.remoteUrl || $rootScope.canteenYunUrl;
                var isApp = $rootScope.isApp;
                return ($rootScope.isApp ? romoteUrl : "") + "/uploadImages/" + $scope.replaceAll($scope.getCurrentCanteen().id, "-", "") + "/" + (isList ? "list/" : "");
            }
            /**
             * 食堂图片前缀
             */
            $scope.getCanteenImgPrifxUrl = function (url, isList) {
                var romoteUrl = $rootScope.remoteUrl || $rootScope.canteenYunUrl;
                var isApp = $rootScope.isApp;
                if (!url) {
                    return 'images/gonggao2_07.png';
                } else {
                    if (isList) {
                        var index = url.lastIndexOf("/");
                        var afterUrl = url.substring(0, index) + "/list" + url.substring(index);
                        return ($rootScope.isApp ? romoteUrl : "") + afterUrl;
                    } else {
                        return ($rootScope.isApp ? romoteUrl : "") + url;
                    }
                }
            }
            /**
             * 企业图片前缀
             */
            $scope.getRidImgPrifxUrl = function (isList) {
                var romoteUrl = $rootScope.remoteUrl || $rootScope.canteenYunUrl;
                var isApp = $rootScope.isApp;
                return ($rootScope.isApp ? romoteUrl : "") + "/uploadImages/" + $scope.replaceAll($scope.getLoginUser().restaurantId, "-", "") + "/" + (isList ? "list/" : "");
            }
            /**
             * 获取头像url
             */
            $rootScope.getUserHeadImg = function () {
                var userHeadImgUrl = $scope.getLoginUser().userExt_1;
                if (userHeadImgUrl) {
                    return $scope.getRidImgPrifxUrl(true) + userHeadImgUrl;
                } else {
                    return 'images/touxiang.jpg';
                }
            }
            /**
             * 获取头像大图url
             */
            $rootScope.getUserHeadBigImg = function () {
                var userHeadImgUrl = $scope.getLoginUser().userExt_1;
                if (userHeadImgUrl) {
                    return $scope.getRidImgPrifxUrl(false) + userHeadImgUrl;
                } else {
                    return 'images/touxiang.jpg';
                }
            }
            /**
             * 根据地址返回常用地址和详细地址
             **/
            $rootScope.getCommonAddress = function (address) {
                if (!address) {
                    return null;
                }
                if ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.addressList) {
                    var commonAddressList = $scope.getLoginUser().erRestaurant.addressList;
                    //将地址分割成常用地址和详细地址
                    for (var i = 0; i < commonAddressList.length; i++) {
                        var commonAddressObj = commonAddressList[i];
                        var commonAddressStr = commonAddressObj.address;
                        if (address.indexOf(commonAddressStr + '-') == 0) {
                            return commonAddressStr;
                        }
                    }
                } else {
                    return null;
                }
            }
            /**
             * 获取真实地址，去掉常用地址以后
             **/
            $rootScope.getRealAddress = function (address, commonAddress) {
                if (!commonAddress) {
                    return address;
                }
                if (!address) {
                    return address;
                }

                address = address.replace(commonAddress + '-', '');
                return address;
            }
            /**
             * 是否移动端
             */
            $scope.isMobile = function () {
                if (navigator.userAgent.match(/(iPhone|iPod|Android|ios|iPad)/i)) {
                    return true;
                } else {
                    return false;
                }
            }
            $rootScope.isMobile = $scope.isMobile;
            /**
             * 获得浏览类型(只判断是支付宝还是微信)
             */
            $scope.getExplorerType = function () {
                var userAgent = navigator.userAgent.toLowerCase();
                if (userAgent.match(/Alipay/i) == "alipay") {
                    return "AL";
                }
                if (userAgent.match(/MicroMessenger/i) == "micromessenger") {
                    return "WX";
                }
                return "NO";
            }
            /**
             * 用户解绑
             */
            $scope.unbindUser = function () {
                if ($scope.getExplorerType() == 'AL') {
                    $scope.unbindAlUser();
                    return;
                }
                $scope.ConfirmMessage("确认要解绑微信号与该账户的关系吗？", "提示").result.then(
                    function () {
                        var url = "doUserAction_unbindWxUser.action";
                        $http.post(url).success(function (data, status, headers, config) {
                            if (data.success) {
                                $scope.toaster("success", "解绑成功");
                                window.location.href = '/pay/unbindSucc.html';
                            } else {
                                $scope.AlertMessage(data.errMsg, '错误');
                            }
                        });
                    }
                );

            }
            /**
             * 用户解绑
             */
            $scope.unbindAlUser = function () {
                $scope.ConfirmMessage("确认要解绑支付宝与该账户的关系吗？", "提示").result.then(
                    function () {
                        var url = "doUserAction_unbindAlUser.action";
                        $http.post(url).success(function (data, status, headers, config) {
                            if (data.success) {
                                $scope.toaster("success", "解绑成功");
                                window.location.href = '/pay/unbindSucc.html';
                            } else {
                                $scope.AlertMessage(data.errMsg, '错误');
                            }
                        });
                    }
                );

            }


            /**
             *营养成分加
             */
            $scope.addYingyang = function (src, food) {
                //能量
                if (food.nengliang) {
                    src.nengliang = src.nengliang + (food.nengliang ? food.nengliang : 0) * food.foodNum;
                }
                //蛋白质
                if (food.danbaizhi) {
                    src.danbaizhi = src.danbaizhi + (food.danbaizhi ? food.danbaizhi : 0) * food.foodNum;
                }
                //脂肪
                if (food.zhifang) {
                    src.zhifang = src.zhifang + (food.zhifang ? food.zhifang : 0) * food.foodNum;
                }
                //碳水化合物
                if (food.tshhw) {
                    src.tshhw = src.tshhw + (food.tshhw ? food.tshhw : 0) * food.foodNum;
                }
            }

            /**
             * 营养餐比较
             */
            $scope.compareYingyang = function (total, biaozhun) {
                if ($scope.yingyangcanCanUse() !== '') {
                    return;
                }
                var configXishu = 0;
                if ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.yingyangPiancha) {
                    configXishu = $scope.getLoginUser().erRestaurant.yingyangPiancha;
                }
                var bodongXishu = 0.1;//波动系数10%
                if (configXishu && configXishu > 0) {
                    bodongXishu = configXishu;
                }
                var yingyangMessage = "";
                //能量
                if (!isNaN(total.nengliang) && !isNaN(biaozhun.nengliang)) {
                    if (total.nengliang > (biaozhun.nengliang * (1 + bodongXishu))) {
                        total.nengliangDesc = "↑";
                        yingyangMessage += "热量偏高↑;";
                    } else if (total.nengliang < (biaozhun.nengliang * (1 - bodongXishu))) {
                        total.nengliangDesc = "↓";
                        yingyangMessage += "热量偏低↓;";
                    } else {
                        total.nengliangDesc = '';
                    }
                } else {
                    total.nengliangDesc = '';
                }
                //蛋白质
                if (!isNaN(total.danbaizhi) && !isNaN(biaozhun.danbaizhi)) {
                    if (total.danbaizhi > (biaozhun.danbaizhi * (1 + bodongXishu))) {
                        total.danbaizhiDesc = "↑";
                        yingyangMessage += "蛋白质偏高↑;";
                    } else if (total.danbaizhi < (biaozhun.danbaizhi * (1 - bodongXishu))) {
                        total.danbaizhiDesc = "↓";
                        yingyangMessage += "蛋白质偏低↓;";
                    } else {
                        total.danbaizhiDesc = '';
                    }
                } else {
                    total.danbaizhiDesc = '';
                }
                //脂肪
                if (!isNaN(total.zhifang) && !isNaN(biaozhun.zhifang)) {
                    if (total.zhifang > (biaozhun.zhifang * (1 + bodongXishu))) {
                        total.zhifangDesc = "↑";
                        yingyangMessage += "脂肪偏高↑;";
                    } else if (total.zhifang < (biaozhun.zhifang * (1 - bodongXishu))) {
                        total.zhifangDesc = "↓";
                        yingyangMessage += "脂肪偏低↓;";
                    } else {
                        total.zhifangDesc = '';
                    }
                } else {
                    total.zhifangDesc = '';
                }
                //碳水化合物
                if (!isNaN(total.tshhw) && !isNaN(biaozhun.tshhw)) {
                    if (total.tshhw > (biaozhun.tshhw * (1 + bodongXishu))) {
                        total.tshhwDesc = "↑";
                        yingyangMessage += "碳水化合物偏高↑;";
                    } else if (total.tshhw < (biaozhun.tshhw * (1 - bodongXishu))) {
                        total.tshhwDesc = "↓";
                        yingyangMessage += "碳水化合物偏低↓;";
                    } else {
                        total.tshhwDesc = '';
                    }
                } else {
                    total.tshhwDesc = '';
                }
                if (yingyangMessage) {
                    total.yingyangMessage = "营养建议：" + yingyangMessage;
                    total.yingyangMessageHead = "营养建议：";
                    total.yingyangMessageBody = yingyangMessage;
                }
            }
            /**
             * 是否使用营养餐
             */
            $scope.yingyangcanCanUse = function () {
                if ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.useYingyangcan == 'Y') {
                    if ($scope.getLoginUser().riNengliang) {
                        return "";
                    } else {
                        return "未配置用户身体状态，无法取得营养餐数据";
                    }
                } else {
                    return "企业未开启营养餐功能";
                }
            }
            /**
             * 取得用户当餐的营养参数 中午40%，早上和晚上30%
             * 早9点和晚5点之前40%
             */
            $scope.userYingyangInfo = function (canbieDate) {
                var user = $scope.getLoginUser();
                var yingyangInfo = {nengliang: 0, zhifang: 0, danbaizhi: 0, tshhw: 0};
                if (!user.riNengliang) {
                    return yingyangInfo;
                } else {
                    var mydate = new Date(canbieDate.time);
                    var hourT = mydate.getHours();
                    var xishu = 0.3;
                    if (hourT >= 9 && hourT <= 16) {
                        xishu = 0.4;
                    }
                    yingyangInfo.nengliang = user.riNengliang ? (Number(user.riNengliang * xishu).toFixed(2)) : 0;
                    yingyangInfo.zhifang = user.riZf ? (Number(user.riZf * xishu).toFixed(2)) : 0;
                    yingyangInfo.danbaizhi = user.riDbz ? (Number(user.riDbz * xishu).toFixed(2)) : 0;
                    yingyangInfo.tshhw = user.riTshhw ? (Number(user.riTshhw * xishu).toFixed(2)) : 0;
                }
                return yingyangInfo;
            }
            /**
             *显示标签内容
             * @param selected
             */
            $scope.getBiaoqianDesc = function (selected) {
                var result = "";
                if (selected) {
                    var selecteds = selected.split(";");
                    for (var i = 0; i < selecteds.length; i++) {
                        var items = selecteds[i].split("@");
                        if (items.length > 1) {
                            result += items[1] + ";";
                        }
                    }
                }
                if (!result) {
                    result = "无";
                }
                return result;
            }
            $rootScope.getBiaoqianDesc = $scope.getBiaoqianDesc;
            $scope.showLogout = navigator.userAgent.match(/MicroMessenger\/([\d\.]+)/i) || navigator.userAgent.match(/Alipay/i);
            $rootScope.showLogout = $scope.showLogout;
            /**
             * 获取屏幕高度
             */
            $scope.getScreenHeight = function (subHeight) {
                //原来统一定的500，现在可按显示区域的高度去动态设置div的高度
                return document.documentElement.clientHeight - subHeight;
            }
            /**
             * 获取饭卡消费类型描述
             **/
            $scope.getMealcarRecordTypeName = function (type) {
                var result = type;
                for (var i = 0; i < $rootScope.mealcardRecordTypes.length; i++) {
                    var mrType = $rootScope.mealcardRecordTypes[i];
                    if (mrType.value == type) {
                        result = mrType.text;
                        break;
                    }
                }
                return result;
            }

            /**
             * 是否是微信浏览器
             */
//        $scope.isInWXBrowser = function(){
//            var wInfo = navigator.userAgent.match(/MicroMessenger\/([\d\.]+)/i) ;
//            return wInfo;
//        }
            /**
             * 根据获取当前企业叫自提还是打包
             */
            $scope.isZiTiOrDaBao = function () {
                if ($scope.isZiTiOrDaBao == "600142") {
                    return "打包";
                } else {
                    return "自提";
                }
            }
            $scope.dataURLtoBlob = function (dataurl) {
                var arr = dataurl.split(','),
                    mime = arr[0].match(/:(.*?);/)[1],
                    bstr = atob(arr[1]),
                    n = bstr.length,
                    u8arr = new Uint8Array(n);
                while (n--) {
                    u8arr[n] = bstr.charCodeAt(n);
                }
                return new Blob([u8arr], {type: mime});
            }
            //将blob转换为file
            $scope.blobToFile = function (theBlob, fileName) {
                theBlob.lastModifiedDate = new Date();
                theBlob.name = fileName;
                return theBlob;
            }
        }]);