app.controller('CameraViewCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {

    /**
     * 视频监控
     * @param erCamera
     */
    $scope.showCamera = function (erCamera) {
        $scope.removePlayer("playerContainer");
        $scope.addPlayer(erCamera, "playerContainer");
        $("#cameraShow").show();
        if (!erCamera.isAdmin && erCamera.limitSeconds && erCamera.limitSeconds > 0) {
            setTimeout(function () {
                SewisePlayer.onPlayTime(function (time, name) {
                    if (time > erCamera.limitSeconds) {
                        $scope.closeCamera(erCamera);
                        $scope.toaster("warning", "超过观看时间，自动关闭", "", 5000);
                    }
                });
            }, 5000);
        }
    }


    /**
     * 视频监控
     * @param erCamera
     */
    $scope.toCameraPlay = function (erCamera) {
        $("#cameraShow").show();
        $scope.toPlay(erCamera);
    }
    /**
     * 视频监控
     * @param erCamera
     */
    $scope.toCameraStop = function (erCamera) {
        $("#cameraShow").hide();
        $scope.toStop(erCamera);
    }

    //分页查询方法
    $scope.getPagedDataAsync = function () {
        setTimeout(function () {
            var url = "doErCameraAction_getErCamerasForSearchPaginated.action";
            var param = {};
            param.start = 0;
            param.limit = 9999;
            param.erCameraSearch = {};
            param.erCameraSearch.state = '启用';
            $http.post(url, param).success(function (data, status, headers, config) {
                if (data.success) {
                    $scope.cameraList = data.list;
                } else {
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });
        }, 100);
    };
    $scope.getPagedDataAsync();


    /**
     * 关闭
     * @param erCamera
     */
    $scope.closeCamera = function (erCamera) {
        $("#cameraShow").hide();
        $scope.removePlayer("playerContainer");
    }

    /**
     * 打开选择企业
     */
    $scope.openCanteenSelect = function () {
        var modal = $scope.getLoginUser().erCanteenList;
        if ($scope.getLoginUser().erCanteenList.length < 2) {
            return;
        }
        $scope.openModalWindow({
            templateUrl: 'tpl/canteenSelect.html',
            controller: 'canteenCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            $scope.changeCanteen(returnData.id);
        });
    }
}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('canteenCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //食堂列表
    $scope.canteenList = modal;
    //选择
    $scope.selectCanteen = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);