app.controller('CanteenListCtrl', ['$rootScope', '$scope', '$http', '$timeout', '$location', function ($rootScope, $scope, $http, $timeout, $location) {
    $rootScope.bodyBg = false;
    //企业是否开启抢单送状态
    $scope.isQds = false;
    if ($scope.getLoginUser()) {
        $scope.isQds = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.isQds && ($scope.getLoginUser().erRestaurant.isQds.length > 0)) && $scope.getLoginUser().erRestaurant.isQds == 0 ? true : false;
    }
    //菜单状态
    $rootScope.showMenu = true;
    $rootScope.currentMenu = "main";
    $scope.canteenList = [];
    $scope.gonggaoList = [];
    $scope.erCanteenC = [];
    $scope.campus = {};
    $scope.floor = {};
    //判断来源
    $rootScope.from = $scope.stateParams.from || app.caches.getItem("from");
    if ($rootScope.from) {
        app.caches.setItem("from", $rootScope.from);
    }
    /**
     * 服务号登陆问题
     */
    $scope.getCanteenListFromSession = function () {
        var url = "doUserAction_getCurrentUserInfo.action";
        $http.post(url).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.canteenList = data.loginUser.erCanteenList;
                $scope.getModal();
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }

    /**
     * 打开选择企业
     */
    $scope.getModal = function () {
        $scope.canteenList = $scope.getLoginUser().erCanteenList;
        // if( $scope.canteenList &&  $scope.canteenList.length ==1){
        // $scope.state.go("app.main");
        // return;
        // }
        //加载公告
        var url = "doErGonggaoAction_getErGonggaosForSearchPaginated.action";
        var param = "erGonggaoSearch.state=启用&start=0&limit=5&erGonggaoSearch.type=企业级";
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                var gonggaoList = data.list;
                if (gonggaoList.length == 0) {
                    var defaultGonggao = {};
                    defaultGonggao.title = '智慧食堂';
                    defaultGonggao.titlePicUrl = 'images/qiye014.jpg';
                    $scope.gonggaoList.push(defaultGonggao);
                } else {
                    for (i = 0; i < gonggaoList.length; i++) {
                        var romoteUrl = $rootScope.remoteUrl || $rootScope.canteenYunUrl;
                        var isApp = $rootScope.isApp;
                        if (gonggaoList[i].titlePicUrl != '') {
                            gonggaoList[i].titlePicUrl = ($rootScope.isApp ? romoteUrl : "") + gonggaoList[i].titlePicUrl;
                        } else {
                            gonggaoList[i].titlePicUrl = null;
                        }
                    }
                }
                $scope.gonggaoList = gonggaoList;
                setTimeout(function () {
                    $('#banner').owlCarousel({items: 1, autoPlay: true});
                    $(".txtScroll-top").slide({
                        mainCell: ".bd ul",
                        autoPage: true,
                        effect: "top",
                        autoPlay: true,
                        vis: 2
                    });
                    //读取用户选择食堂位置,滚动至该位置
                    window.scroll(0, $rootScope.canteenY);
                }, 300)
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    try {
        $scope.getCanteenListFromSession();
    } catch (e) {
        alert(e.name + e.message);
    }
    $scope.goPageTakeout = function () {
        var flage = 'N';
        $scope.checkRoleList = $scope.getLoginUser().roleList
        for (var i = 0; i < $scope.checkRoleList.length; i++) {
            if ($scope.checkRoleList[i].roleId == "SENDER") {
                flage = 'Y';
                break;
            }
        }
        if (flage == 'Y') {
            $location.path("app/takeoutBill");
        } else {
            $scope.AlertMessage('非送餐员无法抢单!', '错误');
        }
    }

    /**
     *  公告查看
     */
    $scope.openShowGonggao = function (gonggao) {
        var modal = gonggao;
        $scope.openModalWindow({
            templateUrl: 'tpl/gogngaoShow.html',
            controller: 'showGonggaoCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
        }, function (returnData) {
        });
    }
    /**
     * 食堂筛选
     * @param canteen
     * @returns {boolean}
     */
    $scope.searchCanteen = function (canteen) {
        if (!$scope.searchCanteenName) {
            return true;
        }
        if (canteen.name && canteen.name.indexOf($scope.searchCanteenName) > -1) {
            return true;
        }
    }
    /**
     * 取得数组
     * @param num
     * @returns {Array}
     */
    $scope.getNumberArray = function (num) {
        return new Array(num);
    }
}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('showGonggaoCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.returnData = {};
    //接收的参数
    $scope.gonggao = modal;
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);