app.controller('DianzicaipuCtrl', ['$rootScope', '$scope', '$http', '$timeout', function ($rootScope, $scope, $http, $timeout) {
    //食堂ID
    $scope.selectCanteenId = $scope.stateParams.canteenId || app.caches.getItem('selectCanteenId') || "4FBB9944-D8B4-41BB-9534-EA3B837DBDE8";
    app.caches.setItem('selectCanteenId', $scope.selectCanteenId, 1);
    //时间间隔
    $scope.timeBetween = app.caches.getItem('timeCount') || 5000;
    //每页大小
    $scope.pageSize = app.caches.getItem('caiyaoNumber') || 10;
    $scope.selectCanteenName = "";
    $scope.nowDate = "";
    $scope.canbieList = [];
    $scope.foodList = [];
    $scope.selectCanbieIndex = -1;
    $scope.selectPageIndex = -1;

    /**
     * 初始化投票列表
     **/
    $scope.initData = function () {
        var url = "doErCookbookAction_getTodayCookbooksFromOcs.action";
        param = "canteenId=" + $scope.selectCanteenId;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.nowDate = data.nowDate;
                $scope.selectCanteenName = data.canteenName
                $scope.canbieList = data.list;
                if ($scope.canbieList && $scope.canbieList.length > 0) {
                    //$scope.selectCanbie($scope.canbieList[0]);
                    $scope.autoPage();
                }
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    //选择餐别
    $scope.selectCanbie = function (item) {
        $scope.selectedCanbie = {};
        for (var i = 0; i < $scope.canbieList.length; i++) {
            if (item.canbieId == $scope.canbieList[i].canbieId) {
                $scope.canbieList[i].selected = true;
                $scope.selectedCanbie = $scope.canbieList[i];
                var tempList = $scope.selectedCanbie.erCookbookDetailList;
                $scope.foodList = [];
                var count = 1;
                var showIndex = 1;
                for (var k = 0; k < tempList.length; k++) {
                    var temp = tempList[k];
                    if (temp.classId !== 'taocan') {
                        temp.myNumber = count;
                        temp.showIndex = showIndex;
                        count++;
                        showIndex++;
                        $scope.foodList.push(temp);
                    } else {
                        temp.myNumber = count;
                        temp.showIndex = showIndex;
                        count++;
                        showIndex++;
                        $scope.foodList.push(temp);
                        for (var m = 0; m < temp.taocanFoodList.length; m++) {
                            var tcd = temp.taocanFoodList[m];
                            tcd.myNumber = count;
                            tcd.intc = true;
                            count++;
                            $scope.foodList.push(tcd);
                        }
                    }
                }
                $scope.selectCanbieIndex = $scope.canbieList.indexOf($scope.selectedCanbie);
                $scope.selectPageIndex = 1;
            } else {
                $scope.canbieList[i].selected = false;
            }

        }
    }
    $scope.initData();
    /**
     * 分页
     * @returns {boolean}
     */
    $scope.displayFood = function (food) {
        var start = ($scope.selectPageIndex - 1) * $scope.pageSize + 1;
        var end = ($scope.selectPageIndex) * $scope.pageSize;
        if (food.myNumber >= start && food.myNumber <= end) {
            return true;
        }
    }
    $scope.openConfig = function () {
        var modal = {};
        modal.timeCount = $scope.timeBetween / 1000;
        //每页大小
        modal.caiyaoNum = $scope.pageSize;
        $scope.openModalWindow({
            templateUrl: 'tpl/caipuConfig.html',
            controller: 'caipuConfigCtrl',
            size: "lg",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            app.caches.setItem("timeCount", returnData.timeCount * 1000, 1);
            app.caches.setItem("caiyaoNumber", returnData.caiyaoNum, 1);
            $scope.freshPage();
        });
    }
    $scope.freshPage = function () {
        $scope.state.go("login.dianzicaipu", {}, {reload: true});
    }
    /**
     * 自动展示
     */
    $scope.autoPage = function () {
        if ($scope.foodList && $scope.foodList.length > 0 && $scope.foodList.length > ($scope.selectPageIndex * $scope.pageSize)) {
            $scope.selectPageIndex++;
        } else if ($scope.canbieList && $scope.canbieList.length > 0) {
            if ($scope.selectCanbieIndex == $scope.canbieList.length - 1) {
                $scope.selectCanbie($scope.canbieList[0]);
            } else {
                $scope.selectCanbie($scope.canbieList[$scope.selectCanbieIndex + 1]);
            }
        }
        $timeout($scope.autoPage, $scope.timeBetween);
    }
}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('caipuConfigCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.mm = {};
    $scope.mm.timeCount = modal.timeCount;
    $scope.mm.caiyaoNum = modal.caiyaoNum;
    //绑定验证
    setTimeout(function () {
        $("#timeCount").focus();
        $("#caipuConfig").validationEngine("attach", {
            promptPosition: "topLeft",
            scroll: false
        });
    }, 500);
    //选择
    $scope.ok = function () {
        //绑定验证
        var formValidate = $('#caipuConfig').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        $modalInstance.close($scope.mm);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);