/**
 * 选择组织机构登陆
 */
app.controller('OrgLoginCtrl', ['$rootScope', '$scope', '$http', '$timeout', function ($rootScope, $scope, $http, $timeout) {
    $rootScope.bodyBg = true;
    $scope.mainRid = "D384DF38-BA81-452B-A208-D8E686CCDEBE";
    $scope.errMsg = $scope.stateParams.authError || "";
    //设定请求地址
    $scope.mainCacheRemoteUrl = "";//http://127.0.0.1/";//http://192.168.1.1";
    if (!app.caches.getItem("cacheRemoteUrl")) {
        app.caches.setItem("cacheRemoteUrl", $scope.mainCacheRemoteUrl, 1);
        $rootScope.remoteUrl = $scope.mainCacheRemoteUrl;
    }
    //$rootScope.remoteUrl

    $scope.rid = $scope.stateParams.rid || app.caches.getItem("rid");
    $scope.rid = $scope.rid ? $scope.rid : $scope.mainRid;//取得一下默认的企业ID
    $scope.orgList = [];//组织机构列表
    $scope.userList = [];//用户列表
    $scope.showOrg = true;//是否显示组织机构列表
    $scope.orgId = "";
    /**
     * 查询组织机构列表
     */
    $scope.selectOrgList = function () {
        var params = "node=" + $scope.rid;
        var action = "selectOrganiseList.action";
        $scope.orgList = [];
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.orgList = data.list;
                for (var i = 0; i < $scope.orgList.length; i++) {
                    if ($scope.orgList[i].orgCode == 'wbry') {
                        $scope.orgList.splice(i, 1);
                        break;
                    }
                }
                $scope.setOrgFocus();
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
                $scope.errMsg = data.errMsg;
            }
        });
    }
    $scope.selectOrgList();
    /**
     * 自动焦点
     */
    $scope.autoFocus = function () {
        if ($scope.showOrg) {
            $scope.setOrgFocus();
        } else {
            $scope.setUserFocus();
        }
        $timeout(function () {
            $scope.autoFocus();
        }, 1000);
    }
    /**
     * 设置org查询焦点
     */
    $scope.setOrgFocus = function () {
        $timeout(function () {
            $("#orgSearchVal").focus();
        }, 800);
    }
    /**
     * 设置user查询焦点
     */
    $scope.setUserFocus = function () {
        $timeout(function () {
            $("#searchUserVal").focus();
        }, 800);
    }

    $scope.orgKeyPress = function (event) {
        if (event.keyCode == 13) {
            //回车自动查询
            if ($scope.searchValue) {
                $scope.showOrg = false;
                $scope.orgId = "";
                $scope.setUserFocus();
                $scope.searchUser($scope.searchValue);
            }

        }
    }
    /**
     * 选择企业
     * @param org
     */
    $scope.clickOrg = function (org) {
        $scope.orgId = org.orgId;
        $scope.showOrg = false;
        $scope.orgName = org.orgName;
        $scope.setUserFocus();
        $scope.searchUser();
    }
    /**
     * 用户查询
     */
    $scope.searchUser = function (c) {
        $scope.errMsg = "";
        var params = "node=" + $scope.orgId + "&rid=" + $scope.rid;
        $scope.userSearchVal = "";
        if (c) {
            params += "&c=" + c;
            $scope.userSearchVal = c;
        }
        var action = "selectUserByOrgId.action";
        $scope.userList = [];
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.userList = data.result;
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
                $scope.errMsg = data.errMsg;
            }
        });
    }
    //查询菜品
    $scope.filterUser = function (user) {
        if (!$scope.userSearchVal) {
            return true;
        }
        if (user.userName && user.userName.toUpperCase().indexOf($scope.userSearchVal.toUpperCase()) > -1) {
            return true;
        }
        if (user.cardCode && user.cardCode.toUpperCase().indexOf($scope.userSearchVal.toUpperCase()) > -1) {
            return true;
        }
        if (user.pinyinName && user.pinyinName.toUpperCase().indexOf($scope.userSearchVal.toUpperCase()) > -1) {
            return true;
        }

    };
    /**
     * 返回
     */
    $scope.backToOrg = function () {
        $scope.showOrg = true;
        $scope.searchValue = "";
        $scope.setOrgFocus();
    }
    /**
     *清空用户选择输入框
     */
    $scope.clearUserVal = function () {
        $scope.userSearchVal = "";
        $scope.setOrgFocus();
    }
    /**
     * 选择用户
     */
    $scope.clickUser = function (item) {
        var params = "userId=" + item.userId + "&rid=" + $scope.rid;
        var action = "oauth2CardCodeOrUserId.action";
        $scope.toaster("wait", "使用[" + item.userName + "]用户登录，请稍后");
        $scope.userList = [];
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                //登陆成功
                //设置缓存
                $scope.toaster("success", "用户[" + item.userName + "]登录成功，请点餐");
                $rootScope.loginUser = data.loginUser;
                var erList = $rootScope.loginUser.erCanteenList;

                $rootScope.currentCanteen = data.erCanteen;
                var currentId = data.erCanteen.id;
                app.caches.setItem("currentCanteen", data.erCanteen);
                var selectCanteenId = app.caches.getItem("selectCanteenId");
                if (selectCanteenId) {
                    for (var i = 0; i < erList.length; i++) {
                        var er = erList[i];
                        if (er.id == selectCanteenId) {
                            $rootScope.currentCanteen = er;
                            app.caches.setItem("currentCanteen", er);
                            break;
                        }
                    }
                }
                //根据用户食堂切换食堂
                if (currentId == $rootScope.currentCanteen.id) {
                    //刷新页面
                    $rootScope.bodyBg = false;
                    $rootScope.$state.go("app.yudingBatch");
                    $scope.running = false;
                } else {
                    var url = "doUserAction_changeCanteen.action";
                    var param = "canteenId=" + $rootScope.currentCanteen.id;
                    $http.post(url, param).success(function (data, status, headers, config) {
                        if (data.success) {
                            app.caches.setItem("currentCanteen", data.erCanteen);
                            app.caches.setItem("selectCanteenId", $rootScope.currentCanteen.id, 1);
                            $rootScope.currentCanteenId = data.erCanteen.id;
                            $rootScope.bodyBg = false;
                            //刷新页面
                            $rootScope.$state.go("app.yudingBatch");
                            $scope.running = false;

                        } else {
                            $scope.AlertMessage(data.errMsg, '错误');
                        }
                    });
                }
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
                $scope.errMsg = data.errMsg;
            }
        });
    }
    //自动焦点
    $scope.autoFocus();
}]);