app.controller('ToupiaoCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    //列表底部显示
    $scope.bottomDesc = "";
    $scope.selectBillObj = null;
    $scope.toupiaoShow = false;
    $scope.showList = true;
    $scope.dateCondition = 'seven';
    $scope.preTitle = "七日内";
    $rootScope.showMenu = false;
    //顶部菜单
    $scope.showTopMenu = false;
    /**
     * 初始化投票列表
     **/
    $scope.loadMyToupiaoList = function () {
        var url = "doErToupiaoAction_getErToupiaoByQT.action";
        param = "erToupiaoSearch.dateCondition=" + $scope.dateCondition;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.toupiaoList = [];
                if (data.list != null && data.list.length > 0) {
                    $scope.bottomDesc = "";
                } else {
                    $scope.bottomDesc = "无符合条件的数据";
                }
                $scope.toupiaoList = data.list;

            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    $scope.loadMyToupiaoList();

    /**
     * 显示投票明细
     **/
    $scope.openTouPiao = function () {
        if ($scope.selectTPObj) {
            $scope.toupiaoShow = true;
            var url = "doErToupiaoQuestionAction_getErToupiaoQuestionResult.action";
            var param = "erToupiaoQuestionSearch.tpId=" + $scope.selectTPObj.id +
                "&state=" + $scope.selectTPObj.state;
            $http.post(url, param).success(function (data, status, headers, config) {
                if (data.success) {
                    $scope.questionList = data.list;
                    if ($scope.questionList != null && $scope.questionList.length > 0) {
                        for (var i = 0; i < $scope.questionList.length; i++) {
                            var questions = $scope.questionList[i];
                            var totalNum = 0;
                            for (var j = 0; j < questions.optionList.length; j++) {
                                var options = questions.optionList[j];
                                if ($scope.selectTPObj.state == '未投票') {
                                    if (options.orderNum == 1 && questions.optionType == '单选') {
                                        options.checked = true;
                                    }
                                } else {
                                    if (options.state == 'yes') {
                                        options.checked = true;
                                        totalNum++;
                                    }
                                }

                            }
                            questions.totalNum = totalNum;
                        }
                    }
                    $scope.btnRunning = false;
                } else {
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });
        }
    }

    /**
     * 关闭投票明细
     **/
    $scope.closeToupiao = function () {
        $scope.toupiaoShow = false;
        $scope.showList = true;
    }

    /**
     * 选择投票
     **/
    $scope.selectEvent = function (toupiao) {
        for (var i = 0; i < $scope.toupiaoList.length; i++) {
            $scope.toupiaoList[i].isSelect = false;
        }
        toupiao.isSelect = true;
        $scope.selectTPObj = toupiao;
        $scope.showList = false;
        //获取投票明细
        $scope.openTouPiao();
    }
    /**
     * 切换时间条件
     **/
    $scope.changeDateCondition = function (type) {
        $scope.dateCondition = type;
        if (type == "today") {
            $scope.preTitle = '今日';
        } else if (type == "seven") {
            $scope.preTitle = '七日内';
        } else if (type == "all") {
            $scope.preTitle = '全部';
        }
        $scope.showTopMenu = false;
        $scope.loadMyToupiaoList();
    }


    //保存投票
    $scope.okToupiao = function () {
        var optList = [];
        for (var i = 0; i < $scope.questionList.length; i++) {
            var questions = $scope.questionList[i];
            var checkResult = $scope.checkQuestion(questions);
            if (checkResult) {
                $scope.AlertMessage((i + 1) + "、" + questions.question + checkResult, '错误', 'lg');
                return;
            }
            for (var j = 0; j < questions.optionList.length; j++) {
                var options = questions.optionList[j];
                if (options.checked) {
                    optList.push(options);
                }

            }
        }
        var url = "doErToupiaoResultAction_addErToupiaoResult.action";
        var param = {};
        param.optList = optList;
        $scope.btnRunning = true;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.closeToupiao();
                $scope.toaster('success', '投票成功');
                $scope.selectTPObj.state = "已投票";
                $scope.selectTPObj.tpNum++;
                $scope.openTouPiao();
            } else {
                $scope.btnRunning = false;
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }

    /**
     * 取得描述
     */
    $scope.getQuestionMulDesc = function (question) {
        //多选控制
        if (!question || !question.rule || question.rule == 'no' || question.optionType == '单选') {
            //不限
            return "";
        } else {
            if (question.rule == 'eq') {
                //等于
                return "【必选" + question.ruleNumber + "项】";
            } else if (question.rule == 'gt') {
                //大于
                return "【请选择" + question.ruleNumber + "项以上】";
            } else if (question.rule == 'lt') {
                //小于
                return "【请选择" + question.ruleNumber + "项以下】";
            }
        }
    }

    /**
     * 当前选择个数
     */
    $scope.countQuestion = function (question) {
        var result = 0;
        if (question.optionList) {
            for (var i = 0; i < question.optionList.length; i++) {
                var opt = question.optionList[i];
                if (opt.checked) {
                    result++;
                }
            }
            return result;
        } else {
            return result;
        }
    }
    //验证投票规则
    $scope.checkQuestion = function (question) {
        //多选控制
        if (!question || !question.rule || question.rule == 'no' || question.optionType == '单选') {
            //不限
            return "";
        } else {
            var count = $scope.countQuestion(question);
            if (question.rule == 'eq' && question.ruleNumber !== count) {
                //等于
                return "【必选" + question.ruleNumber + "项】";
            } else if (question.rule == 'gt' && count <= question.ruleNumber) {
                //大于
                return "【请选择" + question.ruleNumber + "项以上】";
            } else if (question.rule == 'lt' && count >= question.ruleNumber) {
                //小于
                return "【请选择" + question.ruleNumber + "项以下】";
            }
        }
    }
    //保存投票
    $scope.changeRadio = function (question, options) {
        if ($scope.selectTPObj.state != '未投票') {
            return;
        }
        if (question.optionType == '单选') {
            options.checked = true;
            if (options.checked) {
                var num = 0;
                for (var i = 0; i < question.optionList.length; i++) {
                    var opt = question.optionList[i];
                    if (options.id !== opt.id) {
                        opt.checked = false;

                    }
                }
            }
        } else {
            if (!options.checked) {
                return;
            }
            //多选控制
            if (!question || !question.rule || question.rule == 'no') {
                //不限
            } else {
                var count = $scope.countQuestion(question);
                if (question.rule == 'eq') {
                    //等于
                    if (count > (question.ruleNumber ? question.ruleNumber : 0)) {
                        options.checked = false;
                        $scope.toaster('warning', $scope.getQuestionMulDesc(question));
                    }
                } else if (question.rule == 'lt') {
                    //小于
                    if (count > (question.ruleNumber ? question.ruleNumber : 0) - 1) {
                        options.checked = false;
                        $scope.toaster('warning', $scope.getQuestionMulDesc(question));
                    }
                }
            }

        }
    }
    $scope.paihangShow = false;
    $scope.paihangTitle = "";
    /**
     * 展示排行榜
     **/
    $scope.showPaihang = function (question) {
        if (!question) {
            return;
        }
        $scope.paihangShow = true;
        $scope.showList = false;
        $scope.toupiaoShow = false;
        $scope.paihangTitle = question.question;
        $scope.paihangTitle += "排行榜";

        //查询问题所有答案的票数，按票数多少降序排序
        var url = "doErToupiaoOptionAction_getErToupiaoOptionsForSearch.action";
        var param = "erToupiaoOptionSearch.tpId=" + question.tpId +
            "&erToupiaoOptionSearch.tpQid=" + question.id +
            "&sort=TP_NUM&dir=desc";

        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.paihangOptionList = data.list;
            } else {
                //$scope.AlertMessage(data.errMsg,'错误');
            }
        });
    };
    $scope.showBigImg = function (optiont, imgUrl) {
        if (imgUrl) {
            $scope.showDetail = true;
            $scope.imgTitle = optiont;
            $scope.bigImgUrl = $scope.getToupiaoPicUrl(imgUrl, false);
        }
    };
}]);