app.controller('UserBindCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $rootScope.bodyBg = true;
    $scope.user = {};
    $scope.authError = $scope.stateParams.authError || "";
    //参数传递
    $scope.erCode = $scope.stateParams.erCode;
    $scope.openId = $scope.stateParams.openId;
    $scope.type = $scope.stateParams.type || 'wx';
    $scope.selectErCode = "";
    $scope.erRestaurant = {};
    $scope.running = false;
    $("#myform").validationEngine("attach", {
        promptPosition: "topRight",
        scroll: false
    });

    /**
     * 后台登陆方法
     * @returns {}
     */
    $scope.userBind = function () {
        var formValidate = $('#myform').validationEngine('validate');
        if (formValidate) {
            if (!$scope.user || !$scope.user.userCode || !$scope.user.password) {
                return;
            }
            //登陆方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.erCode;
            params.openId = $scope.openId;
            params.c = $scope.type;
            $scope.running = true;
            $http.post("bindWxUser.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $rootScope.loginUser = data.loginUser;
                    var erList = $rootScope.loginUser.erCanteenList;
                    app.caches.setItem("loginUserFront", data.loginUser);
                    $rootScope.currentCanteen = data.erCanteen;
                    var currentId = data.erCanteen.id;
                    app.caches.setItem("currentCanteen", data.erCanteen);
                    var selectCanteenId = app.caches.getItem("selectCanteenId");
                    if (selectCanteenId) {
                        for (var i = 0; i < erList.length; i++) {
                            var er = erList[i];
                            if (er.id == selectCanteenId) {
                                $rootScope.currentCanteen = er;
                                app.caches.setItem("currentCanteen", er);
                                break;
                            }
                        }
                    }
                    //刷新页面
                    $scope.toaster("success", "绑定成功", "绑定成功");
                    $rootScope.$state.go("app.canteenList");
                    $scope.running = false;
                } else {
                    $scope.authError = data.errMsg;
                    $scope.running = false;
                    $scope.toaster("error", "错误", $scope.authError);
                }
            });
        }
    }

    /**
     * 回车方法
     * @param {} event
     * @returns {}
     */
    $scope.keyPress = function (event) {
        if (event.keyCode == '13') {
            $scope.userLogin();
        }
    }
    /**
     *取得当前企业信息
     */
    $scope.getErInfo = function (erCode) {
        if (erCode) {
            var params = "erRestaurantSearch.erCode=" + erCode;
            $http.post("doErRestaurantAction_getRestaurantByCode.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.erRestaurant = data.erRestaurant;
                    $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
                } else {
                    $scope.AlertMessage(data.errMsg, "错误");
                }
            });
        }
    }
    $scope.getErInfo($scope.erCode);
    /**
     * 返回注册页面
     */
    $scope.returnRegister = function () {
        $rootScope.$state.go("login.userRegister", {erCode: $scope.erCode, openId: $scope.openId, type: $scope.type});
    }

    /**
     * 返回忘记密码页面
     */
    $scope.returnForgetPwd = function () {
        if ($scope.selectErCode) {
            app.caches.setItem("erCode", $scope.selectErCode);
        }

        $rootScope.$state.go("login.userForgetPwd", {erCode: $scope.erCode, openId: $scope.openId, type: $scope.type});


    }


}]);