app.controller('UserForgetPwdCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $rootScope.bodyBg = true;
    $scope.user = {};
    $scope.phoneCode = '';//验证码
    $scope.phoneCodeTxt = '获取验证码';//验证码文字
    $scope.phoneCodeUnUsed = false;//验证码
    $scope.zhuceDisable = false;//不允许注册
    $scope.authError = $scope.stateParams.authError || "";
    $scope.openId = $scope.stateParams.openId || "";
    $scope.type = $scope.stateParams.type || "wx";

    $scope.forgetOne_show = true;
    $scope.forgetTwo_show = false;
    $scope.forgetTree_show = false;

    //参数传递
    $scope.erCode = $scope.stateParams.erCode || app.caches.getItem("paramErCode");
    if ($scope.erCode) {
        app.caches.setItem("paramErCode", $scope.erCode);
    }
    $scope.selectErCode = "";
    //本地缓存
    $scope.localErCode = app.caches.getItem("erCode");
    //强制从路由取，随后从本地取
    $scope.selectErCode = $scope.erCode || $scope.localErCode;
    $scope.erRestaurant = {};
    $scope.running = false;
    $("#myform").validationEngine("attach", {
        promptPosition: "topRight",
        scroll: false
    });


    $scope.changeCode = function () {
        if ($rootScope.isApp) {
            // if (!$scope.erRestaurant || !$scope.erRestaurant.mode) {
            // $scope.imgSrc = $rootScope.canteenYunUrl + "doChowhoundAction_getVerify.action?rnd=" + Math.random();
            // } else if ($scope.erRestaurant && $scope.erRestaurant.mode == "云端") {
            // $scope.imgSrc = $rootScope.canteenYunUrl + "doChowhoundAction_getVerify.action?rnd=" + Math.random();
            // } else if ($scope.erRestaurant && $scope.erRestaurant.mode == "离线") {
            // $scope.imgSrc = $scope.erRestaurant.remoteUrl + "doChowhoundAction_getVerify.action?rnd=" + Math.random();
            // }
            $scope.imgSrc = $rootScope.remoteUrl + "doChowhoundAction_getVerify.action?rnd=" + Math.random();
        } else {
            $scope.imgSrc = "doChowhoundAction_getVerify.action?rnd=" + Math.random();
        }

    };


    /**
     * 倒计时时间
     */
    $scope.countdown = 120;
    $scope.countTime = function () {
        var myTime = setInterval(function () {
            $scope.countdown--;
            $scope.phoneCodeUnUsed = true;
            $scope.phoneCodeTxt = "距下次发送" + $scope.countdown + "s";
            if ($scope.countdown <= 0) {
                clearInterval(myTime);
                $scope.countdown = 120;
                $scope.phoneCodeTxt = "获取验证码";
                $scope.phoneCodeUnUsed = false;
            }
            $scope.$digest(); // 通知视图模型的变化
        }, 1000);
    }

    /**
     * 打开选择企业
     */
    $scope.openErSelect = function () {
        var modal = {};
        modal.erCode = $scope.selectErCode;
        $scope.openModalWindow({
            templateUrl: 'tpl/regErSelect.html',
            controller: 'regErSelectCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            $scope.selectErCode = returnData.erCode;
            $scope.erRestaurant = returnData;
            app.caches.setItem("erCode", $scope.selectErCode, 1);
            $scope.changeCode();
            $rootScope.remoteUrl = $scope.erRestaurant.remoteUrl;
            app.caches.setItem("cacheRemoteUrl", $rootScope.remoteUrl, 1);
        });
    }
    /**
     * 发送短信
     */
    $scope.sendMessage = function () {
        if (!$scope.user.userCode) {
            return;
        }
        //注册方法
        var params = {};
        params.phoneNumber = $scope.user.userCode;
        params.verifyCode = $scope.verify;
        $http.post("sendMessageForgetPwd.action", params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.countTime();
            } else {
                $scope.authError = data.errMsg;
                $scope.running = false;
                $scope.toaster("error", "错误", $scope.authError);
            }
        });
    }


    /**
     * 忘记密码提交方法（第一步）
     * @returns {}
     */
    $scope.userForgetPwd_one = function () {
        var formValidate = $('#myform_one').validationEngine('validate');

        if (formValidate) {
            if (!$scope.user || !$scope.user.userCode) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.changeCode();
                $scope.AlertMessage('必须选择一个企业', '提示');
                return;
            }
            //注册方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            params.user.restaurantId = $scope.erRestaurant.id;
            params.verifyCode = $scope.verify;
            $scope.running = true;

            $http.post("doChowhoundAction_updateForgetPwd_nextOne.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    $scope.forgetOne_show = false;
                    $scope.forgetTwo_show = true;
                    $scope.forgetTree_show = false;

                    $scope.running = false;

                    //手机验证成功，修改倒计时读秒 start
                    $scope.phoneCodeUnUsed = true;
                    $scope.phoneCodeTxt = "距下次发送" + $scope.countdown + "s";
                    $scope.countTime();
                    //手机验证成功，修改倒计时读秒 end
                } else {
                    $scope.authError = data.errMsg;
                    $scope.toaster("error", "错误", $scope.authError);
                    $scope.authError = '';//清空

                    $scope.running = false;
                }
            });
        }
    }


    /**
     * 忘记密码提交方法（第二步）
     * @returns {}
     */
    $scope.userForgetPwd_two = function () {
        var formValidate = $('#myform_two').validationEngine('validate');

        if (formValidate) {
            if (!$scope.user || !$scope.user.userCode) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.changeCode();
                $scope.AlertMessage('必须选择一个企业', '提示');
                return;
            }
            //注册方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            params.user.restaurantId = $scope.erRestaurant.id;
            params.phoneCode = $scope.phoneCode;
            params.verifyCode = $scope.verify;
            $scope.running = true;
            $http.post("doChowhoundAction_updateForgetPwd_nextTwo.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    $scope.forgetOne_show = false;
                    $scope.forgetTwo_show = false;
                    $scope.forgetTree_show = true;
                } else {
                    $scope.authError = data.errMsg;
                    $scope.toaster("error", "错误", $scope.authError);
                    $scope.authError = '';//清空
                }
            });
        }
    }

    /**
     * 忘记密码提交方法（第三步）
     * @returns {}
     */
    $scope.userForgetPwd_tree = function () {
        var formValidate = $('#setNewPassword').validationEngine('validate');

        if (formValidate) {


            if (!$scope.user || !$scope.user.userCode || !$scope.user.password) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.changeCode();
                $scope.AlertMessage('必须选择一个企业', '提示');
                return;
            }

            if (!$scope.validatePwd($scope.user.password)) {//验证密码格式
                return;
            }

            //注册方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            params.phoneCode = $scope.phoneCode;
            params.user.restaurantId = $scope.erRestaurant.id;
            params.verifyCode = $scope.verify;
            $scope.running = true;
            $http.post("doChowhoundAction_updateForgetPwd_nextTree.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.toaster("success", "密码修改成功", "请从登录页面登录");
                    $scope.returnLogin();
                    $scope.running = false;
                } else {
                    $scope.authError = data.errMsg;
                    $scope.running = false;
                    $scope.toaster("error", "错误", $scope.authError);
                    $scope.authError = '';//清空
                }
            });
        }
    }
    /**
     * 返回登录页面
     */
    $scope.returnLogin = function () {
        if ($scope.openId) {
            $rootScope.$state.go("login.bindUser", {
                erCode: $scope.selectErCode,
                openId: $scope.openId,
                type: $scope.type
            });
            return;
        }

        if ($scope.selectErCode) {
            app.caches.setItem("erCode", $scope.selectErCode);
        }
        $rootScope.$state.go("login.userLogin");

    }
    /**
     * 回车方法
     * @param {} event
     * @returns {}
     */
    $scope.keyPress = function (event) {
        if (event.keyCode == '13') {
            $scope.userForgetPwd();
        }
    }

    /**
     * 密码框失去焦点事件
     * @param {} event
     * @returns {}
     */
    $scope.passwordBlur = function (event) {
        //if($scope.user.password.length.trim==0){
        //var passwordTrim = $scope.user.password.replace(new RegExp(/\s/g), '&nbsp;')
        if ($scope.user.password == undefined || $scope.user.password == '') {
            return returnResult = false;
        } else {
            $scope.validatePwd($scope.user.password);
        }


    }

    /**
     * 验证密码
     * @param {} password
     * @returns {}
     */
    $scope.validatePwd = function (password) {
        var returnResult = true;
        var reg = /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{6,20}$/;
        if (!reg.test(password)) {
            returnResult = false;
            $scope.user.password = '';
            $scope.AlertMessage('6位以上英文与数字组合，不含空格', '提示');

        }

        return returnResult;
    }


    $scope.passwordType = 'password';
    /**
     * 密码明文和密文切换
     * @param {} password
     * @returns {}
     */
    $scope.hideShowPsw = function ($event) {
        //隐藏text block，显示password block  
        if ($scope.passwordType == "password") {
            $scope.passwordType = 'text';
        } else {
            $scope.passwordType = 'password';
        }
    }


    /**
     *取得当前企业信息
     */
    $scope.getErInfo = function (erCode) {
        $scope.changeCode();
        if (erCode) {
            var params = "erRestaurantSearch.erCode=" + erCode;

            $http.post("doErRestaurantAction_getRestaurantByCode.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.erRestaurant = data.erRestaurant;
                    $scope.user.restaurantId = data.erRestaurant.id;
                    $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
                    if ($scope.zhuceDisable) {
                        $scope.authError = "该企业不允许外部用户注册";
                    } else {
                        $scope.authError = "";
                    }

                    $scope.changeCode();
                } else {
                    $scope.AlertMessage(data.errMsg, "错误");
                }
            });
        }
    }

    //查询餐厅
    $scope.getErInfo($scope.selectErCode);
}]);


/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('regErSelectCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //接收的参数
    $scope.modal = modal;
    //企业列表
    $scope.erList = [];

    $scope.getCateen = function () {

    }
    $scope.getCateen = function () {

    }

    $scope.erChoice = true;

    $scope.erCode_choice = function (x) {

        $scope.cancel();
    }
    /**
     * 页面初始化
     */
    $scope.initPage = function () {
        console.info($scope.searchValue);
        var params = "erRestaurantSearch.erCode=" + $scope.searchValue;
        var action = "doErRestaurantAction_getRestaurantByCode.action";
        $scope.erList = [];
        $scope.errMsg = "查询中，请稍后...";
//        var params = "erRestaurant.isExternalRegister";
//        var action = "doErRestaurantAction_getErRestaurants.action";
        if ($scope.isApp) {
            action = $scope.canteenYunUrl + action;
        }
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.erList.push(data.erRestaurant);
                $scope.mode = data.erRestaurant.mode;
                $scope.erChoice = false;
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
            }
        });
    }
    $scope.changeText = function () {
        if ($scope.searchValue.length == 6) {
            var r = new RegExp("^[0-9]*$");
            if (r.test($scope.searchValue)) {
                $scope.initPage();
            } else {
                $scope.AlertMessage("必须输入数字", "提示");
            }
        }
    }
//    $scope.initPage();
    /**
     *过滤器
     */
    $scope.searchEr = function (item) {
        if (!$scope.searchValue) {
            return true;
        }
        if (item.name && item.name.indexOf($scope.searchValue) > -1) {
            return true;
        }
    }
    //选择
    $scope.selectRest = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);