app.controller('UserInfoCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $scope.showCommonAddress = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.addressList && ($scope.getLoginUser().erRestaurant.addressList.length > 0)) ? true : false;
    $scope.isSender = false;
    $scope.isQds = false;
    $scope.ableUploadImg = $rootScope.loginUser.userExt_1 && $rootScope.loginUser.userExt_1.trim().length > 0 ? false : true;
    $scope.isQds = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.isQds && ($scope.getLoginUser().erRestaurant.isQds.length > 0)) && $scope.getLoginUser().erRestaurant.isQds == 0 ? true : false;
    $scope.getLoginUser().erRestaurant.isQds
    //判断来源
    $scope.from = app.caches.getItem("from");
    //菜单状态
    $rootScope.showMenu = false;

    //验证表单
    $("#passwordForm").validationEngine("attach", {
        promptPosition: "topRight",
        scroll: false
    });
    /**
     * 取得用户信息
     */
    $scope.user = $scope.getLoginUser();
    $scope.showMain = true;
    $scope.getIsSender = function () {
        $scope.isSender = false;
        var roleList = $scope.getLoginUser().roleList;
        if ($scope.isQds) {
            for (var i = 0; i < roleList.length; i++) {
                if (roleList[i].roleId == 'SENDER') {
                    $scope.isSender = true;
                    break;
                }
            }
        } else {
            $scope.isSender = false;
        }

        //读取用户现在可否接受派单
        $scope.accOrder = $scope.getLoginUser().acceptOrder;

    }
    $scope.getIsSender();
    /**
     * 打开头像维护界面
     */
    $scope.photoShow = function () {
        if ($scope.from == 'scan' || !$scope.ableUploadImg) {
            return;
        } else {
            $scope.showPhoto = true;
            $scope.showMain = false;
            $("#imgUrlFull").attr("src", $rootScope.getUserHeadBigImg());
        }
    }
    /**
     * 保存头像
     */
    $scope.uploadPhoto = function () {
        if ($rootScope.loginUser.userExt_1 && $rootScope.loginUser.userExt_1.trim().length > 0) {
            $scope.toaster('info', "已存在头像,无法上传!");
            return false;
        }
        var needUploadImg = document.getElementById("uploadImgFile").files;
        if (needUploadImg.length == 0) {
            $scope.toaster('error', "还没有选择图片上传");
            return false;
        }
        var contentType = 'image/jpeg';
        var dataURI = canvas.toDataURL(contentType, 0.7);//图片压缩，只能使用jpg格式
        console.log(dataURI)
        var sliceSize = 512;
        //将base64编码图片转成blob对象
        var byteCharacters = atob(dataURI.split(',')[1]);
        var byteArrays = [];
        for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
            var slice = byteCharacters.slice(offset, offset + sliceSize);
            var byteNumbers = new Array(slice.length);
            for (var i = 0; i < slice.length; i++) {
                byteNumbers[i] = slice.charCodeAt(i);
            }
            var byteArray = new Uint8Array(byteNumbers);
            byteArrays.push(byteArray);
        }
        var imgBlob = new Blob(byteArrays, {type: contentType});
        var fd = new FormData();//使用h5策略上传图片文件
        fd.append("uploadImgFile", imgBlob);
        var url = "doUserAction_userImgUploadBySelf.action";
        $http.post(url, fd, {
            transformRequest: angular.identity,
            headers: {"Content-Type": undefined}
        }).success(function (data) {
            if (data.success) {
                $scope.toaster('success', '保存成功');
                //重新查询用户
                $scope.reloadUser();
                $scope.showPhoto = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    //预览图片同时做比例调整
    $scope.changePhoto = function () {
        var needUploadImg = document.getElementById("uploadImgFile").files[0];
        var r = new FileReader();
        var maxWidth = 800;//限制大小为800*600 如果不符合则等比压缩
        var maxHeight = 600;
        //获取照片方向角属性，用户旋转控制
        EXIF.getData(needUploadImg, function () {
            EXIF.getAllTags(this);
            $scope.picOrientation = EXIF.getTag(this, 'Orientation');
            //return;
        });
        r.onloadend = function () {
            var result = this.result;
            $("#imgUrlFull").attr("src", result);
            var img = new Image();
            img.src = result;
            img.onload = function () {
                var curWidth = img.width;
                var curHeight = img.height;
                var ratio = 1;
                var heightRatio = 1;
                var widthRatio = 1;
                if (curWidth > maxWidth) {//获取宽度缩放比例
                    widthRatio = maxWidth / curWidth;
                }
                if (curHeight > maxHeight) {//获取高度缩放比例
                    heightRatio = maxHeight / curHeight;
                }
                ratio = widthRatio < heightRatio ? widthRatio : heightRatio;//选择最小的缩放比
                //等比缩放图片后绘制到canvase中
                img.width = curWidth * ratio;
                img.height = curHeight * ratio;
                canvas.width = img.width;
                canvas.height = img.height;
                var ctx = canvas.getContext('2d');
                if ($scope.picOrientation && $scope.picOrientation != 1) {
                    switch ($scope.picOrientation) {
                        case 6://需要顺时针（向左）90度旋转
                            $scope.rotateImg(this, 'left', canvas, img.width, img.height);
                            break;
                        case 8://需要逆时针（向右）90度旋转
                            $scope.rotateImg(this, 'right', canvas, img.width, img.height);
                            break;
                        case 3://需要180度旋转
                            $scope.rotateImg(this, 'right', canvas, img.width, img.height);//转两次
                            $scope.rotateImg(this, 'right', canvas, img.width, img.height);
                            break;
                    }
                } else {
                    ctx.drawImage(img, 0, 0, img.width, img.height);
                }
            };
        }
        r.readAsDataURL(needUploadImg);
    }
    $scope.rotateImg = function (img, direction, canvas, cWidth, cHeight) {
        //最小与最大旋转方向，图片旋转4次后回到原方向
        var min_step = 0;
        var max_step = 3;
        if (img == null) return;
        //img的高度和宽度不能在img元素隐藏后获取，否则会出错
        var height = img.height;
        var width = img.width;
        var step = 2;
        if (step == null) {
            step = min_step;
        }
        if (direction == 'right') {
            step++;
            //旋转到原位置，即超过最大值
            step > max_step && (step = min_step);
        } else {
            step--;
            step < min_step && (step = max_step);
        }
        //旋转角度以弧度值为参数
        var degree = step * 90 * Math.PI / 180;
        var ctx = canvas.getContext('2d');
        switch (step) {
            case 0:
                canvas.width = width;
                canvas.height = height;
                ctx.drawImage(img, 0, 0, cWidth, cHeight);
                break;
            case 1:
                canvas.width = height;
                canvas.height = width;
                ctx.rotate(degree);
                ctx.drawImage(img, 0, -height, cWidth, cHeight);
                break;
            case 2:
                canvas.width = width;
                canvas.height = height;
                ctx.rotate(degree);
                ctx.drawImage(img, -width, -height, cWidth, cHeight);
                break;
            case 3:
                canvas.width = height;
                canvas.height = width;
                ctx.rotate(degree);
                ctx.drawImage(img, -width, 0, cWidth, cHeight);
                break;
        }
    }
    //名称
    $scope.nameShow = function () {
        if ($scope.from == 'scan') {
            return;
        } else {
            $scope.showName = true;
            $scope.showMain = false;
        }
    }
    //手机号
    $scope.telephoneShow = function () {
        if ($scope.from == 'scan') {
            return;
        } else {
            $scope.showTelephone = true;
            $scope.showMain = false;
        }
    }
    //营养
    $scope.yingyangShow = function () {
        if ($scope.from == 'scan') {
            return;
        } else {
            if (!$scope.user.laodongQiangdu) {
                $scope.user.laodongQiangdu = '轻体力劳动';
            }
            if (!$scope.user.xingbie) {
                $scope.user.xingbie = '男';
            }
            $scope.showyingyangCan = true;
            $scope.showMain = false;
        }
    }
    //地址
    $scope.addressShow = function () {
        if ($scope.from == 'scan') {
            return;
        } else {
            $scope.showAddress = true;
            $scope.showMain = false;
        }
    }
    //密码
    $scope.passwordShow = function () {
        if ($scope.from == 'scan') {
            return;
        } else {
            $scope.showPassword = true;
            $scope.showMain = false;
        }
    }
    /***
     * 修改地址
     */
    $scope.updateAddress = function () {
        // if (!$scope.commonAddress && !$scope.addressNew) {
        // $scope.AlertMessage('请输入新地址！', '提示');
        // return;
        // }

        var formValidate = $('#addressForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        // 确定
        var url = "doUserAction_updatePtUser.action";

        var addressNew = "";
        if ($scope.commonAddress) {
            addressNew = $scope.commonAddress;
            if ($scope.addressNew) {
                addressNew = addressNew + '-' + $scope.addressNew;
            }
        } else {
            addressNew = $scope.addressNew;
        }
        var param = "user.address=" + addressNew;

        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //删除操作
                $scope.toaster('success', '保存成功');
                //重新查询用户
                $scope.reloadUser();
                $scope.showAddress = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }

    /**选择常用地址*/
    $scope.selectCommonAddress = function () {
        $scope.commonAddressList = $scope.getLoginUser().erRestaurant.addressList;
        if (!$scope.commonAddressList) {
            return;
        }
        var modal = {};
        modal.currentCommonAddress = $scope.commonAddress;
        modal.commonAddressList = $scope.commonAddressList;
        $scope.openModalWindow({
            templateUrl: 'tpl/commonAddressSelect.html',
            controller: 'commonAddressCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {

            $scope.commonAddress = returnData.address;

        });
    };

    $scope.clearCommonAddress = function () {
        $scope.commonAddress = '';
    };
    /***
     * 更新营养餐参数
     */
    $scope.updateYingyang = function () {
        var formValidate = $('#yingyangcanForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        // 确定
        var url = "doUserAction_updatePtUser.action";
        var param = {};
        param.user = {};
        param.user.shengao = $scope.user.shengao;
        param.user.tizhong = $scope.user.tizhong;
        param.user.nianling = $scope.user.nianling;
        param.user.xingbie = $scope.user.xingbie;
        param.user.laodongQiangdu = $scope.user.laodongQiangdu;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //删除操作
                $scope.toaster('success', '保存成功,日摄入营养信息已更新！');
                //重新查询用户
                $scope.reloadUser();
                $scope.showyingyangCan = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }

    /***
     * 修改用户名
     */
    $scope.updateUserName = function () {
        var formValidate = $('#userNameForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        // 确定
        var url = "doUserAction_updatePtUser.action";
        var param = "user.userName=" + $scope.userNameNew;

        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //删除操作
                $scope.toaster('success', '保存成功');
                //重新查询用户
                $scope.reloadUser();
                $scope.showName = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }
    /***
     * 修改手机号
     */
    $scope.updateUserPhone = function () {
        var formValidate = $('#telephoneForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        // 确定
        var url = "doUserAction_updatePtUser.action";
        var param = "user.telephone=" + $scope.telephoneNew;

        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //删除操作
                $scope.toaster('success', '保存成功');
                //重新查询用户
                $scope.reloadUser();
                $scope.showTelephone = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }
    /***
     * 更新地址方法
     */
    $scope.updatePassword = function () {
        var formValidate = $('#passwordForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        // 确定
        var url = "doUserAction_updateUserPassword.action";
        var param = "oldPassword=" + $scope.oldPassword;
        param += "&newPassword=" + $scope.newPassword;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                //删除操作
                $scope.toaster('success', '保存成功');
                //重新查询用户
                $scope.reloadUser();
                $scope.showPassword = false;
                $scope.showMain = true;
            } else {
                $scope.toaster('error', data.errMsg);
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    /**
     *清空地址
     */
    $scope.clearAddressMinute = function () {
        $("#addressMinute").val("");
    }

    /**
     * 接受派单
     */
    //------------------------$scope.isQds

    $scope.acceptOrder = function () {
        if ($scope.isQds) {
            var url = "doUserAction_updateAcceptOrder.action";
            var param = {};
            param.acceptOrder = $scope.accOrder;
            console.log(param.acceptOrder);
            $http.post(url, param).success(function (data, status, headers, config) {
                if (data.success) {
                    //删除操作
                    $scope.AlertMessage('更改成功', '');
                    //更改后的user重新存入缓存
                    var user = app.caches.getItem("loginUserFront");
                    user.acceptOrder = param.acceptOrder;
                    app.caches.setItem("loginUserFront", user);
                } else {
                    $scope.toaster('error', data.errMsg);
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });
        }
    }


    /**
     * 刷新用户
     */
    $scope.reloadUser = function () {
        $scope.reloadCurrenUserInfo().then(
            function (data) {
                $scope.user = data;
            });
    }
}]);


/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('commonAddressCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //食堂列表
    $scope.commonAddressList = modal.commonAddressList;
    $scope.currentCommonAddress = modal.currentCommonAddress;
    //选择
    $scope.selectCommonAddress = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);
