app.controller('UserLoginCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $rootScope.bodyBg = true;
    $scope.user = {};
    $scope.userCode = localStorage.getItem('localUserCode') || '';//app.caches.getItem('localUserCode')||'';//本地用户名
    $scope.password = app.caches.getItem('localPassword') || '';//本地密码
    $scope.rememberMe = app.caches.getItem('rememberMe') || true;//是否记住密码
    $scope.authError = $scope.stateParams.authError || "";
    //参数传递
    $scope.erCode = $scope.stateParams.erCode || app.caches.getItem("paramErCode");

    $scope.selectErCode = "";
    $scope.zhuceDisable = true;
    //本地缓存
    $scope.localErCode = app.caches.getItem("erCode");
    //强制从路由取，随后从本地取
    $scope.selectErCode = $scope.erCode || $scope.localErCode;
    $scope.erRestaurant = {};
    $scope.running = false;
    $("#myform").validationEngine("attach", {
        promptPosition: "topRight",
        scroll: false
    });

    /**
     * 打开选择企业
     */
    $scope.openErSelect = function () {
        var modal = {};
        modal.erCode = $scope.selectErCode;
        $scope.openModalWindow({
            templateUrl: 'tpl/erSelect.html',
            controller: 'erSelectCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            $scope.selectErCode = returnData.erCode;
            $scope.erRestaurant = returnData;
            $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
            $rootScope.remoteUrl = $scope.erRestaurant.remoteUrl;
            app.caches.setItem("erCode", $scope.selectErCode, 1);
            app.caches.setItem("cacheRemoteUrl", $rootScope.remoteUrl, 1);

        });
    }
    /**
     *  首次选择
     */
    $scope.openFirstSelect = function () {
        var modal = {};
        modal.erCode = $scope.selectErCode;
        $scope.openModalWindow({
            templateUrl: 'tpl/firstSelect.html',
            controller: 'firstSelectCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            $scope.selectErCode = returnData.erCode;
            $scope.erRestaurant = returnData;
            $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
            app.caches.setItem("erCode", $scope.selectErCode, 1);
            $rootScope.remoteUrl = $scope.erRestaurant.remoteUrl;
            app.caches.setItem("cacheRemoteUrl", $rootScope.remoteUrl, 1);
        });
    }
    /**
     * 后台登陆方法
     * @returns {}
     */
    $scope.userLogin = function () {
        var formValidate = $('#myform').validationEngine('validate');
        if (formValidate) {
            $scope.user.userCode = $scope.userCode;
            $scope.user.password = $scope.password;
            if (!$scope.user || !$scope.user.userCode || !$scope.user.password) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.AlertMessage('必须选择一个企业', '提示');
                return;
            }
            //登陆方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            $scope.running = true;
            if (!$rootScope.isApp) {
                //非app的增加一个参数
                params.code = 'f';
                var logo = $("#logo").attr("src");
                $("#logo").show();
                var ver = $("#ver").attr("src");
                $("#ver").show();
                params.c = logo + "|" + ver;
            }
            $http.post("frontLogin.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $rootScope.loginUser = data.loginUser;
                    var erList = $rootScope.loginUser.erCanteenList;
                    if ($scope.rememberMe) {
                        app.caches.setItem('localUserCode', $scope.user.userCode, 1);
                        app.caches.setItem('localPassword', $scope.user.password, 1);
                    } else {
                        app.caches.setItem('localUserCode', '', 1);
                        app.caches.setItem('localPassword', '', 1);
                    }
                    app.caches.setItem('rememberMe', $scope.rememberMe, 1);
                    app.caches.setItem("loginUserFront", data.loginUser);
                    $rootScope.currentCanteen = data.erCanteen;
                    var currentId = data.erCanteen.id;
                    app.caches.setItem("currentCanteen", data.erCanteen);
                    var selectCanteenId = app.caches.getItem("selectCanteenId");
                    if (selectCanteenId) {
                        for (var i = 0; i < erList.length; i++) {
                            var er = erList[i];
                            if (er.id == selectCanteenId) {
                                $rootScope.currentCanteen = er;
                                app.caches.setItem("currentCanteen", er);
                                break;
                            }
                        }
                    }
                    //根据用户食堂切换食堂
                    if (currentId == $rootScope.currentCanteen.id) {
                        //刷新页面
//                      if(erList && erList.length > 1){
                        $rootScope.$state.go("app.canteenList");
//                      }else{
//                          $rootScope.$state.go("app.main");
//                      }
                        $scope.running = false;
                    } else {
                        var url = "doUserAction_changeCanteen.action";
                        var param = "canteenId=" + $rootScope.currentCanteen.id;
                        $http.post(url, param).success(function (data, status, headers, config) {
                            if (data.success) {
                                app.caches.setItem("currentCanteen", data.erCanteen);
                                app.caches.setItem("selectCanteenId", $rootScope.currentCanteen.id, 1);
                                $rootScope.currentCanteenId = data.erCanteen.id;
                                //刷新页面
                                if (erList && erList.length > 1) {
                                    $rootScope.$state.go("app.canteenList");
                                } else {
                                    $rootScope.$state.go("app.main");
                                }

                                $scope.running = false;
                            } else {
                                $scope.AlertMessage(data.errMsg, '错误');
                            }
                        });
                    }


                } else {
                    $scope.authError = data.errMsg;
                    $scope.running = false;
                    $scope.toaster("error", "错误", $scope.authError);
                }
            });
        }
    }

    /**
     * 返回注册页面
     */
    $scope.returnRegister = function () {
        if ($scope.selectErCode) {
            app.caches.setItem("erCode", $scope.selectErCode);
        }
        if ($scope.erCode) {
            $rootScope.$state.go("login.userRegister", {erCode: $scope.erCode});
        } else {
            $rootScope.$state.go("login.userRegister");
        }


    }

    /**
     * 返回忘记密码页面
     */
    $scope.returnForgetPwd = function () {
        if ($scope.selectErCode) {
            app.caches.setItem("erCode", $scope.selectErCode);
        }
        if ($scope.erCode) {
            $rootScope.$state.go("login.userForgetPwd", {erCode: $scope.erCode});
        } else {
            $rootScope.$state.go("login.userForgetPwd");
        }


    }


    /**
     * 回车方法
     * @param {} event
     * @returns {}
     */
    $scope.keyPress = function (event) {
        if (event.keyCode == '13') {
            $scope.userLogin();
        }
    }
    /**
     *取得当前企业信息
     */
    $scope.getErInfo = function (erCode) {
        if (erCode) {
            var params = "erRestaurantSearch.erCode=" + erCode;
            $http.post("doErRestaurantAction_getRestaurantByCode.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.erRestaurant = data.erRestaurant;
                    $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
                } else {
                    $scope.AlertMessage(data.errMsg, "错误");
                }
            });
        }
    }

    if ($scope.erCode) {
        //参数传递
        app.caches.setItem("paramErCode", $scope.erCode);
        //查询餐厅
        $scope.getErInfo($scope.selectErCode);
    } else {
        //非参数传递 判断是否有本地的ercode
        if ($scope.localErCode) {
            $scope.getErInfo($scope.selectErCode);
        } else {
            $scope.openFirstSelect();
        }

    }


}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('erSelectCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //接收的参数
    $scope.modal = modal;
    //企业列表
    $scope.erList = [];
    $scope.errMsg = "请输入6位企业码";
    /**
     * 页面初始化
     */
    $scope.initPage = function () {
        var params = "erRestaurantSearch.erCode=" + $scope.searchValue;
        var action = "doErRestaurantAction_getRestaurantByCode.action";
        if ($scope.isApp) {
            action = $scope.canteenYunUrl + action;
        }
        $scope.errMsg = "查询中，请稍后...";
        $scope.erList = [];
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.erList.push(data.erRestaurant);
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
                $scope.errMsg = data.errMsg;
            }
        });
    }
    //$scope.initPage();
    /**
     * 触发企业码查询
     */
    $scope.changeText = function () {
        if ($scope.searchValue.length == 6) {
            var r = new RegExp("^[0-9]*$");
            if (r.test($scope.searchValue)) {
                $scope.initPage();
            } else {
                $scope.AlertMessage("必须输入数字", "提示");
            }
        }
    }
    /**
     *过滤器
     */
    $scope.searchEr = function (item) {
        if (!$scope.searchValue) {
            return true;
        }
        if (item.name && item.name.indexOf($scope.searchValue) > -1) {
            return true;
        }
    }
    //选择
    $scope.selectRest = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('firstSelectCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.returnData = {};
    //接收的参数
    $scope.modal = modal;
    //企业列表
    $scope.erList = [];

    /**
     * 跳转登陆
     */
    $scope.returnLogin = function () {
        $scope.initPage();
    }
    /**
     * 页面初始化
     */
    $scope.initPage = function () {
        var action = "doErRestaurantAction_getRestaurantByCode.action";
        if ($scope.isApp) {
            action = $scope.canteenYunUrl + action;
        }

        if (!$scope.searchValue || $scope.searchValue.length != 6) {
            $scope.AlertMessage('企业码格式错误', "提示");
            return;
        }
        var params = "erRestaurantSearch.erCode=" + $scope.searchValue;
        $scope.returnData = null;
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.returnData = data.erRestaurant;
                if (!$scope.returnData || !$scope.returnData.id) {
                    $scope.AlertMessage('未找到对应的企业，请确认企业码是否正确', "提示");
                    return;
                } else {
                    $modalInstance.close($scope.returnData);
                }
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
            }
        });
    }
    /**
     * 跳转注册页面
     */
    $scope.returnZhuce = function () {
        $scope.$state.go("login.userRegister");
        $modalInstance.dismiss('cancel');
    }
    //选择
    $scope.selectRest = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);