app.controller('UserRegisterCtrl', ["$location", '$rootScope', '$scope', '$http', function ($location, $rootScope, $scope, $http) {
    $rootScope.bodyBg = true;
    $scope.user = {};
    $scope.phoneCode = '';//验证码
    $scope.phoneCodeTxt = '获取验证码';//验证码文字
    $scope.phoneCodeUnUsed = false;//验证码
    $scope.zhuceDisable = false;//不允许注册
    $scope.authError = $scope.stateParams.authError || "";
    $scope.openId = $scope.stateParams.openId || "";
    $scope.type = $scope.stateParams.type || "wx";
    //参数传递
    $scope.erCode = $scope.stateParams.erCode || app.caches.getItem("paramErCode");
    if ($scope.erCode) {
        app.caches.setItem("paramErCode", $scope.erCode);
    }
    $scope.selectErCode = "";
    //本地缓存
    $scope.localErCode = app.caches.getItem("erCode");
//    console.info(app.caches.getItem("remoteUrlInfo"));
    //强制从路由取，随后从本地取
    $scope.selectErCode = $scope.erCode || $scope.localErCode;
    $scope.erRestaurant = {};
    $scope.running = false;
    $("#myform").validationEngine("attach", {
        promptPosition: "topRight",
        scroll: false
    });

    $scope.changeCode = function () {
        if ($rootScope.isApp) {
            $scope.imgSrc = $rootScope.remoteUrl + "doChowhoundAction_getVerify.action?rnd=" + Math.random();
        } else {
            $scope.imgSrc = "doChowhoundAction_getVerify.action?rnd=" + Math.random();
        }
    };

    /**
     * 倒计时时间
     */
//    $scope.countdown = 120;
//    $scope.countTime = function(){
//        var myTime = setInterval(function() {
//            $scope.countdown--;
//            $scope.phoneCodeUnUsed=true;
//            $scope.phoneCodeTxt = "距下次发送"+ $scope.countdown+"s";
//            if($scope.countdown <= 0){
//                clearInterval(myTime);
//                $scope.countdown = 120;
//                $scope.phoneCodeTxt = "获取验证码";
//                $scope.phoneCodeUnUsed=false;
//            }
//            $scope.$digest(); // 通知视图模型的变化
//        }, 1000);
//    }

    /**
     * 打开选择企业
     */
    $scope.openErSelect = function () {
        var modal = {};
        modal.erCode = $scope.selectErCode;
        $scope.openModalWindow({
            templateUrl: 'tpl/regErSelect.html',
            controller: 'regErSelectCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            $scope.selectErCode = returnData.erCode;
            $scope.erRestaurant = returnData;
            $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
            if ($scope.zhuceDisable) {
                $scope.authError = "该企业不允许外部用户注册";
            } else {
                $scope.authError = "";
            }
            app.caches.setItem("erCode", $scope.selectErCode, 1);
            $scope.changeCode();
            $rootScope.remoteUrl = $scope.erRestaurant.remoteUrl;
            if ($scope.erRestaurant.mode == "离线") {
                app.caches.setItem("cacheRemoteUrl", $rootScope.remoteUrl, 1);
            }
            if ($rootScope.isApp) {
                $scope.getErInfo($scope.selectErCode);
            }

        });
    }
    /**
     * 发送短信
     */
    $scope.sendMessage = function () {
        if (!$scope.user.userCode) {
            return;
        }
        //注册方法
        var params = {};
        params.phoneNumber = $scope.user.userCode;
        $http.post("sendMessageZhuce.action", params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.countTime();
            } else {
                $scope.authError = data.errMsg;
                $scope.running = false;
                $scope.toaster("error", "错误", $scope.authError);
            }
        });
    }

    /**
     * 后台登陆方法
     * @returns {}
     */
    $scope.userRegister = function () {
        var formValidate = $('#myform').validationEngine('validate');
        if (formValidate) {
            if (!$scope.user || !$scope.user.userCode || !$scope.user.password) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.AlertMessage('必须选择一个企业', '提示');
                $scope.changeCode();
                return;
            }
            //注册方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            params.user.restaurantId = $scope.erRestaurant.id;
            params.phoneCode = $scope.verify;
            params.openId = $scope.openId;
            params.c = $scope.type;
            $scope.running = true;
            $http.post("doChowhoundAction_addNewSystemUserWB.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.toaster("success", "注册成功", "注册成功");
                    $scope.userLogin();
                    $scope.running = false;

                } else {
                    $scope.authError = data.errMsg;
                    $scope.running = false;
                    $scope.toaster("error", "错误", $scope.authError);
                    $scope.changeCode();
                }
            });
        }
    }

    $scope.userLogin = function () {
        var formValidate = $('#myform').validationEngine('validate');
        if (formValidate) {
            if (!$scope.user || !$scope.user.userCode || !$scope.user.password) {
                return;
            }
            if (!$scope.selectErCode) {
                $scope.AlertMessage('必须选择一个企业', '提示');
                return;
            }
            //登陆方法
            var params = {};
            params.user = $scope.user;
            params.user.erCode = $scope.selectErCode;
            $scope.running = true;
            if (!$rootScope.isApp) {
                //非app的增加一个参数
                params.code = 'f';
                var logo = $("#logo").attr("src");
                $("#logo").show();
                var ver = $("#ver").attr("src");
                $("#ver").show();
                params.c = logo + "|" + ver;
            }
            $http.post("frontLogin.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $rootScope.loginUser = data.loginUser;
                    var erList = $rootScope.loginUser.erCanteenList;
                    if ($scope.rememberMe) {
                        app.caches.setItem('localUserCode', $scope.user.userCode, 1);
                        app.caches.setItem('localPassword', $scope.user.password, 1);
                    } else {
                        app.caches.setItem('localUserCode', '', 1);
                        app.caches.setItem('localPassword', '', 1);
                    }
                    app.caches.setItem('rememberMe', $scope.rememberMe, 1);
                    app.caches.setItem("loginUserFront", data.loginUser);
                    $rootScope.currentCanteen = data.erCanteen;
                    var currentId = data.erCanteen.id;
                    app.caches.setItem("currentCanteen", data.erCanteen);
                    var selectCanteenId = app.caches.getItem("selectCanteenId");
                    if (selectCanteenId) {
                        for (var i = 0; i < erList.length; i++) {
                            var er = erList[i];
                            if (er.id == selectCanteenId) {
                                $rootScope.currentCanteen = er;
                                app.caches.setItem("currentCanteen", er);
                                break;
                            }
                        }
                    }
                    //根据用户食堂切换食堂
                    if (currentId == $rootScope.currentCanteen.id) {
                        //刷新页面
                        if (erList && erList.length > 1) {
                            $rootScope.$state.go("app.canteenList");
                        } else {
                            $rootScope.$state.go("app.main");
                        }
                        $scope.running = false;
                    } else {
                        var url = "doUserAction_changeCanteen.action";
                        var param = "canteenId=" + $rootScope.currentCanteen.id;
                        $http.post(url, param).success(function (data, status, headers, config) {
                            if (data.success) {
                                app.caches.setItem("currentCanteen", data.erCanteen);
                                app.caches.setItem("selectCanteenId", $rootScope.currentCanteen.id, 1);
                                $rootScope.currentCanteenId = data.erCanteen.id;
                                //刷新页面
                                if (erList && erList.length > 1) {
                                    $rootScope.$state.go("app.canteenList");
                                } else {
                                    $rootScope.$state.go("app.main");
                                }

                                $scope.running = false;
                            } else {
                                $scope.AlertMessage(data.errMsg, '错误');
                            }
                        });
                    }
                } else {
                    $scope.authError = data.errMsg;
                    $scope.running = false;
                    $scope.toaster("error", "错误", $scope.authError);
                }
            });
        }
    }
//	$scope.getVerify = function(){
//		url = "doChowhoundAction_getVerify.action";
//		//注册方法
//		var params = {};
//		$http.post(url,params).success(function(data, status, headers, config){
//			console.info(data);
//			if(data.success){
//				
//			}else{
//				
//			}
//		});
//	}
    /**
     * 返回登录页面
     */
    $scope.returnLogin = function () {
        if ($scope.openId) {
            $rootScope.$state.go("login.bindUser", {
                erCode: $scope.selectErCode,
                openId: $scope.openId,
                type: $scope.type
            });
            return;
        }
        if ($scope.selectErCode) {
            app.caches.setItem("erCode", $scope.selectErCode);
        }
        $rootScope.$state.go("login.userLogin");

    }
    /**
     * 回车方法
     * @param {} event
     * @returns {}
     */
    $scope.keyPress = function (event) {
        if (event.keyCode == '13') {
            $scope.userRegister();
        }
    }
    /**
     *取得当前企业信息
     */
    $scope.getErInfo = function (erCode) {
        if (erCode) {
            var params = "erRestaurantSearch.erCode=" + erCode;

            $http.post("doErRestaurantAction_getRestaurantByCode.action", params).success(function (data, status, headers, config) {
                if (data.success) {
                    //设置缓存
                    $scope.erRestaurant = data.erRestaurant;
                    $scope.user.restaurantId = data.erRestaurant.id;
                    $scope.zhuceDisable = $scope.erRestaurant.isExternalRegister == 'on' ? false : true;
                    if ($scope.zhuceDisable) {
                        $scope.authError = "该企业不允许外部用户注册";
                    } else {
                        $scope.authError = "";
                    }
                    $scope.changeCode();
                } else {
                    $scope.AlertMessage(data.errMsg, "错误");
                }
            });
        }
    }

    //查询餐厅
    $scope.getErInfo($scope.selectErCode);
//    
//    $scope.verify = "验证码";
//     $scope.changeVerify=function () {//定义了一个点击事件，获取验证码
//     	
//        var authCode="";
//        var authCodeLength=4;//取几个随机数字
//        var randomArray=[0,1,2,3,4,5,6,7,8,9,'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R', 'S','T','U','V','W','X','Y','Z'];
//        for(var i=0;i<authCodeLength;i++){
//            var index=Math.floor(Math.random()*36);//随机取一位数
//            authCode +=randomArray[index];//取四位数，并+相连
//        }
//        $scope.showAuthCode=authCode;//赋值
//        console.log($scope.showAuthCode);
//    };

    //上面是封装的获取验证码的函数，会在下面进行调用
//  (function () {
//        $scope.changeVerify();//调用点击事件。
//        $scope.enter=function (userName,userPsd) {
//            //点击登录按钮事件，将双向绑定的账号密码当做参数传入函数
//            if ($scope.writeCode.toUpperCase() ==$scope.showAuthCode){//toUpperCase()将小写转化为大写
//                //双向绑定验证码输入框，可以直接使用，这里是验证验证码
//                $http({
//                    method:"POST",
//                    url:"你的跨域地址",//$http的固定格式
//                    params:{
//                        "name":userName,
//                        "pwd":userPsd
//                        //双向绑定的参数传到下个页面
//                    }
//                }).then(function (res) {
//                    //获取服务器返回的参数
//                    console.log(res);
//                    if (res.data.code!==0){
//                        //参数不为0的时候，弹出提示
//                        alert(res.data.message);
//                    }else {
//                        //参数为0的时候，跳转页面
//                        $state.go("home.studentList");
//
//                    }
//                })
//            }else {
//                alert("验证码输入错误咯，咯咯咯");
//                $scope.changeVerify();//验证后，刷新验证码
//            }
//        }
//    }());


}]);
/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('regErSelectCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //接收的参数
    $scope.modal = modal;
    //企业列表
    $scope.erList = [];

    $scope.getCateen = function () {

    }
    $scope.getCateen = function () {

    }

    $scope.erChoice = true;

    $scope.erCode_choice = function (x) {

        $scope.cancel();
    }
    /**
     * 页面初始化
     */
    $scope.initPage = function () {
        console.info($scope.searchValue);
        var params = "erRestaurantSearch.erCode=" + $scope.searchValue;
        var action = "doErRestaurantAction_getRestaurantByCode.action";
        $scope.erList = [];
        $scope.errMsg = "查询中，请稍后...";
//        var params = "erRestaurant.isExternalRegister";
//        var action = "doErRestaurantAction_getErRestaurants.action";
        if ($scope.isApp) {
            action = $scope.canteenYunUrl + action;
        }
        $http.post(action, params).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.erList.push(data.erRestaurant);
                $scope.mode = data.erRestaurant.mode;
                $scope.erChoice = false;
            } else {
                $scope.AlertMessage(data.errMsg, "提示");
            }
        });
    }
    $scope.changeText = function () {
        if ($scope.searchValue.length == 6) {
            var r = new RegExp("^[0-9]*$");
            if (r.test($scope.searchValue)) {
                $scope.initPage();
            } else {
                $scope.AlertMessage("必须输入数字", "提示");
            }
        }
    }
//    $scope.initPage();
    /**
     *过滤器
     */
    $scope.searchEr = function (item) {
        if (!$scope.searchValue) {
            return true;
        }
        if (item.name && item.name.indexOf($scope.searchValue) > -1) {
            return true;
        }
    }
    //选择
    $scope.selectRest = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);