/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
var payApp = angular.module("payApp", []);
payApp.controller('WxPayCallCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $scope.canshu = sessionStorage.getItem('payCanshu');
    $scope.payId = sessionStorage.getItem('payId');
    if (!$scope.canshu) {
        alert("支付参数为空，请返回支付页面重试");
        return;
    }
    /**
     * 微信支付
     */
    $scope.toWxPay = function () {

        var wechatInfo = navigator.userAgent.match(/MicroMessenger\/([\d\.]+)/i);
        if (!wechatInfo) {
            $scope.AlertMessage("请使用微信登陆系统", "错误", "sm");
            return;
        } else if (wechatInfo[1] <= "5.0") {
            $scope.AlertMessage("支付仅支持微信5.0以上版本!", "错误", "sm");
            return;
        }

        //微信支付
        var url = "doWxPayAction_submitOrderWxPay.action?tradeType=JSAPI&timestamp=" + new Date().getTime();
        var canshu = $scope.canshu;
        var headers = {
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8',
                'Cache-Control': 'no-cache, no-store, max-age=0, must-revalidate',
                'Expires': '-1'
            }
        };
        $scope.toUrl = "/dinner/index.html#/app/main";
        if ($scope.payId && $scope.canshu.indexOf("BILL") > -1) {
            $scope.toUrl = "/dinner/index.html#/app/myBillList?billId=" + $scope.payId;
        }
        if ($scope.canshu.indexOf("FK") > -1) {
            $scope.toUrl = "/dinner/index.html#/app/myCard";
        }
        $scope.tokenid = '';
        $http.post(url, canshu, headers).success(function (data, status, headers, config) {
            if (data.success) {
                var payInfo = data.payInfo;
                $scope.tokenid = payInfo.token_id;
                //微信支付接口开始调用
                //调起微信支付接口
                WeixinJSBridge.invoke('getBrandWCPayRequest', {
                    "appId": payInfo.appId,        //公众号名称，由商户传入
                    "timeStamp": payInfo.timeStamp.toString(),          //时间戳，自 1970 年以来的秒数
                    "nonceStr": payInfo.nonceStr,         //随机串
                    "package": payInfo.packageValue,      //<span style="font-family:微软雅黑;">商品包信息</span>
                    "signType": 'MD5',        //微信签名方式:  MD5
                    "paySign": payInfo.paySign           //微信签名
                }, function (res) {
                    if (res.err_msg == "get_brand_wcpay_request:ok") {
                        alert('支付成功！');

                        window.location.href = $scope.toUrl;
                        return;
                    } else if (res.err_msg == "get_brand_wcpay_request:fail") {
                        //支付失败，可能是跨公众账号引起的，生成支付二维码
                        //调用二维码接口

                        return;
                    } else {
                        alert(res.err_msg);
                        return;
                    }
                });
            } else {
                alert(data.errMsg, '错误');
            }
        });
    }
    //微信支付调用
    if (typeof WeixinJSBridge == "undefined") {
        if (document.addEventListener) {
            document.addEventListener('WeixinJSBridgeReady', $scope.toWxPay, false);
        } else if (document.attachEvent) {
            document.attachEvent('WeixinJSBridgeReady', $scope.toWxPay);
            document.attachEvent('onWeixinJSBridgeReady', $scope.toWxPay);
        }
    } else {
        $scope.toWxPay();
    }
}]);