/**
 * 批量预订
 */
app.controller('YudingBatchCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $scope.hidePrice = $scope.checkIsHidePrice();

    $scope.useTypeZhekou = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.typeZhekouFlag == 'Y') ? true : false;
    //饭卡分类折扣
    $scope.typeZhekou = 1;
    //取得饭卡折扣信息
    $scope.getTypeZhekou = function () {
        //获取加班餐领餐优惠策略
        var url = "doErMealcardTypeAction_getTypeZhekou.action";
        var param = "canteenId=" + $rootScope.currentCanteen.id;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                if (data.typeZhekou !== null && data.typeZhekou !== undefined) {
                    $scope.typeZhekou = data.typeZhekou;
                }
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    if ($scope.useTypeZhekou) {
        $scope.getTypeZhekou();
    }

    //开始时间
    $scope.dateFrom = new Date().format("yyyy-MM-dd");
    var mydate = new Date();
    mydate.setDate(mydate.getDate() + 7);
    //结束时间
    $scope.dateTo = mydate.format("yyyy-MM-dd");
    $scope.canbieList = [];//餐别list
    $scope.billList = [];//订单list
    $scope.foodList = [];//菜肴列表
    $scope.foodTypeList = [];//类型列表
    $scope.countTotal = {all: 0, money: 0, billCount: 0};//点菜总数和合计
    $scope.payTypeList = [];//支付类型
    $scope.colWidth = '25%';
    $scope.colNum = 3;
    //餐别开始日期
    $(document).ready(function () {
        var opt = {
            preset: 'date', //日期
            theme: 'sense-ui', //皮肤样式
            display: 'modal', //显示方式
            mode: 'scroller', //日期选择模式
            dateFormat: 'yyyy-mm-dd', // 日期格式
            setText: '确定', //确认按钮名称
            cancelText: '取消',//取消按钮名籍我
            dateOrder: 'yymmdd', //面板中日期排列格式
            dayText: '日', monthText: '月', yearText: '年', //面板中年月日文字
            endYear: (new Date()).getFullYear() + 2, //结束年份
            startYear: (new Date()).getFullYear(),//结束年份
            onSelect: function (text, inst) {
                $scope.dateFrom = $scope.getDateFromStr(text).format("yyyy-MM-dd");
                $scope.searchCanbieAndBill();
            }
        };
        $("#dateFrom").mobiscroll().date(opt);
    });

    //餐别结束日期
    $(document).ready(function () {
        var opt = {
            preset: 'date', //日期
            theme: 'sense-ui', //皮肤样式
            display: 'modal', //显示方式
            mode: 'scroller', //日期选择模式
            dateFormat: 'yyyy-mm-dd', // 日期格式
            setText: '确定', //确认按钮名称
            cancelText: '取消',//取消按钮名籍我
            dateOrder: 'yymmdd', //面板中日期排列格式
            dayText: '日', monthText: '月', yearText: '年', //面板中年月日文字
            endYear: (new Date()).getFullYear() + 2, //结束年份
            startYear: (new Date()).getFullYear(),//结束年份
            onSelect: function (text, inst) {
                $scope.dateTo = $scope.getDateFromStr(text).format("yyyy-MM-dd");
                $scope.searchCanbieAndBill();
            }
        };
        $("#dateTo").mobiscroll().date(opt);
    });

    /**选择消费记录开始日期*/
    $scope.clickDateFrom = function ($event) {
        var inst = $('#dateFrom').mobiscroll('getInst');
        inst.show();
    };

    /**选择消费记录结束日期*/
    $scope.clickDateTo = function ($event) {
        var inst = $('#dateTo').mobiscroll('getInst');
        inst.show();
    };
    /**上一天*/
    $scope.clickPreviousDateFrom = function () {
        var datelong = $scope.getLongByDate($scope.getDateFromStr($scope.dateFrom));
        $scope.dateFrom = new Date(datelong - 24 * 60 * 60 * 1000).format("yyyy-MM-dd");
        $scope.searchCanbieAndBill();
    }
    /**下一天*/
    $scope.clickNextDateFrom = function () {
        var datelong = $scope.getLongByDate($scope.getDateFromStr($scope.dateFrom));
        $scope.dateFrom = new Date(datelong + 24 * 60 * 60 * 1000).format("yyyy-MM-dd");
        $scope.searchCanbieAndBill();
    }

    /**上一天*/
    $scope.clickPreviousDateTo = function () {
        var datelong = $scope.getLongByDate($scope.getDateFromStr($scope.dateTo));
        $scope.dateTo = new Date(datelong - 24 * 60 * 60 * 1000).format("yyyy-MM-dd");
        $scope.searchCanbieAndBill();
    }
    /**下一天*/
    $scope.clickNextDateTo = function () {
        var datelong = $scope.getLongByDate($scope.getDateFromStr($scope.dateTo));
        $scope.dateTo = new Date(datelong + 24 * 60 * 60 * 1000).format("yyyy-MM-dd");
        $scope.searchCanbieAndBill();
    }
    /**
     * 餐别和订单
     */
    $scope.searchCanbieAndBill = function () {
        $scope.dateFrom = $scope.changeToMyDate($scope.dateFrom, 'yyyy-MM-dd');
        $scope.dateTo = $scope.changeToMyDate($scope.dateTo, 'yyyy-MM-dd');
        if ($scope.dateFrom > $scope.dateTo) {
            $scope.AlertMessage("开始时间不能大于结束时间", "提示");
            return;
        }
        if ($scope.dateFrom && $scope.dateTo) {
            if ($scope.DateDiff($scope.dateFrom, $scope.dateTo) > 15) {
                $scope.AlertMessage("日期间隔不能超过15天", "提示");
                return;
            }
        }
        var url = "doChowhoundAction_getCookbookByStartAndEnd.action";
        var param = '';
        if ($scope.dateFrom) { //日期
            // var selectDate = $scope.selectDate.format("yyyy-MM-dd");
            param += "searchDateStart=" + $scope.dateFrom;
        }
        if ($scope.dateTo) { //日期
            // var selectDate = $scope.selectDate.format("yyyy-MM-dd");
            param += "&searchDateEnd=" + $scope.dateTo;
        }
        $scope.canbieList = [];
        $scope.billList = [];
        $rootScope.showLoading = true;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $rootScope.showLoading = false;
                $scope.canbieList = data.list;
                $scope.billList = data.billList;
                $scope.payTypeList = data.payMethodList;
                $scope.countTotal = {all: 0, money: 0, billCount: 0};
                if ($scope.payTypeList && $scope.payTypeList.length > 0) {
                    $scope.payTypeInit($scope.payTypeList[0]);
                }
                for (var i = 0; i < $scope.canbieList.length; i++) {
                    var cl = $scope.canbieList[i];
                    if (cl.canbieList.length && $scope.colNum < cl.canbieList.length) {
                        $scope.colNum = cl.canbieList.length;
                        $scope.colWidth = (100 / ($scope.colNum + 1)) + '%';
                    }
                    for (var j = 0; j < cl.canbieList.length; j++) {
                        var canbie = cl.canbieList[j];
                        //设置订单到餐别
                        for (var k = 0; k < $scope.billList.length; k++) {
                            var bill = $scope.billList[k];
                            if (canbie.id && bill.cookbookId == canbie.id && (bill.billState == 'a' || bill.billState == 'b')) {
                                canbie.bill = bill;
                                canbie.show = false;//不显示
                                canbie.yuding = true;//已预订
                                canbie.disable = true;//禁止使用
                                break;
                            }
                        }
                        canbie.dianCaiCount = {
                            all: 0,
                            money: 0
                        };
                    }
                }
            } else {
                $rootScope.showLoading = false;
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });

    }
    //选择分类
    $scope.selectFoodType = function (type, canbie) {
        for (var i = 0; i < canbie.foodTypeList.length; i++) {
            canbie.foodTypeList[i].selected = false;
        }
        canbie.erFoodType = type;
        canbie.erFoodType.selected = true;
    }
    /**
     * 总体订单求和
     */
    $scope.countAll = function () {
        $scope.countTotal = {all: 0, money: 0};
        for (var i = 0; i < $scope.canbieList.length; i++) {
            var cl = $scope.canbieList[i];
            for (var j = 0; j < cl.canbieList.length; j++) {
                var canbie = cl.canbieList[j];
                $scope.countTotal.all += canbie.dianCaiCount.all;
                $scope.countTotal.money += canbie.dianCaiCount.money;
            }
        }
    }
    /**
     * 求和
     */
    $scope.countFoodType = function (canbie) {
        canbie.orderList = [];
        //统计菜肴属性个数
        canbie.dianCaiCount = {
            all: 0,
            money: 0
        };
        for (var i = 0; i < canbie.foodTypeList.length; i++) {
            var type = canbie.foodTypeList[i];
            var num = 0;
            for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                var food = type.erCookbookDetailList[j];
                if (food.foodNum) {
                    num += food.foodNum;
                    canbie.dianCaiCount.all += food.foodNum;
                    if (canbie.currentCanbie.taocanOn == "Y") {
                        canbie.dianCaiCount.money = canbie.currentCanbie.taocanPrice;
                    } else {
                        canbie.dianCaiCount.money += (food.price * food.foodNum);
                    }
                    canbie.orderList.push(food);
                }
            }
            type.Num = num;
        }
        $scope.countAll();
    }
    //获取所有菜肴及分类信息（从菜谱缓存中获取）
    /**
     * 取得菜肴信息
     * @param canbie
     * @param canbieDay
     * @param forceSelect 强制选择
     */
    $scope.getFoodList = function (canbie, canbieDay, forceSelect) {
        canbie.foodList = [];
        canbie.foodTypeList = [];
        var url = "doErCookbookAction_getCookbooksFromOcs.action";
        var param = "erCookbook.id=" + canbie.id + "&erCookbook.canbieStartTime=" + canbieDay.dateStr;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                canbie.foodTypeList = data.list;
                if (canbie.foodTypeList != null && canbie.foodTypeList.length > 0) {
                    for (var i = 0; i < canbie.foodTypeList.length; i++) {
                        var type = canbie.foodTypeList[i];
                        for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                            canbie.foodList.push(type.erCookbookDetailList[j]);
                        }
                    }
                    canbie.currentCanbie = canbie.foodTypeList[0];
                    if (canbie.currentCanbie.taocanOn !== 'Y') {
                        canbie.erFoodAll = {name: "全部", erCookbookDetailList: canbie.foodList};
                        $scope.selectFoodType(canbie.erFoodAll, canbie);
                    } else {
                        $scope.selectFoodType(canbie.foodTypeList[0], canbie);
                    }
                    $scope.startEatTime = canbie.foodTypeList[0].canbieStartTime;

                }
                if ((canbie.foodList.length == 1 || forceSelect) && (!canbie.orderList || canbie.orderList.length == 0)) {
                    $scope.clickAddFoodNum(canbie.foodList[0], canbie);
                }
                $scope.countFoodType(canbie);
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    };
    //显示菜谱
    $scope.showFoodList = function (canbie, canbieDay) {
        var tempSelect = canbie.show;
        for (var i = 0; i < $scope.canbieList.length; i++) {
            var cl = $scope.canbieList[i];
            for (var j = 0; j < cl.canbieList.length; j++) {
                var temp = cl.canbieList[j];
                temp.show = false;
            }
        }
        canbie.show = !tempSelect;
        //有菜谱id
        if (canbie.show && canbie.id && (!canbie.foodTypeList || canbie.foodTypeList.length == 0)) {
            //查询菜谱信息
            $scope.getFoodList(canbie, canbieDay);
        }
    }

    /**
     * 餐别全选
     */
    $scope.selectAllCanbie = function () {
        for (var i = 0; i < $scope.canbieList.length; i++) {
            var cl = $scope.canbieList[i];
            for (var j = 0; j < cl.canbieList.length; j++) {
                var canbie = cl.canbieList[j];
                canbie.show = false;
                //有菜谱id
                if (canbie.id && !canbie.yuding && !canbie.disable && !canbie.showState) {
                    //查询菜谱信息
                    $scope.getFoodList(canbie, cl, true);
                }
            }
        }

    }

    /**
     * 判断套餐是否
     */
    $scope.checkTaocanCanEdit = function (food, canbie) {
        for (var i = 0; i < canbie.foodTypeList.length; i++) {
            var type = canbie.foodTypeList[i];
            if (type.id === food.classId) {
                if (type.classLimit) {
                    if (type.Num) {
                        if (type.Num + 1 > type.classLimit) {
                            $scope.toaster("error", "提示", "[" + type.name + "】分类不能超过" + type.classLimit + "份");
                            return false;
                        }
                    } else {
                        if (1 > type.classLimit) {
                            $scope.toaster("error", "提示", "[" + type.name + "】分类不能超过" + type.classLimit + "份");
                            return false;
                        }
                    }
                }
                break;
            }
        }
        return true;
    }


    //获取套餐分类
    $scope.getTaocanType = function (isNew, order, canbie) {
        var food = order ? order : $scope.selectFood;
        $scope.taocanCanbie = canbie;
        //  	var url = "doErTaocanConfigAction_getErTaocanConfigsForSearch.action";
//	    	var param="";
//	    	if(isNew){
//	    		param="erTaocanConfigSearch.foodId="+$scope.selectFood.foodId;
//	    	}else{
//	    		param="erTaocanConfigSearch.foodId="+order.foodId;
//	    	}
//			$http.post(url,param).success(function(data, status, headers, config){
//				if(data.success){
        $scope.taocanTypeList = food.tcConfigList;
        if ($scope.taocanTypeList != null && $scope.taocanTypeList.length > 0) {
            for (var i = 0; i < $scope.taocanTypeList.length; i++) {
                var type = $scope.taocanTypeList[i];
                if (type.foodNum == -1) {
                    type.foodNum = "";
                }
            }
        }
        $scope.selectTaocanType({id: ''});
        $scope.getTaocanFoodList(isNew, order);
//				}else{
//				     $scope.AlertMessage(data.errMsg,'错误');
//				}
//			});


    };
    /**
     * 获取所有套餐内菜肴list
     * @param isnew
     */
    $scope.getTaocanFoodList = function (isNew, order) {
        $scope.isNew = isNew;
        $scope.orderFood = order;
        var food = order ? order : $scope.selectFood;
//    	var url = "doErTaocanConfigAction_getErTaocanFoodForSearch.action";
//    	var params="";
//    	if(isNew){
//    		params="erTaocanConfigSearch.foodId="+$scope.selectFood.foodId;
//    	}else{
//    		params="erTaocanConfigSearch.foodId="+order.foodId;
//    	}

//		$http.post(url,params).success(function(data, status, headers, config){
//			if(data.success){
        $scope.taocanFoodList = food.taocanFoodList;
        for (var i = 0; i < $scope.taocanFoodList.length; i++) {
            var taocan = $scope.taocanFoodList[i];
            taocan.foodNum = 0;
        }
        if (!isNew) {
            var orderFoodList = order.tcList;
            if (orderFoodList && orderFoodList.length > 0) {
                for (var j = 0; j < orderFoodList.length; j++) {
                    var orderFood = orderFoodList[j];
                    for (var i = 0; i < $scope.taocanFoodList.length; i++) {
                        var taocan = $scope.taocanFoodList[i];
                        if (taocan.foodInId == orderFood.foodId) {
                            taocan.foodNum = orderFood.foodNum;
                            break;
                        }
                    }
                }
                $scope.countTaocan();
            }

        } else {
            $scope.autoSelectTc(food);
            $scope.countTaocan();
        }

//			}else{
//			     $scope.AlertMessage(data.errMsg,'错误');
//			}
//		});

    }

    //选中套餐分类
    $scope.selectTaocanType = function (type) {
        angular.forEach($scope.taocanTypeList, function (foodType) {
            foodType.selected = false;
        });
        $scope.taocanType = type;
        $scope.taocanType.selected = true;
        // $scope.getTaocanFoodList();
    };

    //减少套餐点菜数量
    $scope.clickMinusTaocanNum = function (food) {
        if ($scope.selectFood.autoTcSelect == 'Y' && $scope.selectFood.tcCanEdit == 'N') {
            return;
        }
        food.foodNum = food.foodNum - 1;
        food.totalMoney = food.foodNum * food.price;

        $scope.countTaocan();

    }
    //自动选择
    $scope.autoSelectTc = function (order) {
        if (order.autoTcSelect == 'Y') {
            for (var i = 0; i < $scope.taocanTypeList.length; i++) {
                var type = $scope.taocanTypeList[i];
                if (type.foodNum === 0 || !type.foodNum) {
                    type.foodNum = 9999;
                }
                type.Num = 0;
                if (type.foodNum > 0) {
                    for (var j = 0; j < $scope.taocanFoodList.length; j++) {
                        var food = $scope.taocanFoodList[j];
                        if (type.foodTypeId == food.foodTypeId) {
                            food.foodNum = 1;
                            type.Num++;
                        }
                        if (type.Num == type.foodNum) {
                            break;
                        }
                    }
                }


            }
        }
    }
    //增加套餐点菜数量
    $scope.clickAddTaocanNum = function (food) {
        if ($scope.selectFood.autoTcSelect == 'Y' && $scope.selectFood.tcCanEdit == 'N') {
            return;
        }
        for (var i = 0; i < $scope.taocanTypeList.length; i++) {
            var type = $scope.taocanTypeList[i];
            if (type.foodTypeId === food.foodTypeId) {
                if (!type.Num) {
                    type.Num = 0;
                }
                if (type.foodNum && type.Num + 1 > type.foodNum) {
                    $scope.toaster("error", "提示", "[" + type.foodTypeName + "】分类不能超过" + type.foodNum + "份");
                    return;
                }
                break;
            }
        }
        if (!food.foodNum) {
            food.foodNum = 1;
        } else {
            food.foodNum = food.foodNum + 1;
        }
        $scope.countTaocan();
    };
    $scope.countTaocan = function () {
        for (var i = 0; i < $scope.taocanTypeList.length; i++) {
            var type = $scope.taocanTypeList[i];
            var num = 0;
            for (var j = 0; j < $scope.taocanFoodList.length; j++) {
                food = $scope.taocanFoodList[j];
                if (type.foodTypeId == food.foodTypeId && food.foodNum) {
                    num += food.foodNum;
                }
            }
            type.Num = num;

        }
    };

    //套餐返回点菜页面
    $scope.backFood = function () {
        $scope.taocanOn = false;
    };

    //套餐点确定
    $scope.saveTaocan = function () {
        var taocanFoodList = [];
        for (var j = 0; j < $scope.taocanFoodList.length; j++) {
            food = $scope.taocanFoodList[j];
            if (food.foodNum) {
                var detail = {
                    foodId: food.foodInId,
                    foodName: food.foodName,
                    foodUnit: food.unit,
                    foodClassId: food.foodTypeId,
                    foodNum: food.foodNum,
                    yuanPrice: food.price,
                    price: food.price
                };
                taocanFoodList.push(detail);
            }
        }
        if (taocanFoodList.length <= 0) {
            $scope.AlertMessage('请先点菜！', '提示');
            return;
        }
        if ($scope.isNew) {
            //$scope.selectFood.foodNum = 1;

            if ($scope.selectFood.tcFoodList) {
                var nums = 0;
                for (var s = 0; s < $scope.selectFood.tcFoodList.length; s++) {
                    var fd = $scope.selectFood.tcFoodList[s];
                    if (nums < fd.orderNum) {
                        nums = fd.orderNum;
                    }
                }
                $scope.selectFood.tcFoodList.push({
                    "erBillDetailList": taocanFoodList,
                    "foodNum": $scope.selectFood.foodNum,
                    "orderNum": nums + 1
                });
            } else {
                $scope.selectFood.tcFoodList = [];
                $scope.selectFood.tcFoodList.push({
                    "erBillDetailList": taocanFoodList,
                    "foodNum": $scope.selectFood.foodNum,
                    "orderNum": 1
                });
            }
            if (!$scope.selectFood.foodNum) {
                $scope.selectFood.foodNum = 1;
            } else {
                $scope.selectFood.foodNum = $scope.selectFood.foodNum + 1;
            }
            $scope.countFoodType($scope.taocanCanbie);
            $scope.selectFood.totalMoney = $scope.selectFood.price;
        }

        $scope.backFood();
    }


    //减少点菜数量
    $scope.clickMinusFoodNum = function (food, canbie) {
        food.foodNum = food.foodNum - 1;
        food.totalMoney = food.foodNum * food.price;
        $scope.countFoodType(canbie);

    }
    //增加点菜数量
    $scope.clickAddFoodNum = function (food, canbie) {
        if (food.classId == "taocan") {
            $scope.selectFood = food;
            $scope.getTaocanType(true, null, canbie);
            $scope.taocanOn = true;
            return;
        }
        if (food.maxSingleNum && food.foodNum >= food.maxSingleNum) {
            return;
        }
        if (!$scope.checkTaocanCanEdit(food, canbie)) {
            return;
        }
        if (!food.foodNum) {
            food.foodNum = 1;
        } else {
            food.foodNum = food.foodNum + 1;
        }
        $scope.countFoodType(canbie);
        food.totalMoney = food.foodNum * food.price;
    }
    $scope.ableToOrderAndZhifu = true;
    //下单
    $scope.toOrderAndZhifu = function (cardCode, password) {
        var orderAllList = [];//全部
        //判断领餐类型并加入参数
        var dcName = "";//点餐人
        var dcPhone = "";//电话
        var address = "";//地址
        var lingquType = "";//领取类型
        var cardCode = cardCode ? cardCode : '';
        var cardPassword = password ? password : '';

        var formValidate = $('#songcanForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        for (var t = 0; t < $scope.dcType.length; t++) {
            ty = $scope.dcType[t];
            if (ty.selected) {
                if (ty.id == '送餐') {
                    dcName = $scope.dcName;
                    dcPhone = $scope.dcPhone;
                    address = $scope.address;
                }
                lingquType = ty.id;
            }
        }
        if ($scope.lcTypeShow && !lingquType) {
            $scope.AlertMessage('至少选择一种支付方式！', '提示');
            return;
        }
        //1.验证是否点菜
        for (var i = 0; i < $scope.canbieList.length; i++) {
            var cl = $scope.canbieList[i];
            for (var j = 0; j < cl.canbieList.length; j++) {
                var canbie = cl.canbieList[j];
                if (canbie.orderList && canbie.orderList.length > 0) {
                    var temp = {};
                    temp.cookbookId = canbie.id;
                    temp.cookbookDate = cl.dateStr;
                    temp.dcName = dcName;
                    temp.dcPhone = dcPhone;
                    temp.address = address;
                    temp.lingquType = lingquType;
                    if ($scope.fkPay == 'yes') {
                        temp.payType = "FK";
                    } else if ($scope.notqPay == 'yes') {
                        temp.payType = "NO";
                    }
                    var ids = "";
                    var foodNums = "";
                    for (var k = 0; k < canbie.orderList.length; k++) {
                        var order = canbie.orderList[k];

                        if (order.classId == "taocan" && order.tcFoodList) {
                            for (var l = 0; l < order.tcFoodList.length; l++) {
                                ids += order.foodId;
                                foodNums += 1 + ",";
                                var detailIds = "";
                                var detailNums = "";
                                for (var s = 0; s < order.tcFoodList[l].erBillDetailList.length; s++) {
                                    var detail = order.tcFoodList[l].erBillDetailList[s];
                                    detailIds += detail.foodId + "。";
                                    detailNums += detail.foodNum + "。";
                                }
                                detailIds = detailIds.substr(0, detailIds.length - 1);
                                detailNums = detailNums.substr(0, detailNums.length - 1);
                                ids += ":" + detailIds + "!" + detailNums + ",";
                            }

                        } else {
                            ids += order.foodId + ",";
                            foodNums += order.foodNum + ",";
                        }
                    }
                    ids = ids.substr(0, ids.length - 1);
                    foodNums = foodNums.substr(0, foodNums.length - 1);
                    temp.foodIds = ids;
                    temp.foodNums = foodNums;
                    orderAllList.push(temp);
                }
            }
        }
        if (!orderAllList || orderAllList.length == 0) {
            $scope.AlertMessage('没有点菜！', '提示');
            return;
        }
        if (!password && !cardCode && $scope.getLoginUser() && !$scope.getLoginUser().cardCode) {
            $scope.toaster('warning', '未绑定饭卡，输入卡号密码支付');
            $scope.toOtherCardPay();
            return;
        }
        var url = "doErBillInfoAction_xiadanBatch.action";
        var param = {};
        param.batchList = orderAllList;
        if (cardCode) {
            param.cardCode = cardCode;
        }
        if (cardPassword) {
            param.cardPassword = cardPassword;
        }
        $rootScope.showLoading = true;
        $scope.running = true;
        if (!$scope.ableToOrderAndZhifu) {
            return;
        }
        $scope.ableToOrderAndZhifu = false;
        $http.post(url, param).success(function (data, status, headers, config) {
            $scope.ableToOrderAndZhifu = true;
            if (data.success) {
                $rootScope.showLoading = false;
                $scope.state.go("app.myBillList", {});
                $scope.toaster('success', '预订成功！' + '共预订' + $scope.countTotal.billCount + '个餐别。');
                $scope.running = false;
            } else {
                $scope.running = false;
                $rootScope.showLoading = false;
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    //点击弹出订单信息
    $scope.clickOrder = function () {
        $scope.billShow = true;
        $scope.orderListAll = [];
        $scope.countTotal.billCount = 0;
        for (var i = 0; i < $scope.canbieList.length; i++) {
            var cl = $scope.canbieList[i];
            for (var j = 0; j < cl.canbieList.length; j++) {
                var canbie = cl.canbieList[j];
                if (canbie.orderList && canbie.orderList.length > 0) {
                    $scope.countTotal.billCount++;
                    for (var k = 0; k < canbie.orderList.length; k++) {
                        var detail = canbie.orderList[k];
                        var temp = {};
                        temp.dateStr = cl.dateStr.substr(6);
                        temp.canbieName = canbie.canbieName;
                        temp.foodName = detail.foodName;
                        temp.foodNum = detail.foodNum;
                        temp.price = detail.price;
                        temp.unit = detail.unit;
                        temp.isTaocan = canbie.taocanOn;
                        $scope.orderListAll.push(temp);
                    }


                }
            }
        }
    }
    //关闭订单弹出层
    $scope.closeOrder = function () {
        $scope.billShow = false;
    }
    //开启的领餐类型
    $scope.selectDctype = function (type) {
        if ($scope.getLoginUser()) {
            var user = $scope.getLoginUser();
            $scope.dcName = user.userName;
            $scope.dcPhone = user.telephone;
            $scope.address = user.address;
            var fs = $rootScope.currentCanteen;
            $scope.isDcType = {
                songcan: fs.isSongcan,
                tangshi: fs.isTangshi,
                ziti: fs.isZiti
            };
            if (fs.isSongcan == "on" && fs.isTangshi != "on" && fs.isZiti != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: true}, {id: '自提', selected: false}];
                $scope.lcTypeShow = true;
            } else if (fs.isTangshi == "on" && fs.isSongcan != "on" && fs.isZiti != "on") {
                $scope.dcType = [{id: '堂食', selected: true}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
            } else if (fs.isZiti == "on" && fs.isSongcan != "on" && fs.isTangshi != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: false}, {id: '自提', selected: true}];
            } else if (fs.isZiti != "on" && fs.isSongcan != "on" && fs.isTangshi != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
            } else {
                $scope.dcType = [{id: '堂食', selected: true}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
                $scope.lcTypeShow = true;
            }
        }
    }
    //修改点餐类型
    $scope.changeDcType = function (type) {
        for (var t = 0; t < $scope.dcType.length; t++) {
            ty = $scope.dcType[t];
            if (ty.id != type) {
                ty.selected = false;
            }
        }
    }

    /**
     * 初始化支付方式
     **/
    $scope.payTypeInit = function (paytype) {
        $scope.user = $scope.getLoginUser();
        var num = 0;
        $scope.zhifuType = {
            wxPayShow: false,
            zfbPayShow: false,
            fkPayShow: false,
            notqPayShow: false
        };
        $scope.wxPay = 'no';
        $scope.zfbPay = 'no';
        $scope.fkPay = 'no';
        $scope.notqPay = 'no';
        $scope.showPayType = false;
        if ($scope.user.userType == "OUT") {
            if (paytype != null && (paytype.wxOutsideEnable == "yes" || paytype.fkOutsideEnable == "yes" || paytype.alOutsideEnable == "yes" || paytype.noAdvancePayOutsideEnable == "yes")) {
                if (paytype.wxOutsideEnable == "yes" && $scope.showLogout) {
                    //   $scope.zhifuType.wxPayShow=true;
                    //  $scope.wxPay='yes';
                    //   num++;
                }
                if (paytype.fkOutsideEnable == "yes") {
                    $scope.zhifuType.fkPayShow = true;
                    if (num == 0) {
                        $scope.fkPay = 'yes';
                    }
                    num++;
                    $scope.showPayType = true;
                }
                if (paytype.alOutsideEnable == "yes") {
                    // $scope.zhifuType.zfbPayShow=true;
                    //  if(num==0){
                    //      $scope.zfbPay='yes';
                    //  }
                    //  num++;
                }
                if (paytype.noAdvancePayOutsideEnable == "yes") {
                    $scope.zhifuType.notqPayShow = true;
                    if (num == 0) {
                        $scope.notqPay = 'yes';
                    }
                    num++;
                    $scope.showPayType = true;
                }
            }
        } else {
            if (paytype != null && (paytype.wxInsideEnable == "yes" || paytype.fkInsideEnable == "yes" || paytype.alInsideEnable == "yes" || paytype.noAdvancePayInsideEnable == "yes")) {
                if (paytype.wxInsideEnable == "yes" && $scope.showLogout) {
                    //  $scope.zhifuType.wxPayShow=true;
                    //$scope.wxPay='yes';
                    // num++;
                }
                if (paytype.fkInsideEnable == "yes") {
                    $scope.zhifuType.fkPayShow = true;
                    if (num == 0) {
                        $scope.fkPay = 'yes';
                    }
                    num++;
                    $scope.showPayType = true;
                }
                if (paytype.alInsideEnable == "yes") {
                    //  $scope.zhifuType.zfbPayShow=true;
                    //   if(num==0){
                    //      $scope.zfbPay='yes';
                    //   }
                    //   num++;
                }
                if (paytype.noAdvancePayInsideEnable == "yes") {
                    $scope.zhifuType.notqPayShow = true;
                    if (num == 0) {
                        $scope.notqPay = 'yes';
                    }
                    num++;
                    $scope.showPayType = true;
                }
            }
        }
    }
    $scope.myCard = "";
    /**
     * 改变支付方式
     **/
    $scope.changePayType = function (flag) {
        $scope.wxPay = 'no';
        $scope.zfbPay = 'no';
        $scope.fkPay = 'no';
        $scope.notqPay = 'no';
        $scope.myCard = "";
        if (flag == "wx") {
            $scope.wxPay = 'yes';
        }
        if (flag == "fk") {
            //查询饭卡余额
            var url = "doErMealcardAction_getMyCard.action";
            $http.post(url).success(function (data, status, headers, config) {
                if (data.success) {
                    if (data.list && data.list.length > 0) {
                        $scope.myCard = "(余额:￥" + data.list[0].money + ")";
                    } else {
                        $scope.toaster('warning', '未绑定饭卡或饭卡不支持该餐别，输入卡号密码支付');
                        $scope.toOtherCardPay();

                        //$scope.AlertMessage("未绑定饭卡或饭卡在该餐别不能使用，请进入我的饭卡查看",'错误','lg');
                    }
                    $scope.fkPay = 'yes';
                } else {
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });
        }
        if (flag == "zfb") {
            $scope.zfbPay = 'yes';
        }
        if (flag == "notq") {
            $scope.notqPay = 'yes';
        }
    }
    /**
     * 其他饭卡支付
     */
    $scope.toOtherCardPay = function () {
        var modal = {};
        //modal.id = $scope.selectBillObj.id;
        modal.consumeTotal = $scope.countTotal.money;
        $scope.openModalWindow({
            templateUrl: 'tpl/fankaPay.html',
            controller: 'fankaPayCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {
            //其他饭卡支付
            $scope.toOrderAndZhifu(returnData.code, returnData.password);
        });
    }

    //刷新页面
    $scope.searchCanbieAndBill();
    //刷新用户，取得当时食堂
    $scope.reloadCurrenUserInfo().then(function () {
        $scope.selectDctype();
    });
}]);

/**
 * 选择其他饭卡支付弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('fankaPayCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.returnData = {};
    //接收的参数
    $scope.modal = modal;
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
    //绑定验证
    setTimeout(function () {
        $("#fkcode").focus();
        $("#fankaform").validationEngine("attach", {
            promptPosition: "topLeft",
            scroll: false
        });
    }, 500);
    $scope.ableOk = false;
    //关闭
    $scope.ok = function () {
        //绑定验证
        var formValidate = $('#fankaform').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        $scope.ableOk = true;
        $modalInstance.close($scope.modal);
    };

}]);