app.controller('balanceCtrl', ['$location', '$rootScope', '$scope', '$http',
    '$timeout', function ($location, $rootScope, $scope, $http, $timeout) {
        //不显示底部菜单栏
        $rootScope.showMenu = false;
        // 配置页面属性
        $scope.page = 1;
        $scope.pageSize = 6;
        //页面加载时默认选中未结算
        $scope.btn = true;
        //已结算明细默认隐藏
        $scope.balancedListShow = false
        // 查询结果集
        $scope.balancedList = [];// 结算方面
        $scope.balancedDetails = [];//已结算明细
        // 前提条件,已送达状态
        $scope.sendStatus = "2";
        // 未结算状态
        $scope.unbalanceStatus = 0;
        $scope.showUnbalanced = true;
        // 已结算状态
        $scope.balanceStatus = 1;
        $scope.showbalancedDetails = false;
        // 页面加载时先打开未结算明细
        $scope.$watch('$viewContentLoaded', function () {
            setTimeout($scope.getUnBalancedList($scope.unbalanceStatus,
                $scope.page, $scope.pageSize), 200);
        });


        // 查询已结算状态统计订单
        $scope.getBalancedRelation = function (page, pageSize) {
            var url = "doErTakeoutBalanceAction_getErTakeoutBalancesForSearchPaginated.action";
            var params = {};
            params.start = (page - 1) * pageSize;
            params.limit = pageSize;
            params.erTakeoutBalanceSearch = {};
            params.erTakeoutBalanceSearch.takeoutId = $scope.getLoginUser().userId;
            $http.post(url, params).success(
                function (data, status, headers, config) {
                    if (data.success) {
                        $scope.total = data.totalCount;
                        if (page * pageSize < $scope.total) {
                            $scope.more = true;
                        } else {
                            $scope.more = false;
                        }
                        for (var i = 0; i < data.list.length; i++) {
                            $scope.balancedList.push(data.list[i]);
                        }
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }
                });
        }
        // 查询已结算订单详单
        $scope.getBalancedDetails = function (relationId, page, pageSize) {
            var url = "doErTakeoutDetailAction_getErTakeoutDetailsForSearchPaginated.action";
            $scope.balancedDetails = [];
            var params = {};
            params.start = (page - 1) * pageSize;
            params.limit = pageSize;
            params.erTakeoutDetailSearch = {};
            params.erTakeoutDetailSearch.relationId = relationId;
            params.erTakeoutDetailSearch.balanceStatus = "1";
            params.erTakeoutDetailSearch.takeoutId = $scope.getLoginUser().userId;
            $http.post(url, params).success(
                function (data, status, headers, config) {
                    if (data.success) {
                        $scope.total = data.totalCount;
                        if (page * pageSize < $scope.total) {
                            $scope.more = true;
                        } else {
                            $scope.more = false;
                        }
                        for (var i = 0; i < data.list.length; i++) {
                            data.list[i].listNo = i + 1 + ($scope.page - 1) * $scope.pageSize;//订单序号
                            $scope.balancedDetails.push(data.list[i]);
                        }
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }
                });
        }
        // 查询未结算订单
        $scope.getUnBalancedList = function (balanceStatus, page, pageSize) {
            var url = "doErTakeoutDetailAction_getErTakeoutDetailsForSearchPaginated.action";
            var params = {};
            params.start = (page - 1) * pageSize;
            params.limit = pageSize;
            params.erTakeoutDetailSearch = {};
            params.erTakeoutDetailSearch.balanceStatus = balanceStatus;
            params.erTakeoutDetailSearch.takeoutId = $scope.getLoginUser().userId;
            $scope.checkOption = balanceStatus;
            params.erTakeoutDetailSearch.sendStatus = $scope.sendStatus;
            $http.post(url, params).success(
                function (data, status, headers, config) {
                    if (data.success) {
                        $scope.total = data.totalCount;
                        if (page * pageSize < $scope.total) {
                            $scope.more = true;
                        } else {
                            $scope.more = false;
                        }
                        for (var i = 0; i < data.list.length; i++) {
                            data.list[i].listNo = i + 1 + ($scope.page - 1) * $scope.pageSize;//订单序号
                            $scope.balancedList.push(data.list[i]);
                        }
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }
                });
        }
        // 显示已结算订单详单
        $scope.openBalancedDetails = function (x) {
            $scope.balancedListShow = true;
            var relationId = x.relationId;
            $scope.totalNo = x.totalNo;
            $scope.getBalancedDetails(relationId, 1, $scope.pageSize);
        }
        $scope.cancle = function () {
            $scope.balancedListShow = false;
            $scope.showUnbalanced = false;
        }


        // 显示未结算订单明细
        $scope.openUnbalancedList = function () {
            $scope.btn = !$scope.btn;
            $scope.showUnbalanced = true;
            $scope.balancedListShow = false
            $scope.more = true;
            $scope.page = 1;
            $scope.balancedList = [];
            setTimeout($scope.getUnBalancedList($scope.unbalanceStatus,
                $scope.page, $scope.pageSize), 200);
        }
        // 显示已结算订单概况
        $scope.openBalancedList = function () {
            $scope.btn = !$scope.btn;
            $scope.showUnbalanced = false;
            $scope.showbalancedDetails = false;
            $scope.more = true;
            $scope.page = 1;
            $scope.balancedList = [];
            $scope.getBalancedRelation($scope.page, $scope.pageSize)
        }
        // 刷新显示已结算订单概况
        $scope.getBalancedList = function () {
            $scope.showUnbalanced = false;
            $scope.showbalancedDetails = false;
            $scope.balancedListShow = false;
            $scope.more = true;
            $scope.page = 1;
            $scope.balancedList = [];
            $scope.getBalancedRelation($scope.page, $scope.pageSize)
        }
        // 点击加载更多订单
        $scope.findMore = function () {
            $scope.page++;
            setTimeout($scope.getUnBalancedList($scope.checkOption,
                $scope.page, $scope.pageSize), 200);
        }
        // 通过路由转至我的订单页面
        $scope.toTakeout = function () {
            $location.path("app/takeout");
        }
        // 通过路由转至抢单页面
        $scope.toTakeoutBill = function () {
            $location.path("app/takeoutBill");
        }
        // 通过路由重新定位到当前页面
        $scope.toBalance = function () {
            $location.path("app/balance");
        }

    }]);
