/**
 * 点菜及订单页面
 */

app.controller('FoodListCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    $scope.hidePrice = $scope.checkIsHidePrice();
    $scope.showCommonAddress = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.addressList && ($scope.getLoginUser().erRestaurant.addressList.length > 0)) ? true : false;
    $scope.useJiabancanLcyh = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.useJiabancanLcyh == 'Y') ? true : false;
    $scope.useTypeZhekou = ($scope.getLoginUser().erRestaurant && $scope.getLoginUser().erRestaurant.typeZhekouFlag == 'Y') ? true : false;
    //饭卡分类折扣
    $scope.typeZhekou = 1;
    //取得饭卡折扣信息
    $scope.getTypeZhekou = function () {
        //获取加班餐领餐优惠策略
        var url = "doErMealcardTypeAction_getTypeZhekou.action";
        var param = "canteenId=" + $rootScope.currentCanteen.id;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                if (data.typeZhekou !== null && data.typeZhekou !== undefined) {
                    $scope.typeZhekou = data.typeZhekou;
                }
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    if ($scope.useTypeZhekou) {
        $scope.getTypeZhekou();
    }

    //菜谱id
    $scope.cookbookId = $scope.stateParams.cookBookId;
    //餐别日期
    $scope.canbieDate = $scope.stateParams.canbieDate;
    //是否显示订单层
    $scope.billShow = false;
    //是否显示查询层
    $scope.searchShow = false;
    //领餐类型层是否显示
    $scope.lcTypeShow = false;
    //当前餐别信息
    $scope.currentCanbie = {};
    $scope.running = false;
    //是否使用营养餐
    $scope.yingyangcanCanUseMessage = $scope.yingyangcanCanUse();
    if ($scope.yingyangcanCanUseMessage.indexOf("未配置用户") > -1) {
        $scope.toaster("error", "提示", "未配置用户身体状态，请前往个人中心进行设置");
    }
    //用户营养参数
    $scope.userYingyang = {};
    /***
     * 绑定日期控件
     */
    $scope.bindDateComptents = function (startDate, endDate) {
        if (!startDate || !endDate) {
            return;
        }
        //向后推20分钟
        var mydate = $scope.getLongByDate(new Date()) + 20 * 60 * 1000;
        mydate = new Date(mydate);
        if ($scope.getLongByDate(startDate) < $scope.getLongByDate(mydate)) {
            startDate = mydate;
        }
        $(document).ready(function () {
            var opt = {
                preset: 'time', //日期
                theme: 'sense-ui', //皮肤样式
                display: 'modal', //显示方式
                mode: 'scroller', //日期选择模式
                //   dateFormat: 'yyyy-mm-dd', // 日期格式
                timeWheels: 'HHii',
                timeFormat: 'HH:ii',
                stepMinute: 10,
                minDate: startDate,
                maxDate: endDate,
                setText: '确定', //确认按钮名称
                cancelText: '取消',//取消按钮名籍我
                //  dateOrder: 'yymmdd', //面板中日期排列格式
                // dayText: '日', monthText: '月', yearText: '年', //面板中年月日文字
                endYear: (new Date()).getFullYear() + 5, //结束年份
                startYear: (new Date()).getFullYear(),//结束年份
                onSelect: function (text, inst) {
                    $scope.songcanTime = text;
                }
            };
            $("#searchDate").mobiscroll().time(opt);
        });
    }

    $scope.erCode = '';
    $scope.showAddress = true;
    //$scope.dcType=[{id:'堂食',selected:true},{id:'送餐',selected:false},{id:'自提',selected:false}];
    //开启的领餐类型
    $scope.selectDctype = function (type) {
        if ($scope.getLoginUser()) {
            var user = $scope.getLoginUser();
            $scope.dcName = user.userName;
            $scope.dcPhone = user.telephone;
            $scope.address = user.address;
            $scope.commonAddress = $rootScope.getCommonAddress(user.address);
            $scope.address = $rootScope.getRealAddress(user.address, $scope.commonAddress);
            $scope.erCode = user.erCode;
            if ($scope.erCode == '600024') {
                $scope.address = '';
                if ($scope.showCommonAddress == true) {
                    $scope.showAddress = false;
                }
            }

            var fs = $rootScope.currentCanteen;
            $scope.isDcType = {
                songcan: fs.isSongcan,
                tangshi: fs.isTangshi,
                ziti: fs.isZiti
            };
            if (fs.isSongcan == "on" && fs.isTangshi != "on" && fs.isZiti != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: true}, {id: '自提', selected: false}];
                $scope.lcTypeShow = true;
            } else if (fs.isTangshi == "on" && fs.isSongcan != "on" && fs.isZiti != "on") {
                $scope.dcType = [{id: '堂食', selected: true}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
            } else if (fs.isZiti == "on" && fs.isSongcan != "on" && fs.isTangshi != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: false}, {id: '自提', selected: true}];
            } else if (fs.isZiti != "on" && fs.isSongcan != "on" && fs.isTangshi != "on") {
                $scope.dcType = [{id: '堂食', selected: false}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
            } else {
                $scope.dcType = [{id: '堂食', selected: true}, {id: '送餐', selected: false}, {id: '自提', selected: false}];
                $scope.lcTypeShow = true;
            }
        }
    }
    $scope.jiabancanLcyhInfo = null;
    //获取加班餐领餐优惠信息
    $scope.getJiabancanLcyh = function () {
        if ($scope.useJiabancanLcyh) {
            //获取加班餐领餐优惠策略
            var url = "doErJiabanInfoAction_getErJiabanLcyhInfo.action";
            var param = "cookbookId=" + $scope.cookbookId;
            $http.post(url, param).success(function (data, status, headers, config) {
                if (data.success) {
                    $scope.jiabancanLcyhInfo = data.erJiabanInfo;
                } else {
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });

        }
    };
    $scope.getJiabancanLcyh();

    //获取优惠金额
    $scope.getYouhuiMoney = function () {
        var youhuiMoney = 0.0;
        if ($scope.jiabancanLcyhInfo && $scope.dianCaiCount && $scope.dianCaiCount.money) {
            var money = $scope.dianCaiCount.money * $scope.typeZhekou;
            if ($scope.jiabancanLcyhInfo.type == '直减') {
                youhuiMoney = $scope.jiabancanLcyhInfo.youhuiMoney;
                if (youhuiMoney > money) {
                    youhuiMoney = money;
                }
            } else if ($scope.jiabancanLcyhInfo.type == '折扣') {
                youhuiMoney = (money * ((10 - $scope.jiabancanLcyhInfo.zhekou) / 10)).toFixed(2);
            }
        }
        return youhuiMoney;
    };
    //刷新用户，取得当时食堂
    $scope.reloadCurrenUserInfo().then(function () {
        $scope.selectDctype();
    });
    //选择分类
    $scope.selectFoodType = function (type) {
        for (var i = 0; i < $scope.foodTypeList.length; i++) {
            $scope.foodTypeList[i].selected = false;
        }
        $scope.erFoodType = type;
        $scope.erFoodType.selected = true;
    }
    $scope.countFoodType = function () {
        $scope.orderList = [];
        //统计菜肴属性个数
        $scope.dianCaiCount = {
            all: 0,
            money: 0,
            nengliang: 0,
            danbaizhi: 0,
            zhifang: 0,
            tshhw: 0
        };
        for (var i = 0; i < $scope.foodTypeList.length; i++) {
            var type = $scope.foodTypeList[i];
            var num = 0;
            for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                var food = type.erCookbookDetailList[j];
                if (food.foodNum) {

                    if (food.classId == "taocan") {
                        if (food.tcFoodList.length > 0) {
                            if (food.tcFoodList) {
                                var list = food.tcFoodList;
                                for (var t = 0; t < list.length; t++) {
                                    var tc = list[t];
                                    var fNum = tc.foodNum;
                                    var foodt = {
                                        id: food.id,
                                        classId: food.classId,
                                        state: food.state,
                                        cookbookId: food.cookbookId,
                                        foodId: food.foodId,
                                        foodName: food.foodName,
                                        price: food.price,
                                        outPrice: food.outPrice,
                                        unit: food.unit,
                                        foodNum: fNum,
                                        tcList: tc.erBillDetailList,
                                        maxSingleNum: food.maxSingleNum,
                                        supplyNum: food.supplyNum,
                                        orderNum: tc.orderNum,
                                        tcConfigList: food.tcConfigList,
                                        taocanFoodList: food.taocanFoodList,
                                        nengliang: food.nengliang,
                                        danbaizhi: food.danbaizhi,
                                        zhifang: food.zhifang,
                                        tshhw: food.tshhw
                                    };
                                    foodt.tcFoodList = [];
                                    foodt.tcFoodList.push(tc);
                                    $scope.orderList.push(foodt);
                                    if (tc.erBillDetailList) {
                                        for (var m = 0; m < tc.erBillDetailList.length; m++) {
                                            var temp = tc.erBillDetailList[m];
                                            $scope.addYingyang($scope.dianCaiCount, temp);
                                            $scope.compareYingyang($scope.dianCaiCount, $scope.userYingyang);
                                        }
                                    }


                                }
                                food.tcNum = list.length;
                                num += food.tcNum;
                                $scope.dianCaiCount.all += food.tcNum;
                                $scope.dianCaiCount.money += (food.price * food.tcNum);
                                $scope.addYingyang($scope.dianCaiCount, food);
                                $scope.compareYingyang($scope.dianCaiCount, $scope.userYingyang);
                                food.tcFoodList = list;
                            }
                        } else {
//							num+=food.foodNum;
//							food.tcNum=food.foodNum;
//							food.tcList=food.tcFoodList[0].erBillDetailList;
//							food.orderNum=food.tcFoodList[0].orderNum;
//							$scope.dianCaiCount.all += food.foodNum;
//							$scope.dianCaiCount.money += (food.price*food.foodNum);
//                            $scope.addYingyang($scope.dianCaiCount,food);
//                            $scope.compareYingyang($scope.dianCaiCount,$scope.userYingyang);
//							$scope.orderList.push(food);
                        }

                    } else {
                        num += food.foodNum;
                        $scope.dianCaiCount.all += food.foodNum;
                        if ($scope.currentCanbie.taocanOn == "Y") {
                            $scope.dianCaiCount.money = $scope.getLoginUser().userType == 'OUT' ? $scope.currentCanbie.taocanOutPrice : $scope.currentCanbie.taocanPrice;
                        } else {
                            $scope.dianCaiCount.money += (food.price * food.foodNum);
                        }
                        $scope.addYingyang($scope.dianCaiCount, food);
                        $scope.compareYingyang($scope.dianCaiCount, $scope.userYingyang);
                        $scope.orderList.push(food);
                    }

                }
            }
            type.Num = num;
        }
        app.caches.setItem("orderList", $scope.orderList);
        app.caches.setItem("foodTypeList", $scope.foodTypeList);

    }
    //获取所有菜肴及分类信息（从菜谱缓存中获取）
    $scope.getFoodList = function () {
        $scope.foodList = [];
        var foodcookbookId = app.caches.getItem("foodListToCookBookId");
        if (!foodcookbookId) {
            app.caches.setItem("foodListToCookBookId", $scope.cookbookId);
        } else {
            if (foodcookbookId == $scope.cookbookId) {
                $scope.orderList = app.caches.getItem("orderList");
//		    	    if($scope.foodTypeList && $scope.foodTypeList.length>0){
//		    	    	for(var i=0;i<$scope.foodTypeList.length;i++){
//							var type=$scope.foodTypeList[i];
//							for(var j=0;j<type.erCookbookDetailList.length;j++){
//								food=type.erCookbookDetailList[j];
//								$scope.foodList.push(food);
//							}
//
//						}
//						$scope.erFoodAll={name:"全部",erCookbookDetailList:$scope.foodList};
//						$scope.selectFoodType($scope.erFoodAll);
//						$scope.startEatTime=$scope.foodTypeList[0].canbieStartTime;
//						$scope.countFoodType();
//		    	    	return;
//		    	    }
            } else {
                app.caches.setItem("foodListToCookBookId", $scope.cookbookId);
            }
        }

        var url = "doErCookbookAction_getCookbooksFromOcs.action";
        var param = "erCookbook.id=" + $scope.cookbookId + "&erCookbook.canbieStartTime.time=" + $scope.canbieDate;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                $scope.foodTypeList = data.list;
                if ($scope.foodTypeList != null && $scope.foodTypeList.length > 0) {
                    for (var i = 0; i < $scope.foodTypeList.length; i++) {
                        var type = $scope.foodTypeList[i];
                        for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                            food = type.erCookbookDetailList[j];
                            if ($scope.orderList && $scope.orderList.length > 0) {
                                food.tcFoodList = [];
                                for (var k = 0; k < $scope.orderList.length; k++) {
                                    if (food.id == $scope.orderList[k].id) {
                                        food.foodNum = $scope.orderList[k].foodNum;
                                        if (food.classId == "taocan" && $scope.orderList[k].tcFoodList && $scope.orderList[k].tcFoodList.length > 0) {
                                            food.tcFoodList.push($scope.orderList[k].tcFoodList[0]);
                                        } else {
                                            break;
                                        }

                                    }
                                }
                            }
                            $scope.foodList.push(food);
                        }
                    }
                    $scope.currentCanbie = $scope.foodTypeList[0];
                    $scope.userYingyang = $scope.userYingyangInfo($scope.currentCanbie.canbieStartTime);
                    if ($scope.currentCanbie.taocanOn !== 'Y') {
                        $scope.erFoodAll = {name: "全部", erCookbookDetailList: $scope.foodList};
                        $scope.selectFoodType($scope.erFoodAll);
                    } else {
                        $scope.selectFoodType($scope.foodTypeList[0]);
                    }


                    $scope.startEatTime = $scope.foodTypeList[0].canbieStartTime;
                    $scope.startEndTime = $scope.foodTypeList[0].canbieEndTime;
                }
                $scope.countFoodType();
                //绑定控件
                $scope.bindDateComptents(new Date($scope.startEatTime.time), new Date($scope.startEndTime.time));
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });


    };
    $scope.getFoodList();


    /**
     * 判断套餐是否
     */
    $scope.checkTaocanCanEdit = function (food) {
        for (var i = 0; i < $scope.foodTypeList.length; i++) {
            var type = $scope.foodTypeList[i];
            if (type.id === food.classId) {
                if (type.classLimit) {
                    if (type.Num) {
                        if (type.Num + 1 > type.classLimit) {
                            $scope.toaster("error", "提示", "[" + type.name + "】分类不能超过" + type.classLimit + "份");
                            return false;
                        }
                    } else {
                        if (1 > type.classLimit) {
                            $scope.toaster("error", "提示", "[" + type.name + "】分类不能超过" + type.classLimit + "份");
                            return false;
                        }
                    }
                }
                break;
            }
        }
        return true;
    }

    $scope.editTaocan = function (order) {
        $scope.getTaocanType(false, order);
        $scope.taocanOn = true;
        $scope.closeOrder();

    }

    //获取套餐分类
    $scope.getTaocanType = function (isNew, order) {
        var food = order ? order : $scope.selectFood;
        $scope.taocanTypeList = food.tcConfigList;
        if ($scope.taocanTypeList != null && $scope.taocanTypeList.length > 0) {
            for (var i = 0; i < $scope.taocanTypeList.length; i++) {
                var type = $scope.taocanTypeList[i];
                if (type.foodNum == -1) {
                    type.foodNum = "";
                }
            }
        }
        $scope.selectTaocanType({id: ''});
        $scope.getTaocanFoodList(isNew, order);
    };
    /**
     * 获取所有套餐内菜肴list
     * @param isnew
     */
    $scope.getTaocanFoodList = function (isNew, order) {
        $scope.isNew = isNew;
        $scope.orderFood = order;
        var food = order ? order : $scope.selectFood;
        $scope.taocanFoodList = food.taocanFoodList;
        for (var i = 0; i < $scope.taocanFoodList.length; i++) {
            var taocan = $scope.taocanFoodList[i];
            taocan.foodNum = 0;
        }
        if (!isNew) {
            var orderFoodList = order.tcList;
            if (orderFoodList && orderFoodList.length > 0) {
                for (var j = 0; j < orderFoodList.length; j++) {
                    var orderFood = orderFoodList[j];
                    for (var i = 0; i < $scope.taocanFoodList.length; i++) {
                        var taocan = $scope.taocanFoodList[i];
                        if (taocan.foodInId == orderFood.foodId) {
                            taocan.foodNum = orderFood.foodNum;
                            break;
                        }
                    }
                }
                $scope.countTaocan();
            }

        } else {
            $scope.autoSelectTc(food);
            $scope.countTaocan();
        }
    }


    //减少套餐点菜数量
    $scope.clickMinusTaocanNum = function (food) {
        if ($scope.selectFood.autoTcSelect == 'Y' && $scope.selectFood.tcCanEdit == 'N') {
            return;
        }
        food.foodNum = food.foodNum - 1;
        food.totalMoney = food.foodNum * food.price;

        $scope.countTaocan();

    }

    //选中套餐分类
    $scope.selectTaocanType = function (type) {
        angular.forEach($scope.taocanTypeList, function (foodType) {
            foodType.selected = false;
        });
        $scope.taocanType = type;
        $scope.taocanType.selected = true;
        // $scope.getTaocanFoodList();
    };
    //自动选择
    $scope.autoSelectTc = function (order) {
        if (order.autoTcSelect == 'Y') {
            for (var i = 0; i < $scope.taocanTypeList.length; i++) {
                var type = $scope.taocanTypeList[i];
                if (type.foodNum === 0 || !type.foodNum) {
                    type.foodNum = 9999;
                }
                type.Num = 0;
                if (type.foodNum > 0) {
                    for (var j = 0; j < $scope.taocanFoodList.length; j++) {
                        var food = $scope.taocanFoodList[j];
                        if (type.foodTypeId == food.foodTypeId) {
                            food.foodNum = 1;
                            type.Num++;
                        }
                        if (type.Num == type.foodNum) {
                            break;
                        }
                    }
                }


            }
        }
    }
    //增加套餐点菜数量
    $scope.clickAddTaocanNum = function (food) {
        if ($scope.selectFood.autoTcSelect == 'Y' && $scope.selectFood.tcCanEdit == 'N') {
            return;
        }

        if (food.maxSingleNum && food.maxSingleNum > 0 && food.foodNum && food.foodNum >= food.maxSingleNum) {
            return;
        }
        for (var i = 0; i < $scope.taocanTypeList.length; i++) {
            var type = $scope.taocanTypeList[i];
            if (type.foodTypeId === food.foodTypeId) {
                if (!type.Num) {
                    type.Num = 0;
                }
                if (type.foodNum && type.Num + 1 > type.foodNum) {
                    $scope.toaster("error", "提示", "[" + type.foodTypeName + "】分类不能超过" + type.foodNum + "份");
                    return;
                }
                break;
            }
        }
        if (!food.foodNum) {
            food.foodNum = 1;
        } else {
            food.foodNum = food.foodNum + 1;
        }
        $scope.countTaocan();
    };
    $scope.countTaocan = function () {
        for (var i = 0; i < $scope.taocanTypeList.length; i++) {
            var type = $scope.taocanTypeList[i];
            var num = 0;
            for (var j = 0; j < $scope.taocanFoodList.length; j++) {
                food = $scope.taocanFoodList[j];
                if (type.foodTypeId == food.foodTypeId && food.foodNum) {
                    num += food.foodNum;
                }
            }
            type.Num = num;

        }
    };

    //套餐返回点菜页面
    $scope.backFood = function () {
        $scope.changeShow("main");
    };

    //套餐点确定
    $scope.saveTaocan = function () {
        var taocanFoodList = [];
        for (var j = 0; j < $scope.taocanFoodList.length; j++) {
            food = $scope.taocanFoodList[j];
            if (food.foodNum) {
                var detail = {
                    foodId: food.foodInId,
                    foodName: food.foodName,
                    foodUnit: food.unit,
                    foodClassId: food.foodTypeId,
                    foodNum: food.foodNum,
                    yuanPrice: food.price,
                    price: food.price,
                    nengliang: food.nengliang,
                    danbaizhi: food.danbaizhi,
                    zhifang: food.zhifang,
                    tshhw: food.tshhw
                };
                taocanFoodList.push(detail);
            }
        }
        if (taocanFoodList.length <= 0) {
            $scope.AlertMessage('请先点菜！', '提示');
            return;
        }
        if ($scope.isNew) {
            $scope.selectFood.foodNum = 1;

            if ($scope.selectFood.tcFoodList) {
                var nums = 0;
                for (var s = 0; s < $scope.selectFood.tcFoodList.length; s++) {
                    var fd = $scope.selectFood.tcFoodList[s];
                    if (nums < fd.orderNum) {
                        nums = fd.orderNum;
                    }
                }
                $scope.selectFood.tcFoodList.push({
                    "erBillDetailList": taocanFoodList,
                    "foodNum": $scope.selectFood.foodNum,
                    "orderNum": nums + 1
                });
            } else {
                $scope.selectFood.tcFoodList = [];
                $scope.selectFood.tcFoodList.push({
                    "erBillDetailList": taocanFoodList,
                    "foodNum": $scope.selectFood.foodNum,
                    "orderNum": 1
                });
            }
            $scope.countFoodType();
            $scope.selectFood.totalMoney = $scope.selectFood.price;
        } else {
            for (var i = 0; i < $scope.foodTypeList.length; i++) {
                var type = $scope.foodTypeList[i];
                for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                    food = type.erCookbookDetailList[j];
                    if (food.id == $scope.orderFood.id) {
                        for (var t = 0; t < food.tcFoodList.length; t++) {
                            if (food.tcFoodList[t].orderNum == $scope.orderFood.orderNum) {
                                food.tcFoodList[t].erBillDetailList = taocanFoodList;
                                break;
                            }
                        }
                        break;
                    }

                }
            }
            $scope.countFoodType();
        }

        $scope.backFood();
    }
    //减少订单点菜数量
    $scope.clickMinusOrderNum = function (food) {
        food.foodNum = food.foodNum - 1;
        food.totalMoney = food.foodNum * food.price;
        $scope.MinusOrderNum(food);

        $scope.countFoodType();
        if (food.foodNum == 0) {
            $scope.selectFood = null;
        } else {
            $scope.selectFood = food;
        }

    }

    //减少订单套餐数量
    $scope.MinusOrderNum = function (order) {
        for (var i = 0; i < $scope.foodTypeList.length; i++) {
            var type = $scope.foodTypeList[i];
            for (var j = 0; j < type.erCookbookDetailList.length; j++) {
                var food = type.erCookbookDetailList[j];
                if (order.foodId == food.foodId) {
                    food.tcNum = food.tcNum - 1;
                    if (food.tcFoodList.length > 0) {
                        for (var t = 0; t < food.tcFoodList.length; t++) {
                            var tc = food.tcFoodList[t];
                            if (tc.orderNum == order.orderNum) {
                                food.tcFoodList.splice(t, 1);
                            }
                        }
                    } else {
                        food.tcFoodList = [];
                    }
                }

            }

        }

    }


    //减少点菜数量
    $scope.clickMinusFoodNum = function (food) {
        food.foodNum = food.foodNum - 1;
        food.totalMoney = food.foodNum * food.price;

        $scope.countFoodType();
        if (food.foodNum == 0) {
            $scope.selectFood = null;
        } else {
            $scope.selectFood = food;
        }

    }
    //增加点菜数量
    $scope.clickAddFoodNum = function (food) {
        if (food.maxSingleNum && food.foodNum >= food.maxSingleNum) {
            return;
        }
        if (food.classId == "taocan") {
            $scope.selectFood = food;
            $scope.getTaocanType(true, null);
            $scope.changeShow()
            return;
        }
        if (!$scope.checkTaocanCanEdit(food)) {
            return;
        }
        if (!food.foodNum) {
            food.foodNum = 1;
        } else {
            food.foodNum = food.foodNum + 1;
        }
        $scope.countFoodType();
        food.totalMoney = food.foodNum * food.price;
        $scope.selectFood = food;
    }

    //点击弹出订单信息
    $scope.clickOrder = function () {
        $scope.compareYingyang($scope.dianCaiCount, $scope.userYingyang);
        if ($scope.dianCaiCount.yingyangMessage) {
            $scope.toaster('warning', $scope.dianCaiCount.yingyangMessage);
        }
        $scope.billShow = true;
    }
    //关闭订单弹出层
    $scope.closeOrder = function () {
        $scope.billShow = false;
    }
    //下单
    $scope.toOrder = function () {

        if (!$scope.orderList || $scope.orderList.length == 0) {
            $scope.AlertMessage('请先点菜！', '提示');
            return;
        }

        //常用地址和地址二选一
        for (var t = 0; t < $scope.dcType.length; t++) {
            ty = $scope.dcType[t];
            if (ty.selected) {
                if (ty.id == '送餐') {
                    if (!$scope.commonAddress && !$scope.address) {
                        $scope.AlertMessage('请输入送餐地址！', '提示');
                        return;
                    }

                    if (!$scope.songcanTime) {
                        $scope.AlertMessage('请选择送餐时间！', '提示');
                        return;
                    }
                }
            }
        }

        var formValidate = $('#songcanForm').validationEngine('validate');
        if (!formValidate) {
            return;
        }
        var url = "doErBillInfoAction_xiadan.action";
        var param = "erBillInfo.cookbookId=" + $scope.cookbookId +
            "&erBillInfo.cookbookDate.time=" + $scope.startEatTime.time;
        var ids = "";
        var foodNums = "";


        for (var i = 0; i < $scope.orderList.length; i++) {
            var order = $scope.orderList[i];
            ids += order.foodId;
            foodNums += order.foodNum + ",";
            if (order.classId == "taocan") {
                var detailIds = "";
                var detailNums = "";
                for (var s = 0; s < order.tcList.length; s++) {
                    var detail = order.tcList[s];
                    detailIds += detail.foodId + "。";
                    detailNums += detail.foodNum + "。";
                }
                detailIds = detailIds.substr(0, detailIds.length - 1);
                detailNums = detailNums.substr(0, detailNums.length - 1);
                ids += ":" + detailIds + "!" + detailNums;
            }
            ids += ",";
        }
        ids = ids.substr(0, ids.length - 1);
        foodNums = foodNums.substr(0, foodNums.length - 1);
        param += "&foodIds=" + ids + "&foodNums=" + foodNums;
        if (!$scope.yingyangcanCanUseMessage) {
            param += "&erBillInfo.nengliang=" + ($scope.dianCaiCount.nengliang ? $scope.dianCaiCount.nengliang : 0);
            param += "&erBillInfo.danbaizhi=" + ($scope.dianCaiCount.danbaizhi ? $scope.dianCaiCount.danbaizhi : 0);
            param += "&erBillInfo.zhifang=" + ($scope.dianCaiCount.zhifang ? $scope.dianCaiCount.zhifang : 0);
            param += "&erBillInfo.tshhw=" + ($scope.dianCaiCount.tshhw ? $scope.dianCaiCount.tshhw : 0);
        }


        //判断领餐类型并加入参数
        for (var t = 0; t < $scope.dcType.length; t++) {
            ty = $scope.dcType[t];
            if (ty.selected) {
                if (ty.id == '送餐') {
                    param += "&erBillInfo.dcName=" + $scope.dcName + "&erBillInfo.dcPhone=" + $scope.dcPhone +
                        "&erBillInfo.songcanTime=" + $scope.songcanTime;
                    if ($scope.commonAddress) {
                        param += "&erBillInfo.commonAddress=" + $scope.commonAddress;
                    }
                    if ($scope.address) {
                        param += "&erBillInfo.address=" + $scope.address;
                    }
                }
                param += "&erBillInfo.lingquType=" + ty.id;
            }
        }
        $scope.running = true;
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                var erBillInfo = data.erBillInfo;
                app.caches.removeItem("orderList");//清空缓存
                app.caches.removeItem("foodListToCookBookId");
                $scope.state.go("app.myBillList", {billId: erBillInfo.id});
                if (erBillInfo.billState == 'b') {
                    $scope.toaster('success', '提交成功，请支付订单！');
                } else {
                    $scope.toaster('success', '预订成功！');
                }
                $scope.running = false;
                //提交订单后如果有地址需要重新加载用户信息
                /**if(erBillInfo.address || erBillInfo.commonAddress){
                	$scope.reloadCurrenUserInfo();
                }**/
            } else {
                $scope.running = false;
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    //修改点餐类型
    $scope.changeDcType = function (type) {
        for (var t = 0; t < $scope.dcType.length; t++) {
            ty = $scope.dcType[t];
            if (ty.id != type) {
                ty.selected = false;
            }
        }
    }
    $scope.backMail = function () {
        $rootScope.$state.go("app.main");
    }
    //点击查询按钮
    $scope.clickSearchButton = function () {
        $scope.searchShow = true;
    }
    //查询菜品
    $scope.searchFood = function (food) {
        if (!$scope.searchValue) {
            return true;
        }
        if (food.foodName && food.foodName.indexOf($scope.searchValue) > -1) {
            return true;
        }

    };
    //关闭查询弹出层
    $scope.closeSearch = function () {
        $scope.searchShow = false;
    }
    //保存地址
    $scope.saveAddress = function () {
        if (!$scope.dcName) {

        }
        if (!$scope.dcPhone) {

        }
        if (!$scope.commonAddress && !$scope.address) {
            $scope.AlertMessage('请输入送餐地址！', '提示');
            return;
        }
    }

    //验证
    $scope.validateSongcan = function () {
        if (!$scope.dcName) {
            $scope.toaster('error', '*姓名必须填写');
            return false;
        }
        if (!$scope.dcPhone) {
            $scope.toaster('error', '*手机号码必须填写');
            return false;
        } else {
            var myreg = /(^1[0-9]{1}[0-9]{1}[0-9]{8}$)|(^0\d{2,3}-?\d{7,8}$)/;
            if (!myreg.test($scope.dcPhone)) {
                $scope.toaster('error', '*无效的电话号码');
                return false;
            }
        }
        if (!$scope.commonAddress && !$scope.address) {
            $scope.toaster('error', '*请输入送餐地址');
            return false;
        }
        return true;
    }
    /**
     * 选择菜肴
     * @param item
     */
    $scope.selectDetail = function (item) {
        $scope.selectedDetail = item;
        $scope.showDetail = true;
    }
    /**选择日期*/
    /**选择日期*/
    $scope.clickDate = function ($event) {
        var inst = $('#searchDate').mobiscroll('getInst');

        inst.show();
    };
    /**选择常用地址*/
    $scope.selectCommonAddress = function () {
        $scope.commonAddressList = $scope.getLoginUser().erRestaurant.addressList;
        if (!$scope.commonAddressList) {
            return;
        }
        var modal = {};
        modal.currentCommonAddress = $scope.commonAddress;
        modal.commonAddressList = $scope.commonAddressList;
        $scope.openModalWindow({
            templateUrl: 'tpl/commonAddressSelect.html',
            controller: 'commonAddressCtrl',
            size: "",
            resolve: {
                modal: function () {
                    return modal;
                }
            }
        }).result.then(function (returnData) {

            $scope.commonAddress = returnData.address;

        });
    };

    $scope.clearCommonAddress = function () {
        $scope.commonAddress = '';
    };
}]);

/**
 * 弹窗ctrl
 * @param {} $scope
 * @param {} $modalInstance
 * @param {} modal
 * @returns {}
 */
app.controller('commonAddressCtrl', ['$scope', '$modalInstance', 'modal', '$http', function ($scope, $modalInstance, modal, $http) {
    $scope.modal = {};
    //食堂列表
    $scope.commonAddressList = modal.commonAddressList;
    $scope.currentCommonAddress = modal.currentCommonAddress;
    //选择
    $scope.selectCommonAddress = function (item) {
        $modalInstance.close(item);
    }
    //关闭
    $scope.cancel = function () {
        $modalInstance.dismiss('cancel');
    };
}]);