app.controller('MyMessageCtrl', ['$rootScope', '$scope', '$http', function ($rootScope, $scope, $http) {
    //判断是否选择第一条
    $scope.flag = $scope.stateParams.flag;
    //列表底部显示
    $scope.bottomDesc = "";
    //菜单状态
    $rootScope.showMenu = false;
    $scope.selectMess = null;
    $scope.MessShow = false;
    $scope.currentState = "未读";
    //当前页码
    $scope.currentPage = 1;
    //一页显示的条数
    $scope.limit = 10;
    //一共多少页
    $scope.pageCount = 1;
    //展示的订单列表
    $scope.messList = [];

    $scope.dateCondition = "all";

    /**
     * 初始化我的消息
     **/
    $scope.loadMyMessList = function () {
        var url = "doChowhoundAction_getCookbookMess.action";
        var start = ($scope.currentPage - 1) * $scope.limit;
        var param = "start=" + start + "&limit=" + $scope.limit;
        if ($scope.currentState) {
            param += "&state=" + $scope.currentState;
        }
        param += "&searchValue=all";
        $http.post(url, param).success(function (data, status, headers, config) {
            if (data.success) {
                var totalCount = data.totalCount;
                if (totalCount == 0) {
                    $scope.bottomDesc = "无符合条件的消息";
                } else {
                    $scope.bottomDesc = "";
                }
                $scope.pageCount = Math.ceil(totalCount / $scope.limit);
                var list = data.list;
                var canbieStr = "";
                var classPre = 'wu bg_0';
                var canbieIndex = 0;
                for (var i = 0; i < list.length; i++) {
                    var record = list[i];
                    if (record.sendTime) {
                        record.sendTime = new Date(record.sendTime.time).format("yyyy-MM-dd HH:mm");
                        record.date = record.sendTime.substr(5, 5);
                        record.year = record.sendTime.substr(0, 4);
                    }
                    record.isSelect = false;
                    $scope.messList.push(record);
                }
                if ($scope.flag && $scope.flag == 1) {
                    $scope.selectMessEvent($scope.messList[0]);
                }
                $scope.flag = "";
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    /**
     * 拉动滚动条翻页加载数据
     **/
    $scope.scrollPage = function () {
        //当前页码
        $scope.currentPage += 1;
        if ($scope.currentPage > $scope.pageCount) {
            return;
        }
        $scope.loadMyMessList();
    }
    /**
     * 初始化我的订单
     **/
    $scope.changeTab = function (state) {
        $scope.currentState = state;
        $scope.messList = [];
        $scope.currentPage = 1;
        $scope.loadMyMessList();
    }


    /**
     * 选择消息
     **/
    $scope.selectMessEvent = function (mess) {
        for (var i = 0; i < $scope.messList.length; i++) {
            $scope.messList[i].isSelect = false;
        }
        mess.isSelect = true;
        $scope.selectMess = mess;
        $scope.MessShow = true;
        $scope.changeState(mess);
    }
    /**
     * 修改状态为已读
     **/
    $scope.changeState = function (mess) {
        if (mess.state == "未读") {
            //查询订单明细
            var url = "doChowhoundAction_insertMessUser.action";
            var param = "erCookbookMessage.content=" + mess.id +
                "&erCookbookMessage.cookbookId=" + mess.cookbookId +
                "&erCookbookMessage.id=" + mess.operatorId;
            $http.post(url, param).success(function (data, status, headers, config) {
                if (data.success) {
                    mess.state = "已读"
                } else {
                    $scope.AlertMessage(data.errMsg, '错误');
                }
            });
        }
    }
    $scope.loadMyMessList();
}]);