app.controller('takeoutBillCtrl', ['$location', '$rootScope', '$scope',
    '$http', '$timeout', '$interval',
    function ($location, $rootScope, $scope, $http, $timeout, $interval) {
        $rootScope.showMenu = false;
        // 需要在登录进入系统后验证当前用户是否有未送达的单据,如果有,在$rootscope中维护某一变量值以便阻止用户抢单
        $scope.list = [];
        // 送单员有未送达单据,默认为true,需求变更,不再限制送单员抢单数量
        // $scope.takeouCheck=true;
        $scope.sendStatus = 0;
        $scope.checkStatus = 1;
        // 订单详情页面默认隐藏
        $scope.takeoutDetails = true;
        // 抢单确认页面默认隐藏
        $scope.takeoutAffirm = true;
        // 配置页面属性
        $scope.page = 1;
        $scope.pageSize = 6;
        // 查询未派送状态的外卖订单
        $scope.getMyTakeOutBills = function (sendStatus, page, pageSize) {
            var url = "doErTakeoutDetailAction_getErTakeoutDetailsInDateForSearchPaginated.action";
            var params = {};
            params.start = (page - 1) * pageSize;
            params.limit = pageSize;
            params.erTakeoutDetailSearch = {};
            params.erTakeoutDetailSearch.sendStatus = sendStatus;
            params.sort = "songcanTime";
            params.dir = "asc";
            $http.post(url, params).success(
                function (data, status, headers, config) {
                    if (data.success) {
                        $scope.total = data.totalCount;
                        if (page * pageSize < $scope.total) {
                            $scope.more = true;
                        } else {
                            $scope.more = false;
                        }
                        for (var i = 0; i < data.list.length; i++) {
                            if (data.list[i].songcanTime) {
                                data.list[i].sendTime = data.list[i].songcanTime.time;
                            } else {
                                data.list[i].sendTime = data.list[i].createTime.time + (30 * 60 * 1000);
                            }
                            data.list[i].listNo = i + 1 + ($scope.page - 1) * $scope.pageSize;//订单序号
                            $scope.list.push(data.list[i]);
                        }

                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }
                });
        }

        // 查看用户状态,若用户名下有尚未送达外卖,则不允许抢单,需求变更,不再限制送单员抢单数量
        // $scope.checkTakeoutId = function(){
        // var url =
        // "doErTakeoutDetailAction_getErTakeoutDetailsForSearchPaginated.action";
        // var params = {};
        // params.start = 0;
        // params.limit = $scope.pageSize;
        // params.erTakeoutDetailSearch = {
        // takeoutId : $scope.takeoutId,sendStatus : $scope.checkStatus
        // }
        // $http.post(url, params).success(
        // function(data, status, headers, config) {
        // if (data.success) {
        // if(data.list.length>=1){
        // $scope.takeouCheck=false;
        // return;
        // }else{
        // $scope.takeouCheck=true;
        // return;
        // }
        // } else {
        // $scope.AlertMessage(data.errMsg, '错误');
        // }
        // });
        // }

        // 点击对应div后展开订单详情页面
        $scope.getTakeoutDetails = function (x) {
            $scope.takeoutDetails = false;
            var url = "doErTakeoutDetailAction_getErTakeoutDetailsForSearchPaginated.action";
            var params = {};
            params.start = 0;
            params.limit = 4;
            params.erTakeoutDetailSearch = {};
            params.erTakeoutDetailSearch.id = x.id;
            $http.post(url, params).success(
                function (data, status, headers, config) {
                    if (data.success) {
                        data.list[0].sendTime = data.list[0].songcanTime.time;
                        $scope.detailed = data.list[0];
                        $scope.lists = data.list[0].takeoutDetail.split(";");
                        $scope.detailList = [];
                        for (var i = 0; i < $scope.lists.length; i++) {
                            $scope.detailList.push({
                                'name': $scope.lists[i].split("X")[0],
                                'num': $scope.lists[i].split("X")[1]
                            });
                        }
                    } else {
                        $scope.AlertMessage(data.errMsg, '错误');
                    }

                });
        };
        // 关闭订单详情页面
        $scope.closeTakeoutDetails = function ($event) {
            $event.stopPropagation();
            $scope.takeoutDetails = true;
        }
        // 订单详情页面防冒泡
        $scope.fangMaoPao = function ($event) {
            $event.stopPropagation();
        }

        // 页面定时刷新
        $interval(setTimeout($scope.getMyTakeOutBills($scope.sendStatus,
            $scope.page, $scope.pageSize), 200), 60000);
        // 点击加载更多抢单
        $scope.findMore = function () {
            $scope.page++;
            setTimeout($scope.getMyTakeOutBills($scope.sendStatus,
                $scope.page, $scope.pageSize), 200);
            if ($scope.limit < $scope.total) {
                $scope.more = true;
            } else {
                $scope.more = false;
            }
        }
        // 由抢单界面跳转至抢单确认界面
        $scope.toTakeoutAffirm = function ($event) {
            $scope.takeoutAffirm = false;
            $scope.takeoutData = this.x.id;
            $event.stopPropagation();
        }
        // 由订单明细界面跳转至抢单确认界面
        $scope.toTakeOutAffirm = function ($event) {
            $scope.takeoutAffirm = false;
            $scope.takeoutData = this.detailed.id;
            $event.stopPropagation();
        }
        // 隐藏抢单确认页面
        $scope.closeTakeoutAffirm = function () {
            $scope.takeoutAffirm = true;
        }
        // 确认抢单
        $scope.scrambleTakeOutBill = function () {
            // 更改抢单状态
            var url = "doErTakeoutDetailAction_updateErTakeoutDetail.action";
            var params = {};
            params.erTakeoutDetail = {};
            params.erTakeoutDetail.id = $scope.takeoutData;
            params.erTakeoutDetail.sendStatus = "1";
            params.erTakeoutDetail.takeoutId = $scope.getLoginUser().userId;
            params.erTakeoutDetail.takeoutName = $scope.getLoginUser().userName;
            if ($scope.getLoginUser().telephone) {
                params.erTakeoutDetail.takeoutTelephone = $scope.getLoginUser().telephone;
            } else {
                params.erTakeoutDetail.takeoutTelephone = '';
            }
            params.erTakeoutDetail.saveOperLog = false;
            $http.post(url, params).success(function (data) {
                if (data.success) {
                    $scope.AlertMessage("抢单成功!", '');
                    // 跳转至订单页面
                    $location.path("app/takeout");
                    // 刷新当前页面,拟用于测试
                    // $scope.$state.go('app.takeoutBill',{},{reload:true}); 
                }
            })
        }
        // 用户名下有未送达外卖,点击抢单时给予提示弹窗,需求变更,不再限制送单员抢单数量
        // $scope.unableTakeOutBill = function(){
        // alert("您尚有未送达订单,请派送完成后在进行抢单")
        // //弹窗提示后直接跳转到我的订单页面
        // $location.path("app/takeout");
        // }
        // 通过路由转至我的订单页面
        $scope.toTakeout = function () {
            $location.path("app/takeout");
        }
        // 通过路由转至我的结算页面
        $scope.toBalance = function () {
            $location.path("app/balance");
        }
    }]);
