app.controller('takeoutCtrl', ['$location', '$rootScope', '$scope', '$http', '$timeout', function ($location, $rootScope, $scope, $http, $timeout) {
    //页面初始化
    $scope.init = function () {
        $scope.page = 1;
        $scope.pageSize = 6;
        $scope.showMore = true;//加载更多开关
        $scope.sendStatus == 12;//查询已派送未派送
    }
    $scope.init();

    /**
     * 加载订单
     */
    $scope.loadMyTakeoutDetail = function () {
        var url = "doErTakeoutDetailAction_getErTakeoutDetailsForSearchPaginated.action";
        var params = {};
        params.start = ($scope.page - 1) * $scope.pageSize;
        params.limit = $scope.pageSize;
        params.erTakeoutDetailSearch = {};
        params.erTakeoutDetailSearch.takeoutId = $scope.getLoginUser().userId;
        params.sort = "songcanTime";
        params.dir = "desc";
        if ($scope.sendStatus == 12) {
            params.erTakeoutDetailSearch.sendStatusArray = [1, 2];
        } else {
            params.erTakeoutDetailSearch.sendStatus = $scope.sendStatus;
        }
        $http.post(url, params).success(function (data) {
            if (data.success) {
                //不是第一次加载
                if ($scope.takeoutList) {
                    for (var i = 0; i < data.list.length; i++) {
                        $scope.takeoutList.push(data.list[i]);
                    }
                } else {//第一次加载
                    $scope.takeoutList = data.list;
                }
                //总数
                $scope.totalCount = data.totalCount;
                //加载更多是否显示
                if ($scope.totalCount <= $scope.page * $scope.pageSize) {
                    $scope.showMore = false;
                }
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    };
    $scope.loadMyTakeoutDetail();
    /**
     * 加载更多
     */
    $scope.loadMore = function () {
        $scope.page++;
        $scope.loadMyTakeoutDetail()
    }
    /**
     * 确认送达
     */
    $scope.openSended = function (x) {
        $scope.erTakeoutDetail = x;
        $scope.showSend = true;
    }
    /**
     * 关闭确认送达
     */
    $scope.closeSended = function () {
        $scope.showSend = false;
    }
    /**
     * 确认送达空白处
     */
    $scope.noHappened = function ($event) {
        $event.preventDefault();
        $event.stopPropagation();
    }
    /**
     * 确认送达
     */
    $scope.send = function () {
        // 更改派送状态
        var url = "doErTakeoutDetailAction_updateErTakeoutDetail.action";
        var params = {};
        params.erTakeoutDetail = {};
        params.erTakeoutDetail.id = $scope.erTakeoutDetail.id;
        params.erTakeoutDetail.sendStatus = "2";
        params.erTakeoutDetail.orderNum = $scope.erTakeoutDetail.orderNum;
        $http.post(url, params).success(function (data) {
            if (data.success) {
                // 确认送达页面关闭
                $scope.closeSended();
                // 刷新页面
                $scope.$state.go('app.takeout', {}, {
                    reload: true
                });
            } else {
                $scope.AlertMessage(data.errMsg, '错误');
            }
        });
    }
    /**
     * 点击全部订单 展示已派送 未派送按钮
     */
    $scope.showXlcd = function () {
        $scope.showjt = !$scope.showjt;
        $scope.xlcdkg = !$scope.xlcdkg;
    }
    /**
     * 点击已派送
     */
    $scope.yiPaiSong = function () {
        $scope.takeoutList = null;
        $scope.init();
        $scope.sendStatus = "2";
        $scope.loadMyTakeoutDetail();
        $scope.xlcdkg = false;
    }
    /**
     * 点击未派送
     */
    $scope.weiPaiSong = function () {
        $scope.takeoutList = null;
        $scope.init();
        $scope.sendStatus = "1";
        $scope.loadMyTakeoutDetail();
        $scope.xlcdkg = false;
    }
    /**
     * 我的抢单
     */
    $scope.myTakeoutDetailBill = function () {
        $location.path("app/takeoutBill");
    }
    /**
     * 我的结算
     */
    $scope.showBalance = function () {
        $location.path("app/balance");
    }

}]);