/**一键清除**/
angular.module('app')
    .directive('oneKeyClearInput', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            link: function ($scope, iElm, iAttrs, controller) {
                var btn = angular.element('<i class="icon-remove one-key-clear"></i>'),
                    handleId = iElm.html().length
                    + iElm.attr('class') ? iElm.attr('class').split(' ').join('') : ''
                        + 'oneKey',
                    iconSize = 18,  //set the size for icon
                    touchScope = 6,  //set the touch scope for icon button
                    container = null;

                function init() {
                    // get parent
                    container = iElm.offsetParent();

                    // calc position
                    var top = iElm.offset().top + iElm.outerHeight() / 2
                        - iconSize / 2 - container.offset().top
                        - touchScope * 1.4,
                        left = iElm.offset().left + iElm.outerWidth()
                            - iconSize - touchScope - container.offset().left - 5;

                    // set styles
                    btn.css({
                        'position': 'absolute', 'top': top
                        , 'left': left, 'fontSize': iconSize
                        , 'color': '#ccc', 'padding': touchScope
                        , 'display': 'none', 'zIndex': 1000
                    });

                    // push to dom
                    container.find('.one-key-clear').remove();
                    container.append(btn);

                    // bind event
                    if (container.is('label')) {
                        container.click(function (e) {
                            var x = e.clientX,
                                y = e.clientY,
                                top = btn.offset().top;
                            left = btn.offset().left;

                            // check touch scope for label
                            // because the click event of object can not be trigger
                            // when the obj is belong to the label
                            if (x > left - touchScope
                                && x < left + iconSize + touchScope
                                && y > top - touchScope
                                && y < top + iconSize + touchScope) {

                                $scope.$apply(iAttrs['ngModel'] + '=null');
                            }
                        });
                    }
                    btn.click(function (e) {
                        $scope.$apply(iAttrs['ngModel'] + '=null');
                        e.stopPropagation();
                    });
                }

                $scope.checkVal = function () {
                    return $scope.$eval(iAttrs['ngModel']);
                }

                $scope.$watch('checkVal()', function (data) {
                    if (data) {
                        if (!container) {
                            init();
                        }
                        btn.show();
                    } else
                        btn.hide();
                });
            }
        };
    }]);
/**样式切换**/
angular.module('app')
    .directive('uiToggleClass', ['$timeout', '$document', function ($timeout, $document) {
        return {
            restrict: 'AC',
            link: function (scope, el, attr) {
                el.on('click', function (e) {
                    e.preventDefault();
                    var classes = attr.uiToggleClass.split(','),
                        targets = (attr.target && attr.target.split(',')) || Array(el),
                        key = 0;
                    angular.forEach(classes, function (_class) {
                        var target = targets[(targets.length && key)];
                        (_class.indexOf('*') !== -1) && magic(_class, target);
                        $(target).toggleClass(_class);
                        key++;
                    });
                    $(el).toggleClass('active');

                    function magic(_class, target) {
                        var patt = new RegExp('\\s' +
                            _class.replace(/\*/g, '[A-Za-z0-9-_]+').split(' ').join('\\s|\\s') +
                            '\\s', 'g');
                        var cn = ' ' + $(target)[0].className + ' ';
                        while (patt.test(cn)) {
                            cn = cn.replace(patt, ' ');
                        }
                        $(target)[0].className = $.trim(cn);
                    }
                });
            }
        };
    }]);
/**滑动更新**/
angular.module('app')
    .directive('infiniteScroll', [
        '$rootScope', '$window', '$timeout', function ($rootScope, $window, $timeout) {
            return {
                link: function (scope, elem, attrs) {
                    var checkWhenEnabled, handler, scrollDistance, scrollEnabled;
                    $window = angular.element($window);
                    scrollDistance = 0;
                    if (attrs.infiniteScrollDistance != null) {
                        scope.$watch(attrs.infiniteScrollDistance, function (value) {
                            return scrollDistance = parseInt(value, 10);
                        });
                    }
                    scrollEnabled = true;
                    checkWhenEnabled = false;
                    if (attrs.infiniteScrollDisabled != null) {
                        scope.$watch(attrs.infiniteScrollDisabled, function (value) {
                            scrollEnabled = !value;
                            if (scrollEnabled && checkWhenEnabled) {
                                checkWhenEnabled = false;
                                return handler();
                            }
                        });
                    }
                    handler = function () {
                        var elementBottom, remaining, shouldScroll, windowBottom;
                        windowBottom = $window.height() + $window.scrollTop();
                        elementBottom = elem.offset().top + elem.height();
                        remaining = elementBottom - windowBottom;
                        shouldScroll = remaining <= $window.height() * scrollDistance;
                        if (shouldScroll && scrollEnabled) {
                            if ($rootScope.$$phase) {
                                return scope.$eval(attrs.infiniteScroll);
                            } else {
                                return scope.$apply(attrs.infiniteScroll);
                            }
                        } else if (shouldScroll) {
                            return checkWhenEnabled = true;
                        }
                    };
                    $window.on('scroll', handler);
                    scope.$on('$destroy', function () {
                        return $window.off('scroll', handler);
                    });
                    return $timeout((function () {
                        if (attrs.infiniteScrollImmediateCheck) {
                            if (scope.$eval(attrs.infiniteScrollImmediateCheck)) {
                                return handler();
                            }
                        } else {
                            return handler();
                        }
                    }), 0);
                }
            };
        }
    ]);